SystemOrganization addCategory: #'Scribo-Blog'!
SystemOrganization addCategory: #'Scribo-Components'!
SystemOrganization addCategory: #'Scribo-Core'!
SystemOrganization addCategory: #'Scribo-Forum'!
SystemOrganization addCategory: #'Scribo-RSS'!
SystemOrganization addCategory: #'Scribo-Sites'!
SystemOrganization addCategory: #'Scribo-Tests'!
SystemOrganization addCategory: #'Scribo-Wiki'!

!String methodsFor: '*Scribo-Core' stamp: 'JM 4/22/2007 18:06'!
asWikiExceptLinksHtml
	"render this string in Wiki format (leave links in square brackets intact) and return Html"
	^WikiRender exceptLinksFrom: self! !

!String methodsFor: '*Scribo-Core' stamp: 'JM 4/22/2007 18:06'!
asWikiHtml
	"render this string in Wiki format and return Html"
	^WikiRender from: self! !

!String methodsFor: '*Scribo-Core' stamp: 'JM 4/22/2007 18:06'!
asWikiLinksOnlyHtml
	"render this string in Wiki format (links in square brackets only) and return Html"
	^WikiRender linksOnlyFrom: self! !

!String methodsFor: '*Scribo-Core' stamp: 'np 1/23/2008 09:53'!
containsSubstring: aString
	^(self 
		indexOfSubCollection: aString 
		startingAt: 1) > 0! !

!String methodsFor: '*Scribo-Core' stamp: 'np 3/11/2008 13:05'!
replaceSpecialCharacters
	|str|
	str := self copy.
	str do: [:ch | |ascii|
		ascii := ch asInteger.
		((ascii  >= 65 and: [ ascii <= 90 ]) or: [
			( ascii >= 97 and: [ ascii <= 122 ]) or: [ch isDigit] or: [ch = $/]])
			ifFalse: [str replaceAll: ch with: $-]].
	^str! !

!String methodsFor: '*Scribo-Core' stamp: 'np 3/28/2008 22:10'!
trimBlanksAtBeginAndEnd
	"'   hello     ' trimFirstAndLastBlanks"
	(self beginsWith: ' ') ifTrue: [^self allButFirst trimBlanksAtBeginAndEnd].
	(self endsWith: ' ') ifTrue: [^self allButLast trimBlanksAtBeginAndEnd].
	^self! !

!AIDASite methodsFor: '*Scribo-Blog' stamp: 'np 2/13/2008 01:26'!
blog
	^self repository blog! !

!AIDASite methodsFor: '*Scribo-Blog' stamp: 'np 8/19/2008 17:12'!
defaultUserService
	"which will be accessible with url: http:/hostname/ "
	^self blog! !

!AIDASite methodsFor: '*Scribo-Forum' stamp: 'np 2/13/2008 01:27'!
forum
	^self repository forum! !

!AIDASite methodsFor: '*Scribo-Core' stamp: 'np 1/23/2008 09:26'!
repository
	^self userServices 
		at: #Repository
		ifAbsent: 
			[self addUserService: (Repository newOnSite: self) named: #Repository.
			^self repository].! !

!AIDASite methodsFor: '*Scribo-Sites' stamp: 'np 2/13/2008 01:27'!
siteContent
	^self repository siteContent! !

!AIDASite methodsFor: '*Scribo-Wiki' stamp: 'np 2/13/2008 01:27'!
wiki
	^self repository wiki! !

FileProxy subclass: #AttachmentProxy
	instanceVariableNames: 'attachment lock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scribo-Core'!

!AttachmentProxy class methodsFor: 'instance creation' stamp: 'np 6/21/2008 19:37'!
newFor: anAttachment onSite: anAIDASite
	^(super from:  anAttachment filePath onSite: anAIDASite)
		attachment: anAttachment;
		registerInUrlResolver;
		yourself! !

!AttachmentProxy methodsFor: 'locking' stamp: 'np 1/20/2008 09:25'!
aidaCanBeLocked
	"can we get an exclusive lock on that object (not already locked)?"
	^false! !

!AttachmentProxy methodsFor: 'locking' stamp: 'np 1/20/2008 09:25'!
aidaIsLocked
	"is object locked exclusively?"
	^self lock notNil! !

!AttachmentProxy methodsFor: 'locking' stamp: 'np 1/20/2008 09:26'!
aidaLock
	"get an exclusive lock on that object. Until unlocked, noon else can get that lock. Return false if already locked, true if successfull"
	self aidaCanBeLocked ifTrue: [self lock: SpTimestamp now. ^true].
	^false! !

!AttachmentProxy methodsFor: 'locking' stamp: 'np 1/20/2008 09:26'!
aidaUnlock
	"release an exclusive lock if any"	
	self lock: nil.
	^true! !

!AttachmentProxy methodsFor: 'accessing' stamp: 'np 1/20/2008 09:25'!
attachment
	^attachment! !

!AttachmentProxy methodsFor: 'accessing' stamp: 'np 1/20/2008 09:25'!
attachment: anAttachment
	attachment := anAttachment! !

!AttachmentProxy methodsFor: 'private' stamp: 'np 1/20/2008 09:26'!
checkFilePath
	"is url without spaces but documentDirectory still have it? 	
	Replace those spaces with '-' !!"
	(self attachment isNil or: [self attachment parent isNil]) ifTrue: [^false].
	(self attachment parent otherAt: #documentDirectory) isNil ifTrue: [^false].
	(self attachment parent documentDirectory includes: $ ) 
		ifTrue: [self attachment parent allVersions do:
			[:each | each checkDocumentDirectory] ] "this will replace spaces in directory"
		ifFalse: 	[(self filename head includes: $ ) ifFalse: [^false] ]. "everything ok"
	self filename: (self filename head copyReplaceAll: ' ' with: '-'), 
		(String with: self filename separator), self filename tail.
	^true

"AttachmentProxy allInstances select: [:each | each checkFilePath] "
"Document allInstances select: [:each | 
	(each otherAt: #documentDirectory) notNil and: [each documentDirectory includes: $ ] ] "! !

!AttachmentProxy methodsFor: 'private' stamp: 'np 1/20/2008 09:27'!
lock
	^lock! !

!AttachmentProxy methodsFor: 'private' stamp: 'np 1/20/2008 09:27'!
lock: aTimestampOrNil
	lock := aTimestampOrNil! !

!AttachmentProxy methodsFor: 'printing' stamp: 'np 1/20/2008 09:26'!
printString
	^'anAttachmentProxy
	url: ', self attachment url, '
	file: ', self filename asString, '
	doc: ', self attachment parent id, ' ', self attachment parent title! !

!AttachmentProxy methodsFor: 'private' stamp: 'np 1/20/2008 09:27'!
registerInUrlResolver
	self site urlResolver
		defaultURL: self attachment url forObject: self! !

TestCase subclass: #AIDASiteTest
	instanceVariableNames: 'site'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scribo-Tests'!

TestCase subclass: #DocumentTest
	instanceVariableNames: 'document person1 person2 user1 user2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scribo-Tests'!

WebTabs subclass: #WikiPageTabs
	instanceVariableNames: 'pages'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scribo-Wiki'!

!WikiPageTabs methodsFor: 'accessing' stamp: 'np 1/21/2008 10:51'!
addFirstPageWithDescription: aString
	| firstPage assoc firstPageTitle |
	firstPage := self app observee parent defaultPage.
	assoc := self app observee parent pages associations detect: [:each | each value == firstPage].
	firstPageTitle := assoc key.
	self addPage: firstPageTitle description: aString! !

!WikiPageTabs methodsFor: 'accessing' stamp: 'np 1/21/2008 10:51'!
addPage: aNameString description: aTabNameString
	"aNameString is original/first title of page, not changed one!!"
	| pageTitle |
	(self pages contains: [:each | each key == aNameString]) ifTrue: [^nil]. 
	pageTitle := (self app observee parent pageTitled: aNameString).
	pageTitle := pageTitle notNil ifTrue: [pageTitle title] ifFalse: [''].
	self pages add:
		(Association key: aNameString value: (Array with: aTabNameString with: pageTitle ))! !

!WikiPageTabs methodsFor: 'initialize-release' stamp: 'np 1/21/2008 10:51'!
initPages
	pages := OrderedCollection new.! !

!WikiPageTabs methodsFor: 'initialize-release' stamp: 'np 1/21/2008 10:51'!
initialize
	super initialize.
	self initPages.
	^self! !

!WikiPageTabs methodsFor: 'accessing' stamp: 'np 1/21/2008 10:52'!
linkToWikiPage: aTitleString text: aString
	| page titleString |
	titleString := aTitleString "AIDASite convertFromWeb: aTitleString on: self app session".
	page := self app observee parent pageTitled: titleString.
	page notNil ifTrue: [^WebLink text: aString linkTo: page ].
	^(WebLink text: aString linkTo: self app observee parent view: #add )  "new page"
		parameter: 'title' value: (AIDASite convertToWebString: aTitleString)! !

!WikiPageTabs methodsFor: 'private' stamp: 'np 1/21/2008 10:52'!
pages
	^pages! !

!WikiPageTabs methodsFor: 'accessing' stamp: 'np 1/21/2008 10:52'!
prepareTabsList
	| inx pageTitle tabTitle linkText |
	inx := 1. 
	pageTitle := self app observee title ensureUnicodeSloveneChars.
	self pages do: [:each | 
		tabTitle := each key ensureUnicodeSloveneChars.
		linkText := each value first.
		(pageTitle = tabTitle 
				or: [pageTitle asSloveneWithoutCircumflexes = tabTitle asSloveneWithoutCircumflexes
				or: [pageTitle = each value last ensureUnicodeSloveneChars"new page title"] ])
		 	ifTrue: [self addTextBold: each value first. self selected: inx]
			ifFalse: [self add: (self linkToWikiPage: each key text: linkText)].
		inx := inx + 1]! !

!WikiPageTabs methodsFor: 'accessing' stamp: 'janko 7/18/2008 20:51'!
printHTMLPageOn: aStream for: aRequest on: aSession
	self prepareTabsList.
	^ super 
		printHTMLPageOn: aStream for: aRequest on: aSession! !

!WikiPageTabs methodsFor: 'accessing' stamp: 'janko 7/18/2008 20:13'!
printHTMLPageOn: aStream on: aSession 
	self prepareTabsList.
	^ super 
		printHTMLPageOn: aStream
		on: aSession! !

WebFrameApp subclass: #WebForumApp
	instanceVariableNames: 'newResponse lastResponse'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scribo-Forum'!

!WebForumApp methodsFor: 'actions' stamp: 'np 1/30/2008 16:09'!
actionAdd
	self forum addDiscussionsResponse: self newResponse user: self session user.
	self redirectTo: self newResponse.! !

!WebForumApp methodsFor: 'actions' stamp: 'np 1/30/2008 16:09'!
actionIntro
	self newView: #main! !

!WebForumApp methodsFor: 'accessing' stamp: 'np 1/30/2008 16:08'!
forum
	^self observee! !

!WebForumApp methodsFor: 'accessing' stamp: 'np 1/30/2008 16:08'!
lastResponse
	^newResponse! !

!WebForumApp methodsFor: 'accessing' stamp: 'np 1/30/2008 16:08'!
lastResponse: aLastResponse
	lastResponse := aLastResponse.! !

!WebForumApp methodsFor: 'accessing' stamp: 'np 1/30/2008 16:08'!
newResponse
	newResponse isNil
		ifTrue: [self newResponse: WebForumResponse new].
	^newResponse! !

!WebForumApp methodsFor: 'accessing' stamp: 'np 1/30/2008 16:09'!
newResponse: aNewResponse
	newResponse := aNewResponse.! !

!WebForumApp methodsFor: 'printing-elements' stamp: 'np 1/30/2008 16:10'!
newestElement
	| element |
	element := WebElement new.
	self observee newest do: [:response |
		element 
			addText: ('<b>', response discussion title, ': </b>');
			addLinkTo: response text: 
				((response title = '') ifTrue: ['-- no title --'] ifFalse: [response title]);  
			"addText: (', <font size=-2>, ');"
			addText: (', ', response author);
			addText: (', <font size=-2>', (self printStamp: response timestamp), '</font>');
			addBreak].

	element addGif: #redPixelGif size: 10@10.
	element addGif: #adobeLeafGif.

	^element! !

!WebForumApp methodsFor: 'printing-elements' stamp: 'np 1/30/2008 16:10'!
statisticsElement
	| element |
	element := WebElement new.
	element 
		addText: 'visits: ';
		addText: self visitsCount printDotString attributes: #bold"; addText: ', '".
"		add: (self statisticsPageLink text: 'statistics'). "
	^element! !

!WebForumApp methodsFor: 'printing' stamp: 'np 1/30/2008 16:10'!
viewAdd
	| element |
	self newResponse: WebForumResponse new.
	self clear.
	self	title: 'Add a new discussion'.
	element := WebElement new.
	element table width: self pageContentWidth.
	element row color: self tableHeaderColor.
	element cell colspan: 4; addText: self title header: 3.
	element newRow.
	element cell add: (self smallText: 'Title: ' attributes: #bold).
	element newCell colspan:3;
		add: (WebInputField new size: 50; aspect: #title for: self newResponse).
	element newRow.
	element cell add: (self smallText: 'Author: ' attributes: #bold).
	element newCell
		add: (WebInputField new size: 20; aspect: #author for: self newResponse).
	element newCell add: (self smallText: 'E-mail: ' attributes: #bold).
	element newCell
		add: (WebInputField new size: 20; aspect: #authorsEmail for: self newResponse).
	element newRow.
	element cell add: (self smallText: 'Text: ' attributes: #bold).
	element newCell colspan: 3;
		add: (WebTextArea new name: 'info'; size: 50@10; 
			aspect: #body for: self newResponse).

	"Akcijske tipke"
	element newRow color: self tableHeaderColor.
	element cell  align: #center; colspan: 4;
		add: (WebButton new text: 'Add'; type: #submit ).

	^self pageFrameWith: element title: self title.! !

!WebForumApp methodsFor: 'printing' stamp: 'np 1/30/2008 16:10'!
viewIntro
	| element |
	self clear.
	self	title: 'Introduction to discussions'.
	element := WebElement new.
	element table width: self pageContentWidth.
	element row color: self tableHeaderColor.
	element cell addText: self title.
	element newRow.
	element cell 
		add: (WebTextArea new name: 'info'; size: 50@15;
				aspect: #introduction for: self observee).
	element newRow.
	element cell
		add: (WebButton new text: 'Zapisi'; type: #submit ).

	^self pageFrameWith: element title: self title.! !

!WebForumApp methodsFor: 'printing' stamp: 'np 1/30/2008 16:10'!
viewMain
	| element nr |
	self clear.
	self title: 'AIDA/Web Smalltalk Web Application Server - Demo'.
	element := WebElement new.
	element table width: self pageContentWidth; cellSpacing: 0; cellPadding: 0.
      element cell color: self tableHeaderColor.
	element cell colspan: 4; 
		addBreak;
		addText: ('<font face=helvetica><b>', self title, '</b></font>');
		addBreak; addNbSp.
	element newRow. element cell addBreak. element newRow.
	element cell colspan: 4; 
		add: (self smallText: (self addBreaksTo: self observee introduction asWikiHtml)).
	element newRow. element cell addBreak. element newRow.

	nr := 1.
	self observee forum do: [ :article |
		element row color: self tableHeaderColor.
		element cell width: 15; 
			add: (self smallText: (nr printString, '.') attributes: #bold).
		element newCell 
			addText: '<font face="helvetica" size=-1>';
			addLinkTo: article text: 
				((article title = '')
					ifTrue: ['<b>-- no title --</b>'] 
					ifFalse: ['<b>', article title, '</b>']);  
			addText: '<font size=-2>';
			addText: (', ');
			addText: (article author)  "attributes: #italic";
			addText: (', ', article date shortPrintSloString)  "attributes: #italic"; 
			addText: (' (', article responseCount printDotString, ' responses)');
			addText: '</font></font>'.
		element newRow.
		element cell addBreak.
		element newCell	
			add: (self smallText: article body).
		"element newRow. element cell addBreak." element newRow.
		nr := nr + 1].
	element cell colspan: 2; addRulerSize: 1.
	element newRow.
	element cell colspan: 2;
		add: (self smallText: 'Fresh responses:' attributes: #bold).
	element newRow.
	element newCell 
		addText: '<font face="helvetica" size=-1>';
		add: self newestElement;
		addText: '</font>'.
	element newRow.
	element cell colspan: 2; addRulerSize: 1.
	element newRow.
	element cell colspan: 2; align: #center;
		addText: '<font face="helvetica" size=-1>';
		add: self statisticsElement;
		addText: '</font>'.
	element newRow.
	self user isGuest not ifTrue: 
		[element cell colspan: 2;
			addLinkTo: self observee text: 'Open new discusion' 
				parameter: 'view' value: 'add';
			addNbSp: 2;
			addLinkTo: self observee text: 'Introduction' 
				parameter: 'view' value: 'intro'].

	^self pageFrameWith: element title: self title.! !

WebFrameApp subclass: #WebForumResponseApp
	instanceVariableNames: 'newResponse'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scribo-Forum'!

!WebForumResponseApp methodsFor: 'actions' stamp: 'np 1/30/2008 16:16'!
actionAdd
	self observee addDiscussionsResponse: self newResponse user: self session user.
	self redirectTo: self newResponse.! !

!WebForumResponseApp methodsFor: 'actions' stamp: 'np 1/30/2008 16:16'!
actionDelete
	self observee parent isNil ifTrue: [^self redirectTo: self site forum].
	self observee parent deleteDiscussionsResponse: self observee.
	self redirectTo: self observee parent.! !

!WebForumResponseApp methodsFor: 'actions' stamp: 'np 1/30/2008 16:16'!
actionUpdate
	self newView: #main! !

!WebForumResponseApp methodsFor: 'printing-elements' stamp: 'np 1/30/2008 16:30'!
adminSectionFor: aSession

	"it returns links to the form view of this page, etc. element is generated only if user has rights to do something here"

	| element |
	element := WebElement new.
	self user isGuest not ifTrue: 
		[element
			addLinkTo: self observee text: '<b>Add your response </b>' 
				parameter: 'view' value: 'add'].
	self isUpdateAllowed ifTrue:
		[element addLinkTo: self observee text: '<b>Update </b>' 
			parameter: 'view' value: 'update'].
	self isDeleteAllowed ifTrue:
		[element addLinkTo: self observee text: '<b>Delete </b>'
			parameter: 'view' value: 'delete'].
	^element! !

!WebForumResponseApp methodsFor: 'printing-elements' stamp: 'np 1/30/2008 16:17'!
hierarchyElement

	| element firstOne allParents |
	element := WebElement new.
	element 
		addText: '<font face="helvetica" size=-2><b>';
		addText: '> ';
		addLinkTo: '/' text: 'Home';
		addText: ' > ';
		addLinkTo: self site forum text: 'Discussions'.
	allParents := self observee allParents add: self observee; yourself.
	firstOne :=  allParents size > 1 ifTrue: [allParents at: 2] ifFalse: [allParents first].
	(firstOne == self observee) 
		ifTrue: [element addText: (' > ', self responseTitle, '</b></font>'). ^element]
		ifFalse: 	[element addText: ' > '; 
			addLinkTo: firstOne text: (self responseTitleFor: firstOne)].
	1 to: (self observee allParents size - 2 max: 0) do: [:inx | 
		element
			addText: ' '; 
			addLinkTo: (self observee allParents at: inx+2) text: '>';
			addText: ' '].
	element	addText: (' > ', self responseTitle).
	^element! !

!WebForumResponseApp methodsFor: 'testing' stamp: 'np 1/30/2008 16:18'!
isDeleteAllowed
	^self session adminAllowed! !

!WebForumResponseApp methodsFor: 'testing' stamp: 'np 1/30/2008 16:18'!
isUpdateAllowed
	(self session user == self observee user and: [self observee responses isEmpty])
		ifTrue: [^true].
	^self session adminAllowed! !

!WebForumResponseApp methodsFor: 'accessing' stamp: 'np 1/30/2008 16:16'!
newResponse
	^newResponse! !

!WebForumResponseApp methodsFor: 'accessing' stamp: 'np 1/30/2008 16:16'!
newResponse: aWebDiscussionsResponse
	newResponse := aWebDiscussionsResponse.! !

!WebForumResponseApp methodsFor: 'printing-elements' stamp: 'np 1/30/2008 16:18'!
parentElement
	| element |
	element := WebElement new.
	self observee allParents do: [:parentResponse |
		element 
			addText: ('<font size=-1>');
			addText: '<dl>'; 
			addLinkTo: parentResponse text: 
				((parentResponse title = '') ifTrue: ['-- no title --'] ifFalse: [parentResponse title]); 
			addText: (', ');
			addText: ('<font size=-1>', parentResponse author, '</font>')  attributes: #italic;
			addText: (' (', parentResponse date printSloString, ')')  attributes: #italic;
			addText: ('</font>')].
	self observee allParents size timesRepeat: [element addText: '</dl>'].
	^element! !

!WebForumResponseApp methodsFor: 'printing-elements' stamp: 'np 1/30/2008 16:18'!
responseTitle
	^self responseTitleFor: self observee! !

!WebForumResponseApp methodsFor: 'printing-elements' stamp: 'np 1/30/2008 16:18'!
responseTitleFor: aResponse
	^(aResponse title = '') 
		ifTrue: ['-- no title --'] 
		ifFalse: [aResponse title]! !

!WebForumResponseApp methodsFor: 'printing-elements' stamp: 'np 1/30/2008 16:17'!
responsesElementLevel: aLevelNumber
	| element |
	element := WebElement new.
	(self observee responses isEmpty) ifFalse: 
		[self observee responses do: [:response |
			element addNbSp: (aLevelNumber-1)*3 ; 
			addText: ('<font face=helvetica size=-1>');
			addLinkTo: response text: 
				((response title = '') ifTrue: ['-- no title --'] ifFalse: [response title]);  
			addText: (', ');
			addText: response author;
			addText: (', <font size=-2>', (self printStamp: response timestamp), '</font>');
			addText: ('</font>');
			addBreak.
			element add: ((response webAppFor: self session) 
				responsesElementLevel: aLevelNumber+1).
			]].
	^element! !

!WebForumResponseApp methodsFor: 'printing-elements' stamp: 'np 1/30/2008 16:18'!
statisticsElement
	| element |
	element := WebElement new.
	element 
		addText: 'visits: ';
		addText: self visitsCount printDotString attributes: #bold"; addText: ', '".
"		add: (self statisticsPageLink text: 'statistics'). "
	^element! !

!WebForumResponseApp methodsFor: 'printing-elements' stamp: 'np 1/30/2008 16:18'!
titleElement
	| element |
	element := WebElement new.
	(self observee allParents isEmpty) ifFalse: 
		[element addText: '<h3>Discussion: ', 
		self observee allParents first title, '</h3>'].
	^element! !

!WebForumResponseApp methodsFor: 'printing' stamp: 'np 1/30/2008 16:16'!
viewAdd
	| element |
	self newResponse: WebForumResponse new.
	self newResponse title: self observee title copy.
	self clear.
	self	title: 'New response'.
	element := WebElement new.
	element table width: 450.
	element row color: self tableHeaderColor.
	element cell colspan: 4; addText: self title header: 3.
	element newRow.
	element cell add: (self smallText: 'Title: ' attributes: #bold).
	element newCell colspan:3;
		add: (WebInputField new size: 50; aspect: #title for: self newResponse).
	element newRow.
	element cell add: (self smallText: 'Citat: ' attributes: #bold).
	element newCell colspan: 3; color: self tableRowColor;
		add: (self smallText: self observee htmlBody).
	element newRow.
	element cell add: (self smallText: 'Author: ' attributes: #bold).
	element newCell
		add: (WebInputField new size: 20; aspect: #author for: self newResponse).
	element newCell add: (self smallText: 'E-mail: ' attributes: #bold).
	element newCell
		add: (WebInputField new size: 20; aspect: #authorsEmail for: self newResponse).
	element newRow.
	element cell add: (self smallText: 'Response: ' attributes: #bold).
	element newCell colspan: 3;
		add: (WebTextArea new name: 'info'; size: 50@12; 
			aspect: #body for: self newResponse).

	"Akcijske tipke"
	element newRow color: self tableHeaderColor.
	element cell  align: #center; colspan: 4;
		add: (WebButton new text: 'Add'; type: #submit ).

	self pageFrameWith: element title: self title! !

!WebForumResponseApp methodsFor: 'printing' stamp: 'np 1/30/2008 16:16'!
viewDelete
	| element |
	self clear.
	self	title: 'Delete response'.
	element := WebElement new.
	element table width: 450.
	element row color: self tableHeaderColor.
	element cell addText: self title header: 3.
	element newRow.
	element cell add: (self smallText: 'Are you realy want to delete: ', self observee title, ' ?').
	"Akcijske tipke"
	element newRow color: self tableHeaderColor.
	element cell  align: #center; colspan: 4;
		add: (WebButton new text: 'Delete'; type: #submit ).

	self pageFrameWith: element title: self title.! !

!WebForumResponseApp methodsFor: 'printing' stamp: 'np 1/30/2008 16:17'!
viewMain
	| element |
	self clear.
	self	title: 'Discussion: ', self observee title.
	element := WebElement new.
	element table width: self pageContentWidth.
	element row color: self tableRowColor.
 	element cell add: self hierarchyElement.
	element newRow color: self tableHeaderColor.
 	element cell addText: ('<font face=helvetica size=-1 ><b>', self responseTitle, '</b></font>, ').
	(self observee authorsEmail = '') 
		ifFalse: 
			[element cell add: (self smallText: ('<a href=mailto:', self observee authorsEmail, '>', 
				self observee author, '</a>'))]
		ifTrue: [element cell add: (self smallText: self observee author)].
	element cell add: (self smallText:  
		(', <font size=-2>', (self printStamp: self observee timestamp), '</font>')).
	element newRow.
	element cell
		addBreak;	
		add: (self smallText: self observee htmlBody);
		addBreak; addNbSp.
	element newRow color: self tableRowColor.
	element cell	add: (self adminSectionFor: self session).
	element newRow.
	(self observee responses isEmpty) ifFalse:
		[element cell
			addRulerSize: 1;
			add: (self smallText: '<b>Current responses:</b></font>');
			addBreak;
			add: (self responsesElementLevel: 1).
		element newRow].
	element newRow.
	element cell addRulerSize: 1.
	element newRow.
	element cell align: #center;
		addText: '<font face="helvetica" size=-1>';
		add: self statisticsElement;
		addText: '</font>'.
	^self pageFrameWith: element title: self title! !

!WebForumResponseApp methodsFor: 'printing' stamp: 'np 1/30/2008 16:17'!
viewUpdate
	| element |
	self clear.
	self	title: 'Correct the response'.
	element := WebElement new.
	element table width: self pageContentWidth.
	element row color: self tableHeaderColor.
	element cell colspan: 4; addText: self title header: 3.
	element newRow.
	element cell add: (self smallText: 'Title: ' attributes: #bold).
	element newCell colspan:3;
		add: (WebInputField new size: 50; aspect: #title for: self observee).
	element newRow.
	element cell add: (self smallText: 'Author: ' attributes: #bold).
	element newCell
		add: (WebInputField new size: 20; aspect: #author for: self observee).
	element newCell add: (self smallText: 'E-mail: ' attributes: #bold).
	element newCell
		add: (WebInputField new size: 20; aspect: #authorsEmail for: self observee).
	element newRow.
	element cell add: (self smallText: 'Response: ' attributes: #bold).
	element newCell colspan: 3;
		add: (WebTextArea new name: 'info'; size: 50@15; 
			aspect: #body for: self observee).

	"Akcijske tipke"
	element newRow color: self tableHeaderColor.
	element cell  align: #center; colspan: 4;
		add: (WebButton new text: 'Update'; type: #submit ).

	self pageFrameWith: element title: self title.! !

Object subclass: #Attachment
	instanceVariableNames: 'contentType origFilename parent title url proxy stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scribo-Core'!

!Attachment methodsFor: 'private' stamp: 'np 1/20/2008 09:32'!
checkFilePath
	"is url without spaces but documentDirectory still have it?"
	(self parent isNil or: [self parent parent isNil]) ifTrue: [^false].
	(self url includes: $ ) ifTrue: [^false].  "not need to check more"
	(self parent documentDirectory includes: $ ) ifFalse: [^false]. "everything ok"
	^true

"Attachment allInstances select: [:each | each checkFilePath] "
"Document allInstances select: [:each | 
	(each otherAt: #documentDirectory) notNil and: [each documentDirectory includes: $ ] ] "! !

!Attachment methodsFor: 'accessing' stamp: 'np 1/20/2008 09:28'!
close
	"close an open file, that is its stream"
	self stream notNil ifTrue: 
		[self stream close. 
		self stream: nil]! !

!Attachment methodsFor: 'accessing' stamp: 'np 1/20/2008 09:28'!
content
	^self filePath asFilename contentsOfEntireFile! !

!Attachment methodsFor: 'accessing' stamp: 'np 6/21/2008 18:47'!
contentBinary
	^SpFilename named: (self filePath) contentsOfEntireFileBinary! !

!Attachment methodsFor: 'accessing' stamp: 'np 1/20/2008 09:29'!
contentIcon
	"a name of icon to represent attachments, from WebStyle imgs-filetype icons"
	self parent repository site mimeMap iconForType: self contentType.! !

!Attachment methodsFor: 'accessing' stamp: 'np 1/20/2008 09:29'!
contentType
	^contentType! !

!Attachment methodsFor: 'accessing' stamp: 'np 1/20/2008 09:29'!
contentType: aString
	contentType := aString! !

!Attachment methodsFor: 'accessing-timestamps' stamp: 'np 1/20/2008 09:31'!
createdTimestamp
	^self proxy createdTimestamp! !

!Attachment methodsFor: 'accessing' stamp: 'mu 6/24/2008 21:12'!
encodedUrl
	| writeStream readStream |
	writeStream := '' writeStream.
	readStream := self url readStream.
	[readStream atEnd]
		whileFalse: [| elem | 
			elem := AIDASite convertToWebString: (readStream upTo: $/).
			elem isEmpty
				ifFalse: [writeStream nextPut: $/.
					writeStream nextPutAll: elem]].
	^ writeStream contents! !

!Attachment methodsFor: 'testing' stamp: 'np 1/20/2008 09:32'!
exists
	"file still exist? It can happend sometimes that someone deletes an attachment but we still think
	it exist. This can happen when copying attachments in a new doc version"
	^self proxy notNil and: [self proxy fileStillExist]! !

!Attachment methodsFor: 'accessing' stamp: 'mu 5/4/2008 20:49'!
filePath
	"a full path to that attachment"
	^self parent repository rootDirectory, (self platformPathString: self url)! !

!Attachment methodsFor: 'testing' stamp: 'np 1/20/2008 09:32'!
isImageAttachment
	^self contentType = 'image/gif' 
		or: [self contentType = 'image/jpeg'
			or: [self contentType = 'image/png'] ]! !

!Attachment methodsFor: 'private' stamp: 'np 1/20/2008 09:32'!
lastSeparatorIndexIn: aString
	"index of \ or / in a String. nil if none"
	^aString lastIndexOf: $\ "from Windows" ifAbsent: 
		[aString lastIndexOf: $/ "from Linux/Unix" ifAbsent: [nil] ]

"Attachment new lastSeparatorIndexIn: 'c:\dir\file.jpg' "
"Attachment new lastSeparatorIndexIn: '/home/dir/file.jpg' "
"Attachment new lastSeparatorIndexIn: 'file.jpg' "! !

!Attachment methodsFor: 'private' stamp: 'np 1/20/2008 09:33'!
makeProxy
	"make a FileProxy and register it to url resolver in advance, for correct url and filenames!! "
	self proxy: (AttachmentProxy newFor: self onSite: self parent repository site)! !

!Attachment methodsFor: 'accessing-timestamps' stamp: 'np 1/20/2008 09:31'!
modifiedTimestamp
	^self proxy modifiedTimestamp! !

!Attachment methodsFor: 'accessing' stamp: 'np 1/20/2008 09:29'!
origFilename
	"name of file before uploaded. It can be different from those in url!!"
	^origFilename! !

!Attachment methodsFor: 'accessing' stamp: 'np 1/20/2008 09:29'!
origFilename: aString
	"cleanup filename to be just that, without a path if exist"
	"example: c:\dir\image.gif should be just image.gif"
	| inx |
	inx := self lastSeparatorIndexIn: aString.
	origFilename := inx isNil 
		ifTrue: [aString]
		ifFalse: [aString copyFrom: inx+1 to: aString size].! !

!Attachment methodsFor: 'accessing' stamp: 'np 1/20/2008 09:29'!
parent
	^parent! !

!Attachment methodsFor: 'accessing' stamp: 'np 1/20/2008 09:30'!
parent: aDocument
	parent := aDocument! !

!Attachment methodsFor: 'private' stamp: 'mu 5/4/2008 21:03'!
platformPathString: filePathString 
	SpEnvironment onWindows ifTrue: [^ filePathString copyReplaceAll: '/' with: '\'].
	^ filePathString! !

!Attachment methodsFor: 'private' stamp: 'np 1/20/2008 09:33'!
printString
	^'anAttachment
	filename: ', self origFilename, '
	type: ', (self contentType notNil ifTrue: [self contentType] ifFalse: ['']), '
	url: ', self url, '
	on ', (self parent notNil ifTrue: [self parent printString] ifFalse: ['nil']).! !

!Attachment methodsFor: 'private' stamp: 'np 1/20/2008 09:33'!
proxy
	^proxy! !

!Attachment methodsFor: 'private' stamp: 'np 1/20/2008 09:33'!
proxy: anAttachmentProxy
	proxy := anAttachmentProxy! !

!Attachment methodsFor: 'accessing-streams' stamp: 'np 1/20/2008 09:31'!
readStream
	"open (if not yet) an attachment and return a binary read stream to read from it. 
	Don't forget to close it!! "
	self stream isNil ifTrue:
		[self stream: self filePath asFilename readStream binary].
	^self stream! !

!Attachment methodsFor: 'private' stamp: 'np 1/22/2008 14:39'!
removeFile
	(SpFilename named: self filePath) delete! !

!Attachment methodsFor: 'private' stamp: 'np 1/20/2008 09:33'!
removeProxy
	"remove a FileProxy from url resolver and anywhere else"
	self proxy isNil ifTrue: [^nil].
	self proxy 
		removeYourself;
		attachment: nil.
	self proxy: nil.! !

!Attachment methodsFor: 'accessing' stamp: 'np 1/22/2008 12:24'!
setContentType
	"from already set origFilename"
	| extension |
	extension := (SpFilename named: self origFilename) extension.
	extension isNil ifTrue: [^nil].
	self contentType: (self parent repository site mimeMap 
		typeForExtension: extension).! !

!Attachment methodsFor: 'accessing' stamp: 'mu 6/24/2008 11:41'!
setUrl
	"take care for duplicates!! "
	| urlPath oname fname |
	urlPath := (self parent documentDirectory 
		copyReplaceAll: self parent repository rootDirectory with: '').
	oname := self parent neutralFilenameFrom: self origFilename.
	self url: ((urlPath, '/',  oname) copyReplaceAll: ' ' with: '-').  "again for sure"
	(SpFilename named: self filePath) exists ifTrue:
		 [fname := (oname copyUpTo: $. ), 
			'-', (Random new next * 1000) rounded printString,
			(SpFilename named: oname) extension.
		self url: urlPath, '/', fname ]! !

!Attachment methodsFor: 'storing' stamp: 'np 1/20/2008 09:32'!
storeContent: aByteStringOrArray
	self writeStream 
		nextPutAll: aByteStringOrArray asByteArray; 
		close.! !

!Attachment methodsFor: 'storing' stamp: 'np 3/28/2008 03:21'!
storeContentFromFilename: aString
	"stream content of that filename directly into attachment"
	| strm |
	[strm := (SpFilename named: aString) readStream binary.
	self storeContent: strm contents] 
		ensure: [strm notNil ifTrue: [strm close]]! !

!Attachment methodsFor: 'private' stamp: 'np 1/20/2008 09:33'!
stream
	^stream! !

!Attachment methodsFor: 'private' stamp: 'np 1/20/2008 09:33'!
stream: aReadOrWriteStream
	stream := aReadOrWriteStream! !

!Attachment methodsFor: 'accessing' stamp: 'np 1/20/2008 09:30'!
title
	"subtitle on images for instance"
	title isNil ifTrue: [^''].
	^title! !

!Attachment methodsFor: 'accessing' stamp: 'np 1/20/2008 09:30'!
title: aString
	"subtitle on images for instance"
	title := aString! !

!Attachment methodsFor: 'accessing' stamp: 'np 1/20/2008 09:30'!
url
	"a relative url to that document, relative to repository root directory"
	^url! !

!Attachment methodsFor: 'accessing' stamp: 'np 1/20/2008 09:30'!
url: aString
	url := aString! !

!Attachment methodsFor: 'accessing' stamp: 'np 1/20/2008 09:30'!
uuid
	^self hash printString! !

!Attachment methodsFor: 'accessing-streams' stamp: 'np 1/22/2008 17:42'!
writeStream
	"open (if not yet) an attachment and return a binary write stream to write on it. Don't forget to close it!! "
	self stream isNil ifTrue:
		["self parent checkDocumentDirectory." "spaces in dir name etc"
		self stream: (SpFilename named: self filePath) writeStream].
	^self stream! !

Object subclass: #Blog
	instanceVariableNames: 'tagline title posts parent commentsNeedApproval rssRootUrl commentsTimeout'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scribo-Blog'!

!Blog class methodsFor: 'instance creation' stamp: 'np 6/23/2008 00:23'!
new
	^self basicNew initialize! !

!Blog class methodsFor: 'instance creation' stamp: 'np 6/23/2008 00:24'!
newOn: anAIDASite
	"find appropriate class for a new wiki page, defined in ScriboStyle blogClass"
	^anAIDASite style blogClass new
		parent: anAIDASite;
		yourself! !

!Blog methodsFor: 'adding-removing' stamp: 'np 3/29/2008 01:30'!
addPost: aBlogPost 
	aBlogPost isBlogPost ifFalse: [^nil].
	aBlogPost parent: self.
	posts add: aBlogPost.! !

!Blog methodsFor: 'accessing' stamp: 'np 3/29/2008 01:32'!
comments
	"Comments of all posts.
	If comments need approval, then returns approved comments only"
	| comments |
	comments := OrderedCollection new.
	self posts do: [:each | comments addAll: each approvedComments].
	^comments! !

!Blog methodsFor: 'accessing' stamp: 'np 3/28/2008 21:56'!
commentsFeeds
	| comments |
	comments := OrderedCollection new.
	self publishedPosts do: [:each | 
		(each isAccessAllowedFor: self site securityManager guestUser) ifTrue: [
			each approvedComments do: [:comment |
				comments add: comment asRSSFeed]]].
	^comments asSortedCollection: [:comment1 :comment2 |
		comment1 timeStamp > comment2 timeStamp]! !

!Blog methodsFor: 'accessing' stamp: 'np 3/12/2008 13:29'!
commentsNeedApproval
	commentsNeedApproval isNil ifTrue: [commentsNeedApproval := true].
	^commentsNeedApproval! !

!Blog methodsFor: 'accessing' stamp: 'np 3/12/2008 13:29'!
commentsNeedApproval: aBoolean
	commentsNeedApproval := aBoolean! !

!Blog methodsFor: 'accessing' stamp: 'np 6/8/2008 00:09'!
commentsTimeout
	commentsTimeout isNil ifTrue: [commentsTimeout := ''].
	^commentsTimeout ! !

!Blog methodsFor: 'accessing' stamp: 'np 3/12/2008 16:27'!
commentsTimeout: aString
	commentsTimeout := aString! !

!Blog methodsFor: 'accessing' stamp: 'np 1/24/2008 16:47'!
commentsWaitingApproval
	"Comments waiting approval of all posts"
	| comments |
	comments := OrderedCollection new.
	self posts do: [:each | comments addAll: each commentsWaitingApproval].
	^comments! !

!Blog methodsFor: 'initialize-release' stamp: 'np 1/24/2008 10:26'!
initPosts
	posts := OrderedCollection new! !

!Blog methodsFor: 'initialize-release' stamp: 'np 1/25/2008 18:24'!
initialize
	super initialize.
	self initPosts! !

!Blog methodsFor: 'testing' stamp: 'np 1/23/2008 14:45'!
isBlog
	^true! !

!Blog methodsFor: 'accessing' stamp: 'np 3/29/2008 01:31'!
obsoletePosts
	^posts select: [:each | each isObsolete]! !

!Blog methodsFor: 'accessing' stamp: 'np 1/24/2008 10:42'!
pageTitled: aString
	^self postTitled: aString! !

!Blog methodsFor: 'accessing' stamp: 'np 1/23/2008 17:34'!
pages
	^self posts! !

!Blog methodsFor: 'accessing' stamp: 'np 1/24/2008 10:32'!
parent
	^parent! !

!Blog methodsFor: 'accessing' stamp: 'np 1/24/2008 10:32'!
parent: aParent
	parent := aParent ! !

!Blog methodsFor: 'accessing' stamp: 'np 2/14/2008 01:58'!
postFeeds
	^self publishedPosts
		select: [:each | each isAccessAllowedFor: self site securityManager guestUser] 
		thenCollect: [:each | each asRSSFeed]! !

!Blog methodsFor: 'accessing' stamp: 'np 3/29/2008 01:31'!
postTitled: aString
	^self posts detect: [:each | each title = aString] ifNone: [^nil]! !

!Blog methodsFor: 'accessing' stamp: 'np 3/29/2008 01:29'!
posts
	^posts reject: [:each | each isObsolete]! !

!Blog methodsFor: 'accessing' stamp: 'np 3/28/2008 21:36'!
postsCategories
	|categories|
	categories := Set new.
	self publishedPosts do: [:post |
		post tokenizedCategories do: [:cat |
			categories add: cat]].
	^categories asSortedCollection ! !

!Blog methodsFor: 'accessing' stamp: 'np 3/28/2008 21:36'!
postsTags
	|t|
	t := Set new.
	self publishedPosts do: [:post |
		post tokenizedTags do: [:tag |
			t add: tag]].
	^t asSortedCollection ! !

!Blog methodsFor: 'accessing' stamp: 'np 3/29/2008 01:31'!
publishedPosts
	| publishedPosts |
	publishedPosts := self posts select: [:each | 
		each isPublished].
	^publishedPosts asSortedCollection: [:post1 :post2 |
			post1 readyTimestamp > post2 readyTimestamp]
		
! !

!Blog methodsFor: 'accessing' stamp: 'np 1/24/2008 10:34'!
repository
	^self parent repository! !

!Blog methodsFor: 'accessing' stamp: 'np 3/19/2008 04:31'!
rssRootUrl
	rssRootUrl isNil ifTrue: [
		rssRootUrl := 'http://', self app site host, ':', self app site port asString].
	^rssRootUrl! !

!Blog methodsFor: 'accessing' stamp: 'np 3/12/2008 13:32'!
rssRootUrl: aString
	rssRootUrl := aString ! !

!Blog methodsFor: 'accessing' stamp: 'np 1/24/2008 10:34'!
site
	^self parent! !

!Blog methodsFor: 'accessing' stamp: 'np 1/23/2008 16:12'!
tagline
	tagline isNil ifTrue: [tagline := 'A blog about...'].
	^tagline! !

!Blog methodsFor: 'accessing' stamp: 'np 1/23/2008 15:03'!
tagline: aString
	tagline := aString ! !

!Blog methodsFor: 'accessing' stamp: 'np 1/23/2008 16:12'!
title
	title isNil ifTrue: [title := 'Blog'].
	^title! !

!Blog methodsFor: 'accessing' stamp: 'np 1/23/2008 16:00'!
title: aString
	title := aString! !

Object subclass: #DailyText
	instanceVariableNames: 'authors daily last shown'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scribo-Components'!

!DailyText methodsFor: 'accessing-authors' stamp: 'np 1/20/2008 15:53'!
addAuthor: aName imageUrl: anUrl
	"(AIDASite named: 'siska') siteContent dailyText
		addAuthor: 'pis^e: p.Zdravko'
		imageUrl: 'http://www.zupnija-siska.si/2007/09-30/Patri-v41/p-zdravko-m.jpg' "
	"(AIDASite named: 'siska') siteContent dailyText
		addAuthor: 'pis^e: p.Bogdan'
		imageUrl: 'http://www.zupnija-siska.si/2007/09-03/Patri-v39/bogi1-manjse.jpg' "
	self authors add:
		(DailyTextAuthor new
			name: aName;
			image: anUrl)! !

!DailyText methodsFor: 'accessing' stamp: 'np 1/20/2008 15:51'!
author: aDailyTextAuthor onDate: aDate
	"put that author on specified date, but only if there actually is text"
	| entry |
	entry := self daily at: aDate ifAbsent: [nil].
	entry isNil ifTrue: [entry := self openEntryOnDate: aDate].
	entry author: aDailyTextAuthor! !

!DailyText methodsFor: 'accessing-authors' stamp: 'np 1/20/2008 15:53'!
authorNamed: aName 
	^self authors detect: [:each | each name = aName] ifNone: [nil]! !

!DailyText methodsFor: 'accessing' stamp: 'np 1/20/2008 15:51'!
authorOnDate: aDate
	^(self daily at: aDate ifAbsent: [^nil]) author! !

!DailyText methodsFor: 'accessing-authors' stamp: 'np 1/20/2008 15:53'!
authors
	authors isNil ifTrue: [self initAuthors].
	^authors! !

!DailyText methodsFor: 'private' stamp: 'np 1/20/2008 15:53'!
daily
	"daily values for text"
	daily isNil ifTrue: [self initDaily].
	^daily! !

!DailyText methodsFor: 'initialize-release' stamp: 'np 1/20/2008 15:50'!
initAuthors
	authors := OrderedCollection new.! !

!DailyText methodsFor: 'initialize-release' stamp: 'np 1/20/2008 15:50'!
initDaily
	daily := DailyValues new.! !

!DailyText methodsFor: 'private' stamp: 'np 1/20/2008 15:53'!
last
	"last day with fill text returned. Kind a cache for faster retrieve"
	^last! !

!DailyText methodsFor: 'private' stamp: 'np 1/20/2008 15:53'!
last: aDate
	last := aDate! !

!DailyText methodsFor: 'accessing' stamp: 'np 1/20/2008 15:51'!
lastAuthor
	"return today's or if not exist, text from last day entered"
	^(self daily last) author! !

!DailyText methodsFor: 'private' stamp: 'np 1/20/2008 15:54'!
migrateTextsToEntries
	"old texts are strings only, migrate them to DailyTextEntries"
	"(AIDASite named: 'siska') siteContent dailyText migrateTextsToEntries"
	| value |
	self daily allDates do: [:date |
		value := self daily at: date.
		(value isKindOf: String) ifTrue: [self daily at: date put: (DailyTextEntry new text: value)] ]! !

!DailyText methodsFor: 'private' stamp: 'np 1/20/2008 15:54'!
openEntryOnDate: aDate
	"open a new entry and copy author from last entry if any"
	| entry |
	entry := self daily at: aDate ifAbsent: [nil].
	entry notNil ifTrue: [^entry].
	entry := DailyTextEntry new.
	entry author: self lastAuthor. 
	self daily at: aDate put: entry.
	^entry! !

!DailyText methodsFor: 'private' stamp: 'np 1/20/2008 15:54'!
setShown
	shown := SpTimestamp now.! !

!DailyText methodsFor: 'private' stamp: 'np 1/20/2008 15:54'!
shown
	"timestamp of last text retrieved. For cache algorithm"
	^shown! !

!DailyText methodsFor: 'accessing' stamp: 'np 1/20/2008 15:51'!
text: aString onDate: aDate
	"put that text on specified date, but only if there actually is text"
	| entry |
	(aString isNil or: [aString isEmpty]) ifTrue: [^nil].
	entry := self daily at: aDate ifAbsent: [nil].
	entry isNil ifTrue: [entry := self openEntryOnDate: aDate].
	entry text: aString! !

!DailyText methodsFor: 'accessing' stamp: 'np 1/20/2008 15:51'!
textOnDate: aDate
	"text on that date or empty string if not exist"
	^(self daily at: aDate ifAbsent: [^'']) text! !

!DailyText methodsFor: 'accessing' stamp: 'np 1/20/2008 15:52'!
todayAuthor
	"return today's or if not exist, text from last day entered"
	^(self daily atOrLastFrom: SpDate today) author! !

!DailyText methodsFor: 'accessing' stamp: 'np 1/20/2008 15:52'!
todayText
	"return today's or if not exist, text from last day entered"
	^(self daily atOrLastFrom: SpDate today) text! !

!DailyText methodsFor: 'accessing' stamp: 'np 1/20/2008 15:52'!
todayTextDate
	"not nessesary today!! Returns a date of last entered text"
	^self daily lastDateFrom: SpDate today.! !

Object subclass: #DailyTextAuthor
	instanceVariableNames: 'image name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scribo-Components'!

!DailyTextAuthor methodsFor: 'accessing' stamp: 'np 1/20/2008 15:55'!
image
	"an URL of author image"
	image isNil ifTrue: [^''].
	^image! !

!DailyTextAuthor methodsFor: 'accessing' stamp: 'np 1/20/2008 15:55'!
image: anUrlString
	image := anUrlString! !

!DailyTextAuthor methodsFor: 'accessing' stamp: 'np 1/20/2008 15:55'!
name
	"what is wriiten below author image"
	name isNil ifTrue: [^''].
	^name! !

!DailyTextAuthor methodsFor: 'accessing' stamp: 'np 1/20/2008 15:55'!
name: aString
	name := aString convertToSloveneChars! !

Object subclass: #DailyTextEntry
	instanceVariableNames: 'author text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scribo-Components'!

!DailyTextEntry methodsFor: 'accessing' stamp: 'np 1/20/2008 15:56'!
author
	"author of that text"
	^author! !

!DailyTextEntry methodsFor: 'accessing' stamp: 'np 1/20/2008 15:56'!
author: aDailyTextAuthor
	author := aDailyTextAuthor! !

!DailyTextEntry methodsFor: 'accessing' stamp: 'np 1/20/2008 15:56'!
text
	text isNil ifTrue: [^''].
	^text! !

!DailyTextEntry methodsFor: 'accessing' stamp: 'np 1/20/2008 15:56'!
text: aString
	text := aString! !

Object subclass: #EMailMessenger
	instanceVariableNames: 'repository queue sendingLoop client'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scribo-Core'!

!EMailMessenger class methodsFor: 'accessing' stamp: 'janko 7/30/2008 23:15'!
default
	^AIDASite default repository messenger! !

!EMailMessenger class methodsFor: 'instance creation' stamp: 'janko 7/30/2008 23:18'!
newOn: aRepository
	^super new repository: aRepository! !

!EMailMessenger methodsFor: 'private' stamp: 'janko 7/30/2008 22:25'!
client
	"a SMTP client"
	client isNil ifTrue: [self initClient].
	^client! !

!EMailMessenger methodsFor: 'private' stamp: 'janko 7/30/2008 22:28'!
emailAddressFor: aPersonOrCollection
	"one or more email addresses, separated with comma"
	| collection |
	(aPersonOrCollection isKindOf: String) ifTrue: [^aPersonOrCollection].
	collection := (aPersonOrCollection isKindOf: Collection) 
		ifTrue: [aPersonOrCollection] ifFalse: [Array with: aPersonOrCollection].
	collection := collection select: [:each | each notNil and: [each email isValidEMailAddress]].
	collection isEmpty ifTrue: [^'User has no email!! <info@eranova.si>'].
	^(collection inject: '' into: [:string :each |
		(string = '' ifTrue: [''] ifFalse: [string, ', ']), '"', each nameSurname, '" <', each email, '>'])
			ensureUnicodeSloveneChars! !

!EMailMessenger methodsFor: 'initialize-release' stamp: 'janko 7/30/2008 23:21'!
initClient
	client := SMTPClient openOnHostNamed: self repository emailSMTPServer! !

!EMailMessenger methodsFor: 'initialize-release' stamp: 'janko 7/30/2008 22:34'!
initSenderProcess
	self sendingLoop notNil ifTrue: [self sendingLoop terminate].
	self sendingLoop: 
		([self senderProcess] forkAt: Processor userBackgroundPriority).! !

!EMailMessenger methodsFor: 'private-error reports' stamp: 'janko 7/30/2008 22:29'!
messageForError: anErrorString for: aRFC822Message
	| text |
	text := 'Napaka pri pos^iljanju e-pos^te

	', anErrorString, '

prejemnik: ', aRFC822Message to first.

	text := text, '  

To je samodejno sporoc^ilo iz informacijskega portala sistema kakovosti BiArt.'.

	^text! !

!EMailMessenger methodsFor: 'private-error reports' stamp: 'janko 7/30/2008 22:30'!
notifyError: anErrorString toSenderOf: aRFC822Message
	self sendSubject: 'Scribo: error sending e-mails' 
		body: (self messageForError: anErrorString for: aRFC822Message)
		from: aRFC822Message from first to: aRFC822Message from first! !

!EMailMessenger methodsFor: 'private' stamp: 'janko 7/30/2008 22:28'!
privSendMessage: aRFC822Message
	| errorText |
	[aRFC822Message fromSendStrings isEmpty 
		ifTrue: [aRFC822Message from: self repository adminEMail].
	self client sendMessage: aRFC822Message.
	self reportMailSend: aRFC822Message]
		on: Error
		do: [:ex | errorText := ex class name, ': ', ex errorString.
			Transcript cr; show: 'e-mail sending on ', self repository site name, ' failed: ', errorText; cr.
			('*Error 550*' match: errorText) | ('*Error 554*' match: errorText)  
				"relaying rejected, don't send again, it will loop!! "
				ifFalse: [self notifyError: errorText toSenderOf: aRFC822Message] ].
	(Delay forMilliseconds: 200) wait.! !

!EMailMessenger methodsFor: 'private' stamp: 'janko 7/30/2008 22:26'!
queue
	queue isNil ifTrue: 
		[queue := SharedQueue new.
		self initSenderProcess].
	^queue.! !

!EMailMessenger methodsFor: 'private' stamp: 'janko 7/30/2008 22:27'!
reportMailSend: aRFC822Message
	| receiver subject |
	receiver := aRFC822Message toSendStrings first.
	(receiver includes: $<) ifTrue: [receiver := receiver readStream upTo: $<; upTo: $>].
	subject := aRFC822Message subject asSloveneWithoutCircumflexes contractTo: 40.
	Transcript cr; show: 'e-mail sent to: ', receiver, ' ', subject
		.! !

!EMailMessenger methodsFor: 'accessing' stamp: 'janko 7/30/2008 22:24'!
repository
	^repository! !

!EMailMessenger methodsFor: 'private' stamp: 'janko 7/30/2008 22:27'!
repository: aRepository
	repository := aRepository! !

!EMailMessenger methodsFor: 'sending' stamp: 'janko 7/30/2008 22:32'!
sendSubject: aSubjectString body: aBodyString attachFile: aFilenameString content: aContentString from: aPerson to: aPersonOrCollection
	| message receiverAddresses attachment |
	receiverAddresses := self emailAddressFor: aPersonOrCollection.
	receiverAddresses isEmpty ifTrue: [^nil].
	message := MailMessage newTextPlain. 
	message 
		charset: 'UTF-8'; headerCharset: 'UTF-8'; 
		from: (self emailAddressFor: aPerson); 
		to: receiverAddresses; 
		subject: aSubjectString convertToSloveneChars;
		text: aBodyString convertToSloveneChars ensureUnicodeSloveneChars.
 	message addContentTransferEncoding: '8bit'.
"	aFilenameString notNil ifTrue:
		[attachment := MimeEntity new.
		attachment fileName: aFilenameString; 
			contentType: (MimeEntity mimeTypeForFile: aFilenameString).
		attachment body source: aContentString readStream. 
		attachment addContentTransferEncoding: '8bit'.
		message addPart: attachment].
"	self queue nextPut: message.! !

!EMailMessenger methodsFor: 'sending' stamp: 'janko 7/30/2008 22:32'!
sendSubject: aSubjectString body: aBodyString from: aPerson to: aPersonOrCollection
	^self 
		sendSubject: aSubjectString body: aBodyString 
		attachFile: nil content: nil 
		from: aPerson to: aPersonOrCollection! !

!EMailMessenger methodsFor: 'private' stamp: 'janko 7/30/2008 22:26'!
senderProcess
	[true] whileTrue: [self privSendMessage: self queue next].! !

!EMailMessenger methodsFor: 'private' stamp: 'janko 7/30/2008 22:26'!
sendingLoop
	"sender process"
	^sendingLoop! !

!EMailMessenger methodsFor: 'private' stamp: 'janko 7/30/2008 22:27'!
sendingLoop: aProcess
	sendingLoop := aProcess! !

!EMailMessenger methodsFor: 'sending' stamp: 'janko 7/30/2008 22:30'!
startSending
	self initClient.
	self initSenderProcess.! !

!EMailMessenger methodsFor: 'sending' stamp: 'janko 7/30/2008 22:31'!
stopSending
	self sendingLoop notNil ifTrue: [self sendingLoop  terminate. self sendingLoop: nil].
	client := nil.
"	queue := nil."! !

Object subclass: #EventLog
	instanceVariableNames: 'lastTimestamps logs parent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scribo-Core'!

!EventLog class methodsFor: 'accessing' stamp: 'np 3/29/2008 04:22'!
default
	^Repository default eventLog! !

!EventLog class methodsFor: 'instance creation' stamp: 'np 6/23/2008 00:21'!
new
	^self basicNew initialize! !

!EventLog class methodsFor: 'instance creation' stamp: 'np 6/23/2008 00:21'!
newOn: aRepository
	^self new 
		parent: aRepository;
		yourself! !

!EventLog methodsFor: 'accessing-logs' stamp: 'np 3/29/2008 04:25'!
accessedLog
	^self logsAt: #accessed! !

!EventLog methodsFor: 'accessing' stamp: 'np 3/29/2008 04:23'!
allEventsLast: aNumber
	| events |
	events := (self createdLog last: aNumber)
		addAll: (self modifiedLog last: aNumber);
		addAll: (self approvedLog last: aNumber);
		addAll: (self releasedLog last: aNumber);
		addAll: (self obsoleteLog last: aNumber);
		yourself.
	events isEmpty ifTrue: [^events].
	events := SortedCollection withAll: events sortBlock: [:a :b | a timestamp > b timestamp].
	^events copyFrom: 1 to: (aNumber min: events size)! !

!EventLog methodsFor: 'accessing' stamp: 'np 3/29/2008 04:24'!
allEventsOfLog: aSymbol since: aTimestamp
	^((self logsAt: aSymbol) allSinceDate: aTimestamp asDate) 
		select: [:each | each timestamp > aTimestamp]! !

!EventLog methodsFor: 'accessing' stamp: 'np 3/29/2008 04:24'!
allEventsSince: aTimestamp
	| events |
	events := (self createdLog allSinceDate: aTimestamp asDate)
		addAll: (self modifiedLog allSinceDate: aTimestamp asDate);
		addAll: (self approvedLog allSinceDate: aTimestamp asDate);
		addAll: (self releasedLog allSinceDate: aTimestamp asDate);
		addAll: (self obsoleteLog allSinceDate: aTimestamp asDate);
		yourself.
	events := events select: [:each | each timestamp > aTimestamp].
	^SortedCollection withAll: events sortBlock: [:a :b | a timestamp > b timestamp].! !

!EventLog methodsFor: 'accessing-logs' stamp: 'np 3/29/2008 04:25'!
approvedLog
	^self logsAt: #approved! !

!EventLog methodsFor: 'statistics' stamp: 'np 3/29/2008 04:27'!
countsByTypeFrom: aCollection
	| dict |
	dict := Dictionary new.
	aCollection do: [:each | self countsByTypeFrom: each object into: dict].
	^dict! !

!EventLog methodsFor: 'statistics' stamp: 'np 4/4/2008 17:12'!
countsByTypeFrom: anEvent into: aDict
	| type |
	(anEvent isKindOf: Folder) ifTrue: [^aDict at: #folder put: (aDict at: #folder ifAbsent: [0])+1].
	(anEvent isKindOf: Document) ifFalse: [^aDict at: #other put: (aDict at: #other ifAbsent: [0])+1].
	type := anEvent id upToNumber asUppercase.
	(self docTypeCodes includes: type)
		ifTrue: [^aDict at: type put: (aDict at: type ifAbsent: [0])+1]
		ifFalse: [^aDict at: #otherDoc put: (aDict at: #otherDoc ifAbsent: [0])+1]! !

!EventLog methodsFor: 'accessing-logs' stamp: 'np 3/29/2008 04:25'!
createdLog
	^self logsAt: #created! !

!EventLog methodsFor: 'statistics' stamp: 'np 3/29/2008 04:31'!
docStatsForYear: aNumber
	"(AIDASite named: 'biart') repository eventLog docStatsForYear: 2005"
	| dict eventDict |
	eventDict := self eventsForYear: aNumber.
	dict := Dictionary new.
	dict at: #created put: (self countsByTypeFrom: (eventDict at: #created)).
	dict at: #modified put: (self countsByTypeFrom: (eventDict at: #modified)).
	dict at: #approved put: (self countsByTypeFrom: (eventDict at: #approved)).
	dict at: #released put: (self countsByTypeFrom: (eventDict at: #released)).
	dict at: #obsolete put: (self countsByTypeFrom: (eventDict at: #obsolete)).
	^dict! !

!EventLog methodsFor: 'statistics' stamp: 'np 3/29/2008 04:31'!
docTypeCodes
	^#('PKP' 'SOP' 'NAV' 'OBR' 'PLN' 'PRA' 'VL')! !

!EventLog methodsFor: 'statistics' stamp: 'np 3/29/2008 04:31'!
eventsForYear: aNumber
	| dict |
	dict := Dictionary new.
	dict at: #created put: (self createdLog allYear: aNumber) asSet.
	dict at: #modified put: (self modifiedLog allYear: aNumber) asSet.
	dict at: #approved put: (self approvedLog allYear: aNumber) asSet.
	dict at: #released put: (self releasedLog allYear: aNumber) asSet.
	dict at: #obsolete put: (self obsoleteLog allYear: aNumber) asSet.
	^dict! !

!EventLog methodsFor: 'initialize-release' stamp: 'np 3/29/2008 04:22'!
initLastTimestamps
	lastTimestamps := Dictionary new.! !

!EventLog methodsFor: 'initialize-release' stamp: 'np 3/29/2008 04:22'!
initLogs
	logs := Dictionary new! !

!EventLog methodsFor: 'accessing-timestamps' stamp: 'np 3/29/2008 04:26'!
lastModifiedTimestamp
	^self lastTimestamps at: #modified ifAbsent: [SpTimestamp now]! !

!EventLog methodsFor: 'private' stamp: 'np 3/29/2008 04:32'!
lastTimestamps
	lastTimestamps isNil ifTrue: [self initLastTimestamps].
	^lastTimestamps! !

!EventLog methodsFor: 'logging events' stamp: 'mu 6/18/2008 10:30'!
log: aSymbol of: aDocument by: aWebUser
	self removeFrom: aSymbol of: aDocument by: aWebUser newestThan: self windowTimestamp.
	(self logsAt: aSymbol) 
		add: (EventLogRecord newType: aSymbol object: aDocument actor: aWebUser)
		onDate: SpDate today.
		
	self changed: aSymbol with: aDocument. "Currently just use classical #changed:with:"
! !

!EventLog methodsFor: 'private' stamp: 'np 6/21/2008 19:41'!
log: aSymbol of: aDocument by: aWebUser at: aTimestamp
	(self logsAt: aSymbol) 
		add: (EventLogRecord newType: aSymbol object: aDocument actor: aWebUser; 
			timestamp: aTimestamp; yourself) 
		onDate: aTimestamp asDate! !

!EventLog methodsFor: 'logging events' stamp: 'np 3/29/2008 04:26'!
logAccessed: aDocument by: aWebUser
	self log: #accessed of: aDocument by: aWebUser.
	self setLastTimestampFor: #accessed! !

!EventLog methodsFor: 'logging events' stamp: 'np 3/29/2008 04:27'!
logApproved: aDocument by: aWebUser
	self log: #approved of: aDocument by: aWebUser.
	self setLastTimestampFor: #approved! !

!EventLog methodsFor: 'logging events' stamp: 'np 3/29/2008 04:27'!
logCreated: aDocument by: aWebUser
	self log: #created of: aDocument by: aWebUser.
	self setLastTimestampFor: #created! !

!EventLog methodsFor: 'logging events' stamp: 'np 3/29/2008 04:27'!
logModified: aDocument by: aWebUser
	self log: #modified of: aDocument by: aWebUser.
	self setLastTimestampFor: #modified! !

!EventLog methodsFor: 'logging events' stamp: 'np 3/29/2008 04:27'!
logObsolete: aDocument by: aWebUser
	self log: #obsolete of: aDocument by: aWebUser.
		self setLastTimestampFor: #obsolete! !

!EventLog methodsFor: 'logging events' stamp: 'np 3/29/2008 04:27'!
logReleased: aDocument by: aWebUser
	self log: #released of: aDocument by: aWebUser.
		self setLastTimestampFor: #released! !

!EventLog methodsFor: 'private' stamp: 'np 3/29/2008 04:33'!
logs
	logs isNil ifTrue: [self initLogs].
	^logs! !

!EventLog methodsFor: 'private' stamp: 'np 3/29/2008 04:33'!
logsAt: aSymbol
	^self logs at: aSymbol ifAbsentPut: [DailyCollection new].! !

!EventLog methodsFor: 'accessing-logs' stamp: 'np 3/29/2008 04:25'!
modifiedLog
	^self logsAt: #modified! !

!EventLog methodsFor: 'accessing' stamp: 'np 3/29/2008 04:24'!
numberOfAllSince: aTimestamp
	^(self allEventsSince: aTimestamp) size! !

!EventLog methodsFor: 'accessing' stamp: 'np 3/29/2008 04:24'!
numberOfLog: aSymbol since: aTimestamp
	^(self allEventsOfLog: aSymbol since: aTimestamp) size! !

!EventLog methodsFor: 'accessing-logs' stamp: 'np 3/29/2008 04:25'!
obsoleteLog
	^self logsAt: #obsolete! !

!EventLog methodsFor: 'accessing' stamp: 'np 3/29/2008 04:24'!
parent
	^parent! !

!EventLog methodsFor: 'private' stamp: 'np 3/29/2008 04:33'!
parent: aRepository
	parent := aRepository! !

!EventLog methodsFor: 'private' stamp: 'np 3/29/2008 04:38'!
preferedUrl
	^'/logs.html'.! !

!EventLog methodsFor: 'accessing-logs' stamp: 'np 3/29/2008 04:25'!
releasedLog
	^self logsAt: #released! !

!EventLog methodsFor: 'private' stamp: 'np 3/29/2008 05:28'!
removeFrom: aSymbol of: aDocument by: aWebUser newestThan: aTimestamp
	"to avoid too frequent logging, remove similar events inside time window, eg. last 5minutes"
	| newest |
	newest := ((self logsAt: aSymbol) allSinceDate: aTimestamp asDate) select: [:each | 
		each object == aDocument and: [each actor == aWebUser and: [each timestamp > aTimestamp]] ].
	(self logsAt: aSymbol) removeAll: newest.! !

!EventLog methodsFor: 'private' stamp: 'np 3/29/2008 05:28'!
setLastTimestampFor: aSymbol 
	self lastTimestamps at: aSymbol put: SpTimestamp now! !

!EventLog methodsFor: 'private' stamp: 'np 3/29/2008 05:28'!
windowTimestamp
	"a time window, like 5minutes or since midnigt, on which we won't allow similar events, to avoid
	unnessesary and too frequent event logging, eg. a lot of modifications 
	of same doc by same user in short time"
	| windowSize |
	"windowSize := 5*60." "5 minutes"
	windowSize := SpTimestamp now asSeconds - SpDate today asSeconds. "since midnight"
	^SpTimestamp fromSeconds: (SpTimestamp now asSeconds - windowSize)! !

Object subclass: #EventLogRecord
	instanceVariableNames: 'timestamp actor object type'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scribo-Core'!

!EventLogRecord class methodsFor: 'instance creation' stamp: 'np 3/29/2008 04:39'!
approved: aDocument by: aWebUser
	^self newType: #approved object: aDocument actor: aWebUser! !

!EventLogRecord class methodsFor: 'instance creation' stamp: 'np 3/29/2008 04:40'!
created: aDocument by: aWebUser
	^self newType: #created object: aDocument actor: aWebUser! !

!EventLogRecord class methodsFor: 'instance creation' stamp: 'np 3/29/2008 04:40'!
modified: aDocument by: aWebUser
	^self newType: #modified object: aDocument actor: aWebUser! !

!EventLogRecord class methodsFor: 'instance creation' stamp: 'np 6/23/2008 00:21'!
new
	^self basicNew initialize! !

!EventLogRecord class methodsFor: 'instance creation' stamp: 'np 6/21/2008 19:41'!
newType: aSymbol object: anObject actor: aWebUser
	^self new
		type: aSymbol;
		object: anObject;
		actor: aWebUser;
		yourself! !

!EventLogRecord class methodsFor: 'instance creation' stamp: 'np 3/29/2008 04:40'!
obsolete: aDocument by: aWebUser
	^self newType: #obsolete object: aDocument actor: aWebUser! !

!EventLogRecord class methodsFor: 'instance creation' stamp: 'np 3/29/2008 04:40'!
released: aDocument by: aWebUser
	^self newType: #released object: aDocument actor: aWebUser! !

!EventLogRecord methodsFor: 'accessing' stamp: 'np 3/29/2008 04:41'!
actor
	^actor! !

!EventLogRecord methodsFor: 'accessing' stamp: 'np 3/29/2008 04:41'!
actor: aWebUser
	actor := aWebUser! !

!EventLogRecord methodsFor: 'accessing' stamp: 'np 3/29/2008 04:41'!
actorAsPerson
	^actor asPerson! !

!EventLogRecord methodsFor: 'accessing' stamp: 'np 3/29/2008 04:42'!
actorName
	actor isNil ifTrue: [^''].
	^actor surnameName! !

!EventLogRecord methodsFor: 'accessing' stamp: 'np 3/29/2008 04:42'!
date
	^self timestamp asDate! !

!EventLogRecord methodsFor: 'accessing' stamp: 'np 3/29/2008 05:34'!
dateString
	^self date printString! !

!EventLogRecord methodsFor: 'initialize-release' stamp: 'np 3/29/2008 04:41'!
initTimestamp
	timestamp := SpTimestamp now.! !

!EventLogRecord methodsFor: 'initialize-release' stamp: 'np 3/29/2008 04:41'!
initialize
	self initTimestamp! !

!EventLogRecord methodsFor: 'testing' stamp: 'np 3/29/2008 04:48'!
isLaterThan: aTimestamp
	^self timestamp > aTimestamp! !

!EventLogRecord methodsFor: 'accessing' stamp: 'np 3/29/2008 04:43'!
object
	^object! !

!EventLogRecord methodsFor: 'accessing' stamp: 'np 3/29/2008 04:43'!
object: anObject
	object := anObject! !

!EventLogRecord methodsFor: 'accessing' stamp: 'np 3/29/2008 04:43'!
objectName
	| name |
	object isNil ifTrue: [^''].
	name := object id, ' ', object title. "if document"
	^name trimBlanks isEmpty ifTrue: [^'-- no title --'] ifFalse: [name].! !

!EventLogRecord methodsFor: 'accessing' stamp: 'np 3/29/2008 04:43'!
timeString
	^self timestamp asTime printSloString! !

!EventLogRecord methodsFor: 'accessing' stamp: 'np 3/29/2008 04:43'!
timestamp
	^timestamp! !

!EventLogRecord methodsFor: 'accessing' stamp: 'np 3/29/2008 04:43'!
timestamp: aTimestamp
	timestamp := aTimestamp! !

!EventLogRecord methodsFor: 'accessing' stamp: 'np 3/29/2008 04:44'!
type
	^type! !

!EventLogRecord methodsFor: 'accessing' stamp: 'np 3/29/2008 04:44'!
type: aSymbol
	type := aSymbol! !

!EventLogRecord methodsFor: 'accessing' stamp: 'np 3/29/2008 04:47'!
typeText
	type isNil ifTrue: [^''].
	type = #accessed ifTrue: [^'access'].
	type = #modified ifTrue: [^'modification'].
	type = #created ifTrue: [^'new'].
	type = #approved ifTrue: [^'approval'].
	type = #released ifTrue: [^'publication'].
	type = #obsolete ifTrue: [^'removal'].
	^type asString! !

Object subclass: #HtmlRender
	instanceVariableNames: 'source inputStream outputStream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scribo-Wiki'!

!HtmlRender commentStamp: '<historical>' prior: 0!
For rendering formated text into HTML. Currently Wiki format supported (in WikRender subclass)

Thanks to WikiWorks authors for original code, which is adopted here!!
!

!HtmlRender class methodsFor: 'instance creation' stamp: 'np 1/21/2008 10:18'!
from: aString
	"render aString in Wiki syntax and return Html string"
	| stream |
	stream := WriteStream on: String new.
	self from: aString into: stream.
	^stream contents! !

!HtmlRender class methodsFor: 'instance creation' stamp: 'np 1/21/2008 10:18'!
from: aString into: aStream
	"only cr, convert cr-lf or lf to cr"
	| in out ch |
	
	in := aString readStream. out := (String new: aString size) writeStream.
	[in atEnd] whileFalse:
		[ch := in next. 
		ch = Character cr ifTrue: [in peek = Character lf ifTrue: [in next]]. "skip"
		ch = Character lf ifTrue: [ch := Character cr].
		out nextPut: ch].
	^self new
		source: aString;
		inputStream: out contents readStream;
		outputStream: aStream;
		render.! !

!HtmlRender methodsFor: 'streaming' stamp: ' 21/4/07 22:07'!
!!= anObject 
	self
		,= anObject;
		cr.
	^anObject! !

!HtmlRender methodsFor: 'streaming' stamp: 'mivsek 6/11/2007 00:30'!
,= anObject
	anObject class == Character ifTrue: [^outputStream nextPut: anObject]. 
	outputStream nextPutAll: anObject
"	^anObject sendOver: outputStream"! !

!HtmlRender methodsFor: 'html-tags' stamp: ' 21/4/07 22:07'!
break
	self !!= '<br>'! !

!HtmlRender methodsFor: 'html-tags' stamp: ' 21/4/07 22:07'!
bulletList: aBlock 
	self startBulletList.
	aBlock value.
	self closeBulletList! !

!HtmlRender methodsFor: 'html-tags' stamp: ' 21/4/07 22:07'!
closeBulletList
	self !!= '</ul>'! !

!HtmlRender methodsFor: 'html-tags' stamp: ' 21/4/07 22:07'!
closeListItem
	self !!= '</li>'! !

!HtmlRender methodsFor: 'html-tags' stamp: ' 21/4/07 22:07'!
closeNumberList
	self !!= '</ol>'! !

!HtmlRender methodsFor: 'html-tags' stamp: ' 21/4/07 22:07'!
closeTableCell
	self !!= '</td>'! !

!HtmlRender methodsFor: 'streaming' stamp: ' 21/4/07 22:07'!
cr
	outputStream cr.! !

!HtmlRender methodsFor: 'html-tags' stamp: ' 21/4/07 22:07'!
heading: aBlock 
	self heading: aBlock level: 2! !

!HtmlRender methodsFor: 'html-tags' stamp: ' 21/4/07 22:07'!
heading: aBlock level: anInteger 
	self
		,= '<h';
		,= anInteger;
		,= ' ><font face="Arial" >'.
	aBlock value.
	self
		,= '</font></h';
		,= anInteger;
		!!= '>'! !

!HtmlRender methodsFor: 'html-tags' stamp: ' 21/4/07 22:07'!
horizontalRule
	self !!= '<hr >'! !

!HtmlRender methodsFor: 'html-tags' stamp: ' 21/4/07 22:07'!
inlineImage: aBlock 
	self ,= '<img src="'.
	aBlock value.
	self !!= '" border="0" >'! !

!HtmlRender methodsFor: 'initialize-release' stamp: ' 21/4/07 22:07'!
inputStream: aStream
	inputStream := aStream! !

!HtmlRender methodsFor: 'html-tags' stamp: ' 21/4/07 22:07'!
italicize: aBlock 
	self ,= '<i >'.
	aBlock value.
	self ,= '</i>'! !

!HtmlRender methodsFor: 'html-tags' stamp: ' 21/4/07 22:07'!
linkTo: urlBlock titled: titleBlock 
	self ,= '<a href="'.
	urlBlock value.
	self ,= '" >'.
	titleBlock value.
	self ,= '</a>'! !

!HtmlRender methodsFor: 'html-tags' stamp: ' 21/4/07 22:07'!
listItem: aBlock 
	self startListItem.
	aBlock value.
	self closeListItem! !

!HtmlRender methodsFor: 'initialize-release' stamp: ' 21/4/07 22:07'!
outputStream: aStream
	outputStream := aStream! !

!HtmlRender methodsFor: 'html-tags' stamp: ' 21/4/07 22:07'!
paragraph
	self !!= '<p >'! !

!HtmlRender methodsFor: 'html-tags' stamp: ' 21/4/07 22:07'!
precise: aBlock 
	self ,= '<pre >'.
	aBlock value.
	self !!= '</pre>'! !

!HtmlRender methodsFor: 'acessing' stamp: ' 21/4/07 22:07'!
source
	"a source text to be parsed"
	^source! !

!HtmlRender methodsFor: 'private' stamp: ' 21/4/07 22:07'!
source: aString
	source := aString! !

!HtmlRender methodsFor: 'streaming' stamp: ' 21/4/07 22:07'!
space
	outputStream space! !

!HtmlRender methodsFor: 'html-tags' stamp: ' 21/4/07 22:07'!
startBulletList
	self ,= '<ul >'! !

!HtmlRender methodsFor: 'html-tags' stamp: ' 21/4/07 22:07'!
startListItem
	self ,= '<li >'! !

!HtmlRender methodsFor: 'html-tags' stamp: ' 21/4/07 22:07'!
startNumberList
	self ,= '<ol >'! !

!HtmlRender methodsFor: 'html-tags' stamp: ' 21/4/07 22:07'!
startTableCell: align 
	self ,= '<td align="'.
	self ,= align.
	self ,= '" >'! !

!HtmlRender methodsFor: 'html-tags' stamp: ' 21/4/07 22:07'!
startTableRow
	self startTableRow: 'center'! !

!HtmlRender methodsFor: 'html-tags' stamp: ' 21/4/07 22:07'!
startTableRow: align 
	self ,= '<tr >'.
	self startTableCell: align! !

HtmlRender subclass: #WikiRender
	instanceVariableNames: 'mode currentChar lastChar headingLevel inTable bulletLevel numberLevel inBold other'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scribo-Wiki'!

!WikiRender commentStamp: '<historical>' prior: 0!
Renders input in Wiki syntax to Html output.

Thanks to WikiWorks authors for original code, which is adopted here!!

Instance Variables:
	bulletLevel	<Number>
	currentChar	<Char>	
	headingLevel	<Number>
	inTable	<Boolean>	
	lastChar	<Boolean>	
	numberLevel	<Number>

!

!WikiRender class methodsFor: 'instance creation' stamp: 'np 1/23/2008 09:39'!
exceptLinksFrom: aString
	"render aString in Wiki syntax (leave links in square brackets intact) and return Html string"
	| stream |
	stream := WriteStream on: String new.
	self exceptLinksFrom: aString into: stream.
	^stream contents! !

!WikiRender class methodsFor: 'instance creation' stamp: 'np 8/17/2008 17:55'!
exceptLinksFrom: aString for: aDocument
	"aDocument is needed to keep a reference for Galleries and such Scriblets. Do not use it if you don't need it."
	"render aString in Wiki syntax (leave links in square brackets intact) and return Html string"
	| stream |
	stream := WriteStream on: String new.
	self exceptLinksFrom: aString into: stream for: aDocument.
	^stream contents! !

!WikiRender class methodsFor: 'instance creation' stamp: 'np 1/23/2008 09:40'!
exceptLinksFrom: aString into: aStream
	self new
		source: aString;
		inputStream: (aString copyWithout: Character lf) readStream;
		outputStream: aStream;
		setExceptLinksMode;
		render.! !

!WikiRender class methodsFor: 'instance creation' stamp: 'np 8/17/2008 17:55'!
exceptLinksFrom: aString into: aStream for: aDocument
	"aDocument is needed to keep a reference for Galleries and such Scriblets. Do not use it if you don't need it."
	self new
		source: aString;
		document: aDocument;
		inputStream: (aString copyWithout: Character lf) readStream;
		outputStream: aStream;
		setExceptLinksMode;
		render.! !

!WikiRender class methodsFor: 'instance creation' stamp: 'np 8/17/2008 17:55'!
from: aString for: aDocument
	"aDocument is needed to keep a reference for Galleries and such Scriblets. Do not use it if you don't need it."
	"render aString in Wiki syntax and return Html string"
	| stream |
	stream := WriteStream on: String new.
	self from: aString into: stream for: aDocument.
	^stream contents! !

!WikiRender class methodsFor: 'instance creation' stamp: 'np 8/17/2008 17:55'!
from: aString into: aStream for: aDocument
	"aDocument is needed to keep a reference for Galleries and such Scriblets. Do not use it if you don't need it."
	"only cr, convert cr-lf or lf to cr"
	| in out ch |
	
	in := aString readStream. out := (String new: aString size) writeStream.
	[in atEnd] whileFalse:
		[ch := in next. 
		ch = Character cr ifTrue: [in peek = Character lf ifTrue: [in next]]. "skip"
		ch = Character lf ifTrue: [ch := Character cr].
		out nextPut: ch].
	^self new
		source: aString;
		document: aDocument;
		inputStream: out contents readStream;
		outputStream: aStream;
		render.! !

!WikiRender class methodsFor: 'instance creation' stamp: 'np 1/23/2008 09:40'!
linksOnlyFrom: aString
	"render aString in Wiki syntax (links in square brackets only) and return Html string"
	| stream |
	stream := WriteStream on: String new.
	self linksOnlyFrom: aString into: stream.
	^stream contents! !

!WikiRender class methodsFor: 'instance creation' stamp: 'np 8/17/2008 17:55'!
linksOnlyFrom: aString for: aDocument
	"aDocument is needed to keep a reference for Galleries and such Scriblets. Do not use it if you don't need it."
	"render aString in Wiki syntax (links in square brackets only) and return Html string"
	| stream |
	stream := WriteStream on: String new.
	self linksOnlyFrom: aString into: stream for: aDocument.
	^stream contents! !

!WikiRender class methodsFor: 'instance creation' stamp: 'np 1/23/2008 09:40'!
linksOnlyFrom: aString into: aStream
	self new
		source: aString;
		inputStream: (aString copyWithout: Character lf) readStream;
		outputStream: aStream;
		setLinksOnlyMode;
		render.! !

!WikiRender class methodsFor: 'instance creation' stamp: 'np 8/17/2008 17:55'!
linksOnlyFrom: aString into: aStream for: aDocument
	"aDocument is needed to keep a reference for Galleries and such Scriblets. Do not use it if you don't need it."
	self new
		source: aString;
		document: aDocument;
		inputStream: (aString copyWithout: Character lf) readStream;
		outputStream: aStream;
		setLinksOnlyMode;
		render.! !

!WikiRender methodsFor: 'parsing' stamp: ' 21/4/07 22:07'!
addCurrentChar
	self ,= currentChar! !

!WikiRender methodsFor: 'private' stamp: 'np 1/23/2008 09:56'!
allowed: aString
	"access allowed to that page?"
	| app |
	(self exist: aString) ifFalse: [^true]. "we need link to create a new page"
	app := self app. (app isKindOf: WikiPageApp) ifFalse: [^true].
	^(app wiki pageTitled: aString) isAccessAllowedFor: self app user.! !

!WikiRender methodsFor: 'private' stamp: ' 21/4/07 22:07'!
app
	"try to find a first sender up in calling stack, who is  WebApplication"
	^self firstAppFromStack! !

!WikiRender methodsFor: 'parsing states' stamp: ' 21/4/07 22:07'!
atLineStart
	^lastChar == Character cr! !

!WikiRender methodsFor: 'parsing' stamp: ' 21/4/07 22:07'!
closeBullets
	self closeListItem.
	inputStream peek = $* ifFalse: 
		[bulletLevel timesRepeat: [self closeBulletList].
		self resetBullets]! !

!WikiRender methodsFor: 'parsing' stamp: ' 21/4/07 22:07'!
closeHeading
	self
		,= '</h';
		,= headingLevel printString;
		!!= '>'.
	self resetHeading! !

!WikiRender methodsFor: 'parsing' stamp: ' 21/4/07 22:07'!
closeNumbers
	self closeListItem.
	inputStream peek = $# ifFalse: 
		[numberLevel timesRepeat: [self closeNumberList].
		self resetNumbers]! !

!WikiRender methodsFor: 'parsing' stamp: ' 21/4/07 22:07'!
closeTableRow
	self closeTableCell.
	self !!= '</tr>'.
	((inputStream peekForAll: '||') 
		or: [(inputStream peekForAll: '|{') or: [inputStream peekForAll: '|}']]) 
			ifTrue: 
				[inputStream skip: -2.
				^self].
	self !!= '</table>'.
	self notInTable! !

!WikiRender methodsFor: 'private' stamp: 'np 8/17/2008 17:21'!
document
	^self otherAt: #document ifAbsent: [nil]! !

!WikiRender methodsFor: 'private' stamp: 'np 8/17/2008 17:21'!
document: aDocument
	self otherAt: #document put: aDocument! !

!WikiRender methodsFor: 'private' stamp: 'janko 3/16/2008 22:57'!
exist: aString
	| app |
	app := self app. app isNil ifTrue: [^false].
	(app isKindOf: WikiPageApp) |
	(app class == BlogApp) | (app class == BlogPostApp) ifTrue: [^self existWikiPage: aString].
	((app observee respondsTo: #repository) and: [app observee repository notNil]) ifTrue:
		[(app observee repository docFinder documentWithIdAndTitle: aString) notNil ifTrue: [^true].
		(self recordFor: aString) notNil ifTrue: [^true] ].
	^false! !

!WikiRender methodsFor: 'private' stamp: 'np 1/23/2008 09:55'!
existWikiPage: aString
	^(self app wiki pageTitled: aString) notNil.! !

!WikiRender methodsFor: 'parsing' stamp: ' 21/4/07 22:07'!
getNextChar
	lastChar := currentChar.
	currentChar := inputStream next! !

!WikiRender methodsFor: 'parsing states' stamp: ' 21/4/07 22:07'!
inBold
	^inBold! !

!WikiRender methodsFor: 'parsing states' stamp: ' 21/4/07 22:07'!
inBullets
	^bulletLevel > 0! !

!WikiRender methodsFor: 'accessing-mode' stamp: ' 21/4/07 22:07'!
inExceptLinksMode
	"parse all but leave links in square brackets intact"
	^self mode == #exceptLinks! !

!WikiRender methodsFor: 'accessing-mode' stamp: ' 21/4/07 22:07'!
inFullMode
	"full wiki syntax parsing - default"
	^self mode == #full! !

!WikiRender methodsFor: 'parsing states' stamp: ' 21/4/07 22:07'!
inHeading
	^headingLevel > 0! !

!WikiRender methodsFor: 'accessing-mode' stamp: ' 21/4/07 22:07'!
inLinksOnlyMode
	"only links in square brackets parsing"
	^self mode == #linksOnly! !

!WikiRender methodsFor: 'parsing states' stamp: ' 21/4/07 22:07'!
inNumbers
	^numberLevel > 0! !

!WikiRender methodsFor: 'parsing states' stamp: ' 21/4/07 22:07'!
inTable
	^inTable! !

!WikiRender methodsFor: 'parsing states' stamp: ' 21/4/07 22:07'!
isInBold
	inBold := true! !

!WikiRender methodsFor: 'parsing states' stamp: ' 21/4/07 22:07'!
isInTable
	inTable := true! !

!WikiRender methodsFor: 'private' stamp: ' 21/4/07 22:07'!
mode
	mode isNil ifTrue: [self setFullMode].
	^mode! !

!WikiRender methodsFor: 'private' stamp: ' 21/4/07 22:07'!
mode: aSymbol
	mode := aSymbol! !

!WikiRender methodsFor: 'parsing states' stamp: ' 21/4/07 22:07'!
notInBold
	inBold := false! !

!WikiRender methodsFor: 'parsing states' stamp: ' 21/4/07 22:07'!
notInTable
	inTable := false! !

!WikiRender methodsFor: 'private' stamp: 'np 1/26/2008 16:53'!
other
	"If you extend WikiRender, user other to store variables"
	other isNil ifTrue: [other := Dictionary new].
	^other! !

!WikiRender methodsFor: 'private' stamp: 'np 1/26/2008 16:51'!
otherAt: aSymbol
	"other values"
	^self otherAt: aSymbol ifAbsent: [nil]! !

!WikiRender methodsFor: 'private' stamp: 'np 1/26/2008 17:01'!
otherAt: aSymbol ifAbsent: aBlock
	"other values"
	^self other at: aSymbol ifAbsent: aBlock! !

!WikiRender methodsFor: 'private' stamp: 'np 1/26/2008 17:01'!
otherAt: aSymbol ifAbsentPut: aBlock
	^self other at: aSymbol ifAbsent: [self other at: aSymbol put: aBlock value]! !

!WikiRender methodsFor: 'private' stamp: 'np 1/26/2008 17:01'!
otherAt: aSymbol put: anObject
	^self other at: aSymbol put: anObject! !

!WikiRender methodsFor: 'parsing' stamp: ' 21/4/07 22:07'!
processAsterix
	| currentLevel |
	self atLineStart ifFalse: 
		[self inBold ifTrue: [self ,= '</b>'. ^self notInBold] ifFalse: [self ,= '<b>'. ^self isInBold]].
	self inBullets ifTrue: [self closeListItem].
	currentLevel := 1.
	[inputStream peekFor: $*] whileTrue: [currentLevel := currentLevel + 1].
	bulletLevel - currentLevel timesRepeat: [self closeBulletList].
	currentLevel - bulletLevel timesRepeat: [self startBulletList].
	self startListItem.
	bulletLevel := currentLevel! !

!WikiRender methodsFor: 'parsing' stamp: ' 21/4/07 22:07'!
processBang
	self atLineStart 
		ifTrue: [self processHeadingLevel]
		ifFalse: [self addCurrentChar]! !

!WikiRender methodsFor: 'parsing' stamp: ' 21/4/07 22:07'!
processCR
	self inHeading ifTrue: [^self closeHeading].
	self inTable ifTrue: [^self closeTableRow].
"	self atLineStart ifFalse: [^self space]. " "break always!! "
	self inBullets ifTrue: [^self closeBullets].
	self inNumbers ifTrue: [^self closeNumbers].
	self break! !

!WikiRender methodsFor: 'parsing' stamp: 'np 3/15/2008 00:33'!
processCurrentChar
	(self inFullMode | self inExceptLinksMode ) ifTrue:
		[currentChar == $\ ifTrue: [^self processEscape].
		currentChar == Character space ifTrue: [^self processSpace].
		currentChar == Character tab ifTrue: [^self processSpace].
		currentChar == Character cr ifTrue: [^self processCR].
		currentChar == $< ifTrue: [^self processLeftAngle].
		currentChar == $* ifTrue: [^self processAsterix].
		currentChar == $# ifTrue: [^self processPound].
		currentChar == $~ ifTrue: [^self processTilde].
		currentChar == $- ifTrue: [^self processDash].
		currentChar == $!! ifTrue: [^self processBang].
		currentChar == $| ifTrue: [^self processPipe] ].
	self inExceptLinksMode not ifTrue:
		[currentChar == $[ ifTrue: [^self processLeftBracket].
		currentChar == ${ ifTrue: [^self processLeftBrace] ]. 

	self addCurrentChar! !

!WikiRender methodsFor: 'parsing' stamp: ' 21/4/07 22:07'!
processDash
	(self atLineStart and: [inputStream peekForAll: '---']) 
		ifFalse: [^self addCurrentChar].
	inputStream skipThrough: Character cr.
	currentChar := Character cr.
	self horizontalRule! !

!WikiRender methodsFor: 'parsing' stamp: ' 21/4/07 22:07'!
processEscape
	self getNextChar.
	self addCurrentChar! !

!WikiRender methodsFor: 'parsing' stamp: ' 21/4/07 22:07'!
processHeadingLevel
	headingLevel := headingLevel + 1.
	(inputStream peekFor: $!!) ifTrue: [^self processHeadingLevel].
	self
		,= '<h';
		,= headingLevel printString;
		,= '>'! !

!WikiRender methodsFor: 'parsing' stamp: ' 21/4/07 22:07'!
processLeftAngle
	self addCurrentChar.
	(inputStream insensitivePeekForAll: 'PRE') ifFalse: [^self].
	self ,= 'pre'.
	
	[inputStream atEnd or: 
			[| closeTag |
			closeTag := inputStream through: $>.
			self ,= closeTag.
			closeTag sameAs: '/pre>']] 
			whileFalse: [self ,= (inputStream through: $<)].
	currentChar := $>! !

!WikiRender methodsFor: 'parsing' stamp: ' 21/4/07 22:07'!
processLeftBrace
	| include |
	(inputStream peekFor: ${ ) ifTrue: [^self addCurrentChar]. "to escape, put two {{"
	include := (WikiInclude on: self) contents: (inputStream upTo: $} escaper: $\).
	^self ,= include asHtml! !

!WikiRender methodsFor: 'parsing' stamp: 'np 1/23/2008 10:06'!
processLeftBracket
	| link url exist urlTitle |
	(inputStream peekFor: $[) ifTrue: [^self addCurrentChar].
	link := WikiLink new contents: (inputStream upTo: $] escaper: $\).
"	link isImage ifTrue: 
		[^self inlineImage: [link isExternalLink ifFalse: [self fileServerURL: targetHandler].
		self ,= link address]]. "
	link isExternalLink ifTrue: [^self linkTo: [self ,= link address] titled: [self ,= link name]].
	url := self urlFor: link address. exist := self exist: link address.
	(self allowed: link address) ifFalse: 
		[^self ,= ('<span style={color:lightgrey}>', link name, '</span>')].
	urlTitle := (exist ifFalse: ['<i>'] ifTrue: ['']), link name, (exist ifFalse: ['</i>'] ifTrue: ['']).
	url notNil ifTrue: [^self linkTo: [self ,= url] titled: [self ,=urlTitle] ].
	^self ,= link name! !

!WikiRender methodsFor: 'parsing' stamp: ' 21/4/07 22:07'!
processMethod: link 
	| class className selector |
	className := link name.
	class := [Compiler evaluate: className] on: Error
				do: [:ex | ex return: nil].
	selector := link address.
	(class isBehavior and: [class canUnderstand: selector]) 
		ifTrue: [^self processMethodSelector: selector ofClass: class].
	self italicise: 
			[self ,= className.
			self ,= '>>#'.
			self ,= selector]! !

!WikiRender methodsFor: 'parsing' stamp: ' 21/4/07 22:07'!
processMethodSelector: selector ofClass: class 
	| source realClass |
	realClass := (class includesSelector: selector) 
				ifTrue: [class]
				ifFalse: [class whichClassIncludesSelector: selector].
	source := realClass sourceCodeAt: selector.
	self precise: 
			[self ,= class.
			class == realClass 
				ifFalse: 
					[self ,= $(.
					self ,= realClass.
					self ,= $)].
			self ,= '>>#'.
			self ,= source]! !

!WikiRender methodsFor: 'parsing' stamp: ' 21/4/07 22:07'!
processPipe
	| align |
	(inputStream peekFor: $|) ifTrue: [align := 'center'].
	(inputStream peekFor: ${) ifTrue: [align := 'left'].
	(inputStream peekFor: $}) ifTrue: [align := 'right'].
	align ifNil: [^self addCurrentChar].
	self atLineStart 
		ifFalse: 
			[^self inTable 
				ifTrue: 
					[self closeTableCell.
					self startTableCell: align]
				ifFalse: [self ,= '||']].
	self inTable 
		ifFalse: [self !!= '<table class="wikiTable">'].
	self startTableRow: align.
	self isInTable! !

!WikiRender methodsFor: 'parsing' stamp: ' 21/4/07 22:07'!
processPound
	| currentLevel |
	self atLineStart ifFalse: [^self addCurrentChar].
	self inNumbers ifTrue: [self closeListItem].
	currentLevel := 1.
	[inputStream peekFor: $#] whileTrue: [currentLevel := currentLevel + 1].
	numberLevel - currentLevel timesRepeat: [self closeNumberList].
	currentLevel - numberLevel timesRepeat: [self startNumberList].
	self startListItem.
	numberLevel := currentLevel! !

!WikiRender methodsFor: 'parsing' stamp: ' 21/8/07 09:38'!
processSpace
	self atLineStart ifFalse: [lastChar := currentChar. ^self space].
	inputStream atEnd ifFalse: [self getNextChar].
	lastChar := Character space.
"	lastChar := Character cr. "
	self processCurrentChar! !

!WikiRender methodsFor: 'parsing' stamp: ' 21/4/07 22:07'!
processTilde
	self atLineStart ifTrue: [self break] ifFalse: [self addCurrentChar]! !

!WikiRender methodsFor: 'rendering' stamp: 'np 1/26/2008 19:03'!
render
	"convert Wiki text in inputStream into Html outputStream"
	self resetParsingStates.
	[inputStream atEnd] whileFalse: 
		[self getNextChar. self processCurrentChar].
	lastChar := currentChar := Character cr.
	self processCurrentChar.! !

!WikiRender methodsFor: 'parsing states' stamp: ' 21/4/07 22:07'!
resetBullets
	bulletLevel := 0! !

!WikiRender methodsFor: 'parsing states' stamp: ' 21/4/07 22:07'!
resetHeading
	headingLevel := 0! !

!WikiRender methodsFor: 'parsing states' stamp: ' 21/4/07 22:07'!
resetNumbers
	numberLevel := 0! !

!WikiRender methodsFor: 'parsing states' stamp: ' 21/4/07 22:07'!
resetParsingStates
	currentChar := Character cr.
	self resetHeading.
	self resetBullets.
	self resetNumbers.
	self notInTable.
	self notInBold.! !

!WikiRender methodsFor: 'accessing-mode' stamp: ' 21/4/07 22:07'!
setExceptLinksMode
	"parse all but leave links in square brackets intact"
	^self mode: #exceptLinks! !

!WikiRender methodsFor: 'accessing-mode' stamp: ' 21/4/07 22:07'!
setFullMode
	"full wiki syntax parsing - default"
	self mode: #full! !

!WikiRender methodsFor: 'accessing-mode' stamp: ' 21/4/07 22:07'!
setLinksOnlyMode
	"only links in square brackets parsing"
	self mode: #linksOnly! !

!WikiRender methodsFor: 'private' stamp: 'np 1/23/2008 16:45'!
urlFor: aString
	"find an url for an object with a specificied name (eg. a document with that name)"
	| app doc record |
	app := self app. app isNil ifTrue: [^nil].
	((app isKindOf: WikiPageApp) | (app isKindOf: WikiApp)) ifTrue: [^self wikiPageUrlFor: aString].
	((app observee respondsTo: #repository) and: [app observee repository notNil]) ifTrue: 
		[doc := app observee repository docFinder documentWithIdAndTitle: aString].  "BiArt specific"
	doc notNil ifTrue: [^app site urlResolver halfUrlFor: doc].
	record := self recordFor: aString. 
	record notNil ifTrue: [^app site urlResolver halfUrlFor: record].
	^nil! !

!WikiRender methodsFor: 'private' stamp: 'janko 3/16/2008 23:37'!
wikiPageUrlFor: aString
	"if exist, return wiki page url,otherwise url to add new page"
	"BiArt specific!! "
	| app page title |
	app := self app. page := app wiki pageTitled: aString. 
	page notNil ifTrue: [^app site urlResolver halfUrlFor: page].
	title := (AIDASite convertToWebString: (AIDASite convert: aString toCodepage: #'iso8859-2') ).
"	title := title copyReplaceAll: '+' with: ' '."
	^(app site urlResolver halfUrlFor: app wiki), '?view=add&title=',  title! !

!Object methodsFor: '*Scribo-Blog' stamp: 'np 1/24/2008 08:25'!
isBlog
	^false! !

!Object methodsFor: '*Scribo-Blog' stamp: 'np 1/24/2008 08:25'!
isBlogComment
	^false! !

!Object methodsFor: '*Scribo-Blog' stamp: 'np 1/24/2008 08:25'!
isBlogPost
	^false! !

Object subclass: #Repository
	instanceVariableNames: 'eventLog root settings support site other'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scribo-Core'!

!Repository class methodsFor: 'accessing' stamp: 'np 1/17/2008 18:23'!
default
	^AIDASite default repository! !

!Repository class methodsFor: 'instance creation' stamp: 'np 6/23/2008 00:20'!
new
	^self basicNew initialize! !

!Repository class methodsFor: 'instance creation' stamp: 'np 6/23/2008 00:20'!
newOnSite: aSite
	^self new 
		site: aSite; 
		yourself! !

!Repository methodsFor: 'settings' stamp: 'np 1/17/2008 18:07'!
adminEMail
	^self settingsAt: #AdminEMail ifAbsent: ['']! !

!Repository methodsFor: 'settings' stamp: 'np 1/17/2008 18:07'!
adminEMail: aString
	self settingsAt: #AdminEMail put: aString! !

!Repository methodsFor: '*Scribo-Blog' stamp: 'np 4/1/2008 19:57'!
blog
	| blog |
	^self pluginsAt: #blog ifAbsent: [
		blog := Blog newOn: self site.
		self site urlResolver defaultURL: '/blog.html' forObject: blog.
		self pluginsAt: #blog put: blog.
		^blog]! !

!Repository methodsFor: 'settings' stamp: 'janko 7/30/2008 22:35'!
emailSMTPServer
	^self settingsAt: #SMTPServer ifAbsent: ['']! !

!Repository methodsFor: 'settings' stamp: 'janko 7/30/2008 22:35'!
emailSMTPServer: aString
	self settingsAt: #SMTPServer put: aString! !

!Repository methodsFor: 'accessing' stamp: 'np 3/29/2008 05:17'!
eventLog
	eventLog isNil ifTrue: [self initEventLog].
	^eventLog! !

!Repository methodsFor: 'accessing' stamp: 'np 1/17/2008 10:59'!
folderWithName: aString
	"search for this folder through hierarchy starting from root"
	^self root folderWithName: aString! !

!Repository methodsFor: 'accessing' stamp: 'np 1/17/2008 10:59'!
folderWithUuid: aString
	"search for this folder through hierarchy starting from root"
	^self root folderWithUuid: aString! !

!Repository methodsFor: '*Scribo-Forum' stamp: 'np 4/1/2008 19:57'!
forum
	| forum |
	^self pluginsAt: #forum ifAbsent: [
		forum := WebForum new.
		self site urlResolver defaultURL: '/discussions.html' forObject: forum.
		self pluginsAt: #forum put: forum.
		^forum]! !

!Repository methodsFor: 'initialize-release' stamp: 'np 1/18/2008 16:02'!
initDefaultContent
	self root addFolder: (Folder newNamed: 'Procesi') setProcessFolder.
	self root addFolderNamed: 'Navodila'.
	self root addFolder: (Folder newNamed: 'Obrazci') setTemplateFolder.
	self root addFolderNamed: 'Ostalo'.! !

!Repository methodsFor: 'initialize-release' stamp: 'np 3/29/2008 05:17'!
initEventLog
	eventLog := EventLog newOn: self.! !

!Repository methodsFor: 'initialize-release' stamp: 'janko 7/30/2008 22:36'!
initMessenger
	self supportAt: #EMailMessenger put: (EMailMessenger newOn: self)! !

!Repository methodsFor: 'initialize-release' stamp: 'np 1/17/2008 10:56'!
initNumberer
	self supportAt: #Numberer put: Numberer new.! !

!Repository methodsFor: 'initialize-release' stamp: 'np 1/26/2008 12:27'!
initOther
	other := Dictionary new! !

!Repository methodsFor: 'initialize-release' stamp: 'np 1/17/2008 10:56'!
initRoot
	root := Folder new name: 'Dokumentacija'; parent: self.! !

!Repository methodsFor: 'initialize-release' stamp: 'np 1/17/2008 10:56'!
initSettings
	settings := Dictionary new.! !

!Repository methodsFor: 'initialize-release' stamp: 'np 1/17/2008 10:56'!
initSupport
	support := Dictionary new.! !

!Repository methodsFor: 'initialize-release' stamp: 'np 1/20/2008 12:34'!
initialize
	self initRoot.
	self initDefaultContent.
	self initSettings.
	self initSupport! !

!Repository methodsFor: 'testing' stamp: 'np 1/17/2008 18:21'!
isRepository
	^true! !

!Repository methodsFor: 'support' stamp: 'janko 7/30/2008 22:36'!
messenger
	"deals with sending bulk of emails"
	^self supportAt: #EMailMessenger ifAbsent: [self initMessenger. self messenger].! !

!Repository methodsFor: 'support' stamp: 'np 1/17/2008 18:20'!
numberer
	"counters for things like invoice numbers"
	^self supportAt: #Numberer ifAbsent: [self initNumberer. self numberer].! !

!Repository methodsFor: 'private' stamp: 'np 1/20/2008 15:34'!
other
	^other! !

!Repository methodsFor: 'private' stamp: 'np 1/20/2008 15:34'!
otherAt: aSymbol
	"other values"
	^self otherAt: aSymbol ifAbsent: [nil]! !

!Repository methodsFor: 'private' stamp: 'np 1/20/2008 15:34'!
otherAt: aSymbol ifAbsent: aBlock
	"other values"
	self other isNil ifTrue: [^aBlock value].
	^self other at: aSymbol ifAbsent: aBlock! !

!Repository methodsFor: 'private' stamp: 'np 1/20/2008 15:34'!
otherAt: aSymbol ifAbsentPut: aBlock
	self other isNil ifTrue: [self initOther].
	^self other at: aSymbol ifAbsent: [self other at: aSymbol put: aBlock value]! !

!Repository methodsFor: 'private' stamp: 'np 1/20/2008 15:34'!
otherAt: aSymbol put: anObject
	self other isNil ifTrue: [self initOther].
	^self other at: aSymbol put: anObject! !

!Repository methodsFor: 'private' stamp: 'np 4/1/2008 19:52'!
plugins
	^self otherAt: #plugins ifAbsentPut: [Dictionary new]! !

!Repository methodsFor: 'private' stamp: 'np 4/1/2008 19:54'!
pluginsAt: aSymbol
	^self pluginsAt: aSymbol ifAbsent: [nil]! !

!Repository methodsFor: 'private' stamp: 'np 4/1/2008 19:53'!
pluginsAt: aSymbol ifAbsent: aBlock
	^self plugins at: aSymbol ifAbsent: aBlock! !

!Repository methodsFor: 'private' stamp: 'np 4/1/2008 19:53'!
pluginsAt: aSymbol ifAbsentPut: aBlock
	^self plugins at: aSymbol ifAbsent: [self plugins at: aSymbol put: aBlock value]! !

!Repository methodsFor: 'private' stamp: 'np 4/1/2008 19:54'!
pluginsAt: aSymbol put: anObject
	^self plugins at: aSymbol put: anObject! !

!Repository methodsFor: 'private' stamp: 'np 1/17/2008 18:21'!
preferedUrl
	^'/repository.html'! !

!Repository methodsFor: 'private' stamp: 'np 1/17/2008 18:21'!
printString
	^'aRepository on site: ', (self site notNil ifTrue: [self site name] ifFalse: [''])! !

!Repository methodsFor: 'private' stamp: 'np 1/17/2008 18:21'!
reconnectAllRepositoriesToSites
	"Repository new reconnectAllRepositoriesToSites"
	AIDASite allInstances do: [:each | (each userServiceNamed: #Repository) notNil
		ifTrue: [each repository site: each]]! !

!Repository methodsFor: 'accessing' stamp: 'np 1/17/2008 11:03'!
repository
	^self! !

!Repository methodsFor: 'accessing' stamp: 'np 1/17/2008 11:03'!
root
	"root folder"
	root isNil ifTrue: [self initRoot].
	^root! !

!Repository methodsFor: 'settings' stamp: 'np 1/22/2008 17:41'!
rootDirectory
	"default dir is 'repository-<site name>' "
	"Repository default rootDirectory "
	| dir |
	^self settingsAt: #rootDirectory ifAbsent: 
		[dir := 'repository-', self site name.
		(SpFilename named: dir) asAbsoluteFilename makeDirectory.
		self rootDirectory: dir.
		dir]! !

!Repository methodsFor: 'settings' stamp: 'np 1/17/2008 18:17'!
rootDirectory: aString
	self settingsAt: #rootDirectory put: aString! !

!Repository methodsFor: 'private' stamp: 'np 1/17/2008 18:21'!
settings
	settings isNil ifTrue: [self initSettings].
	^settings! !

!Repository methodsFor: 'private' stamp: 'np 1/17/2008 18:22'!
settingsAt: aSymbol
	^self settingsAt: aSymbol ifAbsent: [nil]! !

!Repository methodsFor: 'private' stamp: 'np 1/17/2008 18:22'!
settingsAt: aSymbol ifAbsent: aBlock
	^self settings at: aSymbol ifAbsent: aBlock! !

!Repository methodsFor: 'private' stamp: 'np 1/17/2008 18:22'!
settingsAt: aSymbol put: aValue
	^self settings at: aSymbol put: aValue! !

!Repository methodsFor: 'accessing' stamp: 'np 1/17/2008 11:03'!
site
	^site! !

!Repository methodsFor: 'private' stamp: 'np 1/17/2008 18:22'!
site: aSite
	site := aSite! !

!Repository methodsFor: '*Scribo-Sites' stamp: 'np 4/1/2008 19:57'!
siteContent
	| siteContent |
	^self pluginsAt: #siteContent ifAbsent: [
		siteContent := SiteContent newOn: self site.
		self site urlResolver defaultURL: '/site.html' forObject: siteContent.
		self pluginsAt: #siteContent put: siteContent.
		^siteContent]! !

!Repository methodsFor: 'start/stop' stamp: 'np 1/20/2008 13:19'!
start
	! !

!Repository methodsFor: 'start/stop' stamp: 'np 1/17/2008 18:18'!
stop
	"self messenger stopReceiving."! !

!Repository methodsFor: 'private' stamp: 'np 1/17/2008 18:22'!
support
	"support helpers like docFinder etc"
	support isNil ifTrue: [self initSupport].
	^support! !

!Repository methodsFor: 'private' stamp: 'np 1/17/2008 18:22'!
supportAt: aSymbol
	^self supportAt: aSymbol ifAbsent: [nil]! !

!Repository methodsFor: 'private' stamp: 'np 1/17/2008 18:22'!
supportAt: aSymbol ifAbsent: aBlock
	^self support at: aSymbol ifAbsent: aBlock! !

!Repository methodsFor: 'private' stamp: 'np 1/17/2008 18:22'!
supportAt: aSymbol put: aValue
	self support at: aSymbol put: aValue! !

!Repository methodsFor: '*Scribo-Wiki' stamp: 'np 4/1/2008 19:57'!
wiki
	| wiki |
	^self pluginsAt: #wiki ifAbsent: [
		wiki := Wiki newOn: self site.
		self site urlResolver defaultURL: '/wiki.html' forObject: wiki.
		self pluginsAt: #wiki put: wiki.
		^wiki]! !

Object subclass: #WebForum
	instanceVariableNames: 'discussions newest introduction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scribo-Forum'!

!WebForum class methodsFor: 'accessing' stamp: 'np 1/30/2008 16:07'!
default
	^AIDASite default userServiceNamed: #WebForum! !

!WebForum class methodsFor: 'instance creation' stamp: 'np 1/30/2008 16:07'!
fileInFrom: aFilenameString

	| stream boss new |
	stream := aFilenameString asFilename readStream.
	boss := BinaryObjectStorage onOld: stream.
	new := boss next.
	boss close.
	^new.

"WebDiscussions fileInFrom: 'discussions.boss' "! !

!WebForum class methodsFor: 'odb private' stamp: 'np 1/30/2008 16:07'!
needsDataVerification
	"Do not alter. Added automatically."
	^true! !

!WebForum class methodsFor: 'instance creation' stamp: 'np 1/30/2008 16:07'!
new
	^super new initialize! !

!WebForum methodsFor: 'adding-removing' stamp: 'np 1/30/2008 16:06'!
addDiscussionsResponse: aWebDiscussionsMessage user: aWebUser
	"add a new action event to the actions, if not already exist"
	(self forum includes: aWebDiscussionsMessage) ifTrue: [^nil].
	self forum	add: aWebDiscussionsMessage.
	aWebDiscussionsMessage 
		parent: self;
		timestamp: SpTimestamp now;
		user: aWebUser.
	self addToNewest: aWebDiscussionsMessage.! !

!WebForum methodsFor: 'adding-removing' stamp: 'np 1/30/2008 16:06'!
addToNewest: aWebDiscussionResponse
	(self newest includes: aWebDiscussionResponse) ifFalse:
		[self newest addFirst: aWebDiscussionResponse.
		self newest size > 10 ifTrue: [self newest removeLast] ].! !

!WebForum methodsFor: 'accessing' stamp: 'np 1/30/2008 16:05'!
allParents
	^#()! !

!WebForum methodsFor: 'adding-removing' stamp: 'np 1/30/2008 16:06'!
deleteDiscussionsResponse: aWebDiscussionsMessage
	"delete this  response"
	aWebDiscussionsMessage responses notEmpty ifTrue: [^nil].
	self forum remove: aWebDiscussionsMessage ifAbsent: [^nil].
	aWebDiscussionsMessage parent: nil.
	self removeFromNewest: aWebDiscussionsMessage.! !

!WebForum methodsFor: 'import-export' stamp: 'np 1/30/2008 16:06'!
fileOutTo: aFilenameString

	| stream boss |
	stream := aFilenameString asFilename writeStream.
	boss := BinaryObjectStorage onNew: stream.
	boss nextPut: self.
	boss close.

"WebDiscussions default fileOutTo: 'discussions.boss' "! !

!WebForum methodsFor: 'accessing' stamp: 'np 1/30/2008 16:05'!
forum
	discussions isNil ifTrue: [self initDiscussions].
	^discussions.! !

!WebForum methodsFor: 'initialize-release' stamp: 'np 1/30/2008 16:03'!
initDefaultIntroduction
	"(AIDASite named: 'test') discussions initDefaultIntroduction"
	self introduction: '!!!!Congratulations!!
You just started your AIDA/Web Smalltalk Web Application Server. Here you can look at several demos (see navigation bar at the left), you are just reading a simple forum with discussions and top left are links to main website, where you can find more information. 
You are encougared to:
*look at *Screenshots* to see, what kind of complex web applications you can build with AIDA/Web,
*see *Tutorial* to build your first web application,
*read other *Documentation* to learn more (Architecture, Administrator''s guide, Programer''s guide, Ajax, Advanced features, Articles and presentations and more),
*join the *Development* community.
'! !

!WebForum methodsFor: 'initialize-release' stamp: 'np 1/30/2008 16:04'!
initDiscussions
	discussions := OrderedCollection new.! !

!WebForum methodsFor: 'initialize-release' stamp: 'np 1/30/2008 16:05'!
initNewest
	newest := OrderedCollection new.! !

!WebForum methodsFor: 'initialize-release' stamp: 'np 1/30/2008 16:04'!
initialize! !

!WebForum methodsFor: 'accessing' stamp: 'np 1/30/2008 16:05'!
introduction
	introduction isNil ifTrue: [self initDefaultIntroduction].
	^introduction! !

!WebForum methodsFor: 'accessing' stamp: 'np 1/30/2008 16:05'!
introduction: aString
	introduction := aString.! !

!WebForum methodsFor: 'accessing' stamp: 'np 1/30/2008 16:05'!
newest
	"list of newest reponses in all discusions"
	newest isNil ifTrue: [self initNewest].
	^newest

"WebServer default webDiscussions newest"! !

!WebForum methodsFor: 'adding-removing' stamp: 'np 1/30/2008 16:06'!
removeFromNewest: aWebDiscussionResponse
	self newest remove: aWebDiscussionResponse ifAbsent: []! !

Object subclass: #WebForumResponse
	instanceVariableNames: 'responses author authorsEmail body parent timestamp title user'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scribo-Forum'!

!WebForumResponse class methodsFor: 'initialize-release' stamp: 'np 1/30/2008 16:15'!
new
	^super new initialize.! !

!WebForumResponse methodsFor: 'adding-removing' stamp: 'np 1/30/2008 16:14'!
addDiscussionsResponse: aWebDiscussionsMessage user: aWebUser
	"add an empty dicussions response"
	 WebTransactionMonitor critical:
		[(self responses includes: aWebDiscussionsMessage) ifFalse:
			[self responses add: aWebDiscussionsMessage.
			aWebDiscussionsMessage
				parent: self;
				timestamp: SpTimestamp now;
				user: aWebUser.
			self top addToNewest: aWebDiscussionsMessage.
		"aWebDiscussionsMessage notifyNewResponse"] ].! !

!WebForumResponse methodsFor: 'accessing' stamp: 'np 1/30/2008 16:11'!
allParents
	
	| collection |
	collection := OrderedCollection new.
	self parent notNil ifTrue: 
		[collection add: self parent.
		collection addAllFirst: self parent allParents].
	^collection! !

!WebForumResponse methodsFor: 'accessing' stamp: 'np 1/30/2008 16:11'!
author
	author isNil ifTrue: [self author: ''].
	^author! !

!WebForumResponse methodsFor: 'accessing' stamp: 'np 1/30/2008 16:11'!
author: aString
	author := aString.! !

!WebForumResponse methodsFor: 'accessing' stamp: 'np 1/30/2008 16:12'!
authorsEmail
	authorsEmail isNil ifTrue: [self authorsEmail: ''].
	^authorsEmail! !

!WebForumResponse methodsFor: 'accessing' stamp: 'np 1/30/2008 16:12'!
authorsEmail: aString
	authorsEmail := aString.! !

!WebForumResponse methodsFor: 'accessing' stamp: 'np 1/30/2008 16:12'!
body
	body isNil ifTrue: [self body: ''].
	^body! !

!WebForumResponse methodsFor: 'accessing' stamp: 'np 1/30/2008 16:12'!
body: aString
	body := aString.! !

!WebForumResponse methodsFor: 'accessing' stamp: 'np 1/30/2008 16:12'!
date
	^self timestamp asDate! !

!WebForumResponse methodsFor: 'adding-removing' stamp: 'np 1/30/2008 16:14'!
deleteDiscussionsResponse: aWebDiscussionsMessage
	"delete this  response, if don't have subresponses"
	aWebDiscussionsMessage responses notEmpty ifTrue: [^nil].
	WebTransactionMonitor critical:
		[self responses remove: aWebDiscussionsMessage ifAbsent: [^nil].
		aWebDiscussionsMessage parent: nil.
		self top removeFromNewest: aWebDiscussionsMessage].! !

!WebForumResponse methodsFor: 'accessing' stamp: 'np 1/30/2008 16:12'!
discussion
	"original discussion, where this response belongs"
	self allParents size > 1
		ifTrue: [^self allParents at: 2]
		ifFalse: [^self]

"WebServer default webDiscussions"! !

!WebForumResponse methodsFor: 'accessing' stamp: 'np 1/30/2008 16:35'!
htmlBody
	| htmlBody |
	(self body isNil) ifTrue: [htmlBody := '']
		ifFalse: 
		[htmlBody := self body 
		 	copyReplaceAll: (String with: Character cr)
			with: '<br>'].
	^htmlBody! !

!WebForumResponse methodsFor: 'initialize-release' stamp: 'np 1/30/2008 16:11'!
initResponses
	responses := OrderedCollection new.! !

!WebForumResponse methodsFor: 'initialize-release' stamp: 'np 1/30/2008 16:11'!
initialize! !

!WebForumResponse methodsFor: 'adding-removing' stamp: 'np 1/30/2008 16:14'!
notifyNewResponse

	"send by e-mail notification of new response"
	|  msgSubject msgBody |
	msgSubject := 'New response in discussion: ', self discussion title.
	msgBody := 'New response: ', self title, ' from author: ', self author.
	[AIDASite default urgentEMailSubject: msgSubject body: msgBody] fork.! !

!WebForumResponse methodsFor: 'accessing' stamp: 'np 1/30/2008 16:13'!
parent
	^parent.! !

!WebForumResponse methodsFor: 'accessing' stamp: 'np 1/30/2008 16:13'!
parent: aWebDiscussionsResponse
	parent := aWebDiscussionsResponse.! !

!WebForumResponse methodsFor: 'printing' stamp: 'np 1/30/2008 16:15'!
printString
 ^'WebDiscussionsResponse titled: ', self title.! !

!WebForumResponse methodsFor: 'accessing' stamp: 'np 1/30/2008 16:13'!
responseCount

	"return a number of all responses down in hierarchy"

	| count |
	count := self responses size.
	self responses do: [:each | count := count + each responseCount].
	^count! !

!WebForumResponse methodsFor: 'accessing' stamp: 'np 1/30/2008 16:13'!
responses
	responses isNil ifTrue: [self initResponses].
	^responses! !

!WebForumResponse methodsFor: 'accessing' stamp: 'np 1/30/2008 16:13'!
time
	^self timestamp asTime! !

!WebForumResponse methodsFor: 'accessing' stamp: 'np 1/30/2008 16:13'!
timestamp
	"date and time of response"
	timestamp isNil ifTrue: [self timestamp: SpTimestamp now].
	^timestamp! !

!WebForumResponse methodsFor: 'accessing' stamp: 'np 1/30/2008 16:13'!
timestamp: aTimestamp
	timestamp := aTimestamp.! !

!WebForumResponse methodsFor: 'accessing' stamp: 'np 1/30/2008 16:13'!
title
	title isNil ifTrue: [self title: ''].
	^title! !

!WebForumResponse methodsFor: 'accessing' stamp: 'np 1/30/2008 16:13'!
title: aString
	title := aString.! !

!WebForumResponse methodsFor: 'accessing' stamp: 'np 1/30/2008 16:14'!
top
	"reference to aWebDiscussions as parent of all responses"
	^self allParents first

"WebServer default webDiscussions"! !

!WebForumResponse methodsFor: 'accessing' stamp: 'np 1/30/2008 16:14'!
user
	"a web user, which created a response"
	^user! !

!WebForumResponse methodsFor: 'accessing' stamp: 'np 1/30/2008 16:14'!
user: aWebUser
	user := aWebUser.! !

Object subclass: #WebRSSFeedEntry
	instanceVariableNames: 'title author message tags timeStamp directUrl'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scribo-RSS'!

!WebRSSFeedEntry methodsFor: 'accessing' stamp: 'np 10/28/2007 04:19'!
author
	^author! !

!WebRSSFeedEntry methodsFor: 'accessing' stamp: 'np 10/28/2007 04:18'!
author: aWebUser
	author := aWebUser! !

!WebRSSFeedEntry methodsFor: 'accessing' stamp: 'np 4/5/2008 14:41'!
directUrl
	directUrl isNil ifTrue: [directUrl := ''].
	^directUrl! !

!WebRSSFeedEntry methodsFor: 'accessing' stamp: 'np 10/28/2007 19:51'!
directUrl: aString
	directUrl := aString! !

!WebRSSFeedEntry methodsFor: 'accessing' stamp: 'np 10/28/2007 04:21'!
message
	^message! !

!WebRSSFeedEntry methodsFor: 'accessing' stamp: 'np 10/28/2007 04:21'!
message: aString
	message := aString! !

!WebRSSFeedEntry methodsFor: 'accessing' stamp: 'np 10/28/2007 23:48'!
tags
	tags isNil ifTrue: [tags := OrderedCollection new].
	^tags! !

!WebRSSFeedEntry methodsFor: 'accessing' stamp: 'np 10/28/2007 04:20'!
tags: aCollection
	tags := aCollection! !

!WebRSSFeedEntry methodsFor: 'accessing' stamp: 'np 10/28/2007 04:19'!
timeStamp
	^timeStamp! !

!WebRSSFeedEntry methodsFor: 'accessing' stamp: 'np 10/28/2007 04:19'!
timeStamp: aSpDAte
	timeStamp := aSpDAte! !

!WebRSSFeedEntry methodsFor: 'accessing' stamp: 'np 10/28/2007 04:20'!
title
	^title! !

!WebRSSFeedEntry methodsFor: 'accessing' stamp: 'np 10/28/2007 04:20'!
title: aString
	title := aString! !

Object subclass: #Wiki
	instanceVariableNames: 'pages ordered parent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scribo-Wiki'!

Wiki subclass: #SiteContent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scribo-Sites'!

!SiteContent class methodsFor: 'instance creation' stamp: 'np 6/23/2008 00:26'!
newOn: anAIDASite
	"find appropriate class for a new wiki page, defined in ScriboStyle siteContentClass"
	^anAIDASite style siteContentClass basicNew 
		parent: anAIDASite;
		initialize;
		yourself! !

!SiteContent methodsFor: 'private' stamp: 'np 1/21/2008 10:54'!
connectParentToAllSiteContents
	"SiteContent new connectParentToAllSiteContents"
	AIDASite allInstances do: [:each | each siteContent parent: each].! !

!SiteContent methodsFor: 'accessing' stamp: 'np 1/21/2008 10:53'!
defaultPageTitle
	^self site style defaultPageTitle! !

!SiteContent methodsFor: 'accessing' stamp: 'np 1/21/2008 10:53'!
firstPage
	^self defaultPage! !

!SiteContent methodsFor: 'initialize-release' stamp: 'np 1/21/2008 14:49'!
initDefaultPage
	self addPage: (self site style sitePageClass new title: self defaultPageTitle)! !

!SiteContent methodsFor: 'testing' stamp: 'np 1/21/2008 10:54'!
isRepository
	^false! !

!SiteContent methodsFor: 'private' stamp: 'np 1/21/2008 10:54'!
migrateToStyle: aWebStyleClass
	"migrate self and pages to classes defined in WebStyle subclass"
	"(AIDASite named: 'aida') siteContent migrateToStyle: AidaWebStyle"
	"(AIDASite named: 'aida') sessionManager initAppsForObjects"
	"(AIDASite named: 'aida') securityManager initAdminAccess"
	self changeClassTo: aWebStyleClass new siteContentClass.
	self pages do: [:each | each changeClassTo: aWebStyleClass new sitePageClass].! !

!Wiki class methodsFor: 'instance creation' stamp: 'np 6/23/2008 00:18'!
new
	^self basicNew initialize! !

!Wiki class methodsFor: 'instance creation' stamp: 'np 6/23/2008 00:17'!
newOn: anAIDASite
	"find appropriate class for a new wiki page, defined in ScriboStyle wikiClass"
	^anAIDASite style wikiClass new 
		parent: anAIDASite; 
		yourself! !

!Wiki methodsFor: 'adding-removing' stamp: 'janko 7/14/2008 22:30'!
addPage: aWikiPage
	(self pages includesKey: aWikiPage title) ifTrue: [^nil].
	self pages at: aWikiPage title put: aWikiPage.
	self ordered add: aWikiPage.
	aWikiPage parent: self.! !

!Wiki methodsFor: 'accessing' stamp: 'np 3/29/2008 06:11'!
allPages
	"all pages on that wiki or site which are not obsolete"
	^self pages values reject: [:each | each isObsolete]! !

!Wiki methodsFor: 'private' stamp: 'np 1/21/2008 10:39'!
connectParentToAllWikis
	"Wiki new connectParentToAllWikis"
	AIDASite allInstances do: [:each | each wiki parent: each].! !

!Wiki methodsFor: 'private' stamp: 'np 1/21/2008 10:39'!
convertFromFullToLinksOnlyWikiFormat
	"(AIDASite named: 'siska') siteContent convertFromFullToLinksOnlyWikiFormat"
	self pages do: [:each | each allVersions do: [:page | page convertFromFullToLinksOnlyWikiFormat]].! !

!Wiki methodsFor: 'accessing' stamp: 'np 3/28/2008 18:52'!
defaultPage
	^self pages at: self defaultPageTitle ! !

!Wiki methodsFor: 'accessing' stamp: 'np 1/21/2008 10:38'!
defaultPageTitle
	^'Wiki'! !

!Wiki methodsFor: 'initialize-release' stamp: 'np 3/28/2008 21:17'!
initDefaultPage
	self addPage: (WikiPage new title: self defaultPageTitle)! !

!Wiki methodsFor: 'initialize-release' stamp: 'np 8/17/2008 20:14'!
initOrdered
	ordered := OrderedCollection new.
	! !

!Wiki methodsFor: 'initialize-release' stamp: 'np 1/21/2008 10:37'!
initPages
	pages := Dictionary new! !

!Wiki methodsFor: 'initialize-release' stamp: 'np 8/17/2008 20:12'!
initialize
	self initOrdered.
	self initPages.
	self initDefaultPage! !

!Wiki methodsFor: 'private' stamp: 'np 1/21/2008 10:39'!
migrateToUnicode
	"from iso8859-2"
	"Wiki allInstances do: [:each | each migrateToUnicode]"
	self pages associations do: [:assoc |
		self pages removeKey: assoc key.
		assoc value migrateToUnicode.
		self pages at: assoc value title put: assoc value]! !

!Wiki methodsFor: 'accessing' stamp: 'janko 7/31/2008 19:35'!
moveDownPage: aPage
	self ordered moveDown: aPage! !

!Wiki methodsFor: 'accessing' stamp: 'janko 7/31/2008 19:35'!
moveUpPage: aPage
	self ordered moveUp: aPage! !

!Wiki methodsFor: 'accessing' stamp: 'np 3/29/2008 01:36'!
obsoletePages
	^pages select: [:each | each value isObsolete]! !

!Wiki methodsFor: 'private' stamp: 'janko 7/14/2008 22:28'!
ordered
	ordered isNil ifTrue: [self initOrdered].
	^ordered! !

!Wiki methodsFor: 'accessing' stamp: 'np 3/29/2008 01:45'!
pageTitled: aString
	"an original title, not changed one, if changed later"
	^self pages at: aString ifAbsent: 
		"compatibility with old, pre UTF-8 wikis"
		[self pages at: (AIDASite convert: aString toCodepage: #'iso8859-2')  ifAbsent: [nil] ]! !

!Wiki methodsFor: 'private' stamp: 'np 3/29/2008 06:10'!
pages
	pages isNil ifTrue: [self initPages].
	^pages! !

!Wiki methodsFor: 'private' stamp: 'np 1/21/2008 10:39'!
parent
	^parent! !

!Wiki methodsFor: 'private' stamp: 'np 1/21/2008 10:39'!
parent: anAIDASite
	parent := anAIDASite! !

!Wiki methodsFor: 'adding-removing' stamp: 'janko 7/14/2008 22:33'!
removePage: aWikiPage
	(self pages includesKey: aWikiPage title) ifFalse: [^nil].
	self pages removeKey: aWikiPage title.
	self ordered remove: aWikiPage.
	aWikiPage parent: nil.! !

!Wiki methodsFor: 'accessing' stamp: 'np 1/21/2008 10:38'!
repository
	^self parent repository! !

!Wiki methodsFor: 'accessing' stamp: 'np 1/21/2008 10:38'!
site
	^parent! !

Object subclass: #WikiInclude
	instanceVariableNames: 'parent name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scribo-Wiki'!

!WikiInclude commentStamp: '<historical>' prior: 0!
WikiInclude to include things like Table od contents into a Wiki page. Use braces { } for inclusion.
Supported includes:
{TOC}  Table of contents

Instance Variables:
	name	<String>	 name of include (a text between braces)

!

!WikiInclude class methodsFor: 'instance creation' stamp: 'np 6/23/2008 00:18'!
new
	^self basicNew initialize! !

!WikiInclude class methodsFor: 'instance creation' stamp: 'np 6/23/2008 00:18'!
on: aWikiRenderer
	^self new 
		parent: aWikiRenderer;
		initialize! !

!WikiInclude methodsFor: 'printing' stamp: 'np 8/17/2008 17:30'!
asGallery
	"image gallery into a IFRAME"
	| app out url iframe |
	app := self parent app.
	out := WriteStream on: String new.
	url := app site urlResolver halfUrlFor: self parent document firstGallery.	"only one gallery supported so far"
	iframe := WebIFrame new.
	iframe
		src: url ;
		size: self parent document firstGallery app gallerySize ;
		scrolling: #no.	"because it is bigger for admins"
	iframe 
		printHTMLPageOn: out for: app session lastRequest
		on: app session.
	^ out contents! !

!WikiInclude methodsFor: 'printing' stamp: 'janko 3/22/2008 14:34'!
asHtml
	self isTOC ifTrue: [^self asTOC].
	self isGallery ifTrue: [^self asGallery].
	self isMethod ifTrue: [^self asResultOfMethod].
	^''! !

!WikiInclude methodsFor: 'printing' stamp: 'janko 7/18/2008 20:49'!
asResultOfMethod
	"result of method invocation. Method must return a WebElement. "
	"Method must accept one argument if argument folllows mathod name in include"
	| app method argument e stream session |
	app := self parent app.
	stream := self name trimBlanks readStream.
	method := stream upToSeparator.
	method := (method 
		copyFrom: 2
		to: method size) asSymbol.
	argument := stream upToEnd trimBlanks.
	(app class canUnderstand: method) 
		ifTrue: 
			[ e := argument isEmpty 
				ifTrue: [ app perform: method ]
				ifFalse: 
					[ app 
						perform: method
						with: argument ].
			app form registerFormElementsIn: e ]
		ifFalse: [ e := WebElement new ].
	stream := WriteStream on: String new.
	session := self firstSessionFromStack.
	e 
		printHTMLPageOn: stream for: app session lastRequest
		on: session.
	^ AIDASite 
		convertFromWeb: stream contents
		on: session	"because printHTML do UTF-8 encoding"! !

!WikiInclude methodsFor: 'printing' stamp: 'np 8/17/2008 17:14'!
asTOC
	"table of contents"
	| headings anchor app out url |
	self parent mode =  #linksOnly ifFalse: [^'']. "TOC only works with HTML markup"
	app := self parent app. out := WriteStream on: String new.
	url := app site urlResolver halfUrlFor: app observee.
	headings := self parent source asCollectionOfHtmlHeadings.
	headings do: [:each || level bold ebold |
		each withoutHtmlTags trimBlanks notEmpty ifTrue: 
			[level := (String with: (each at: 3)) asInteger. 
			bold := ''. ebold := ''. level = 2 ifTrue: [bold := '<b>'. ebold := '</b>'].
			(level <= 3) & (level ~= 1) "skip title" ifTrue: 
				[anchor := 'h-', (headings indexOf: each) printString.
				out nextPutAll: 
					'<a href="', url, '#', anchor, '">', bold, each withoutHtmlTags, ebold, '</a><br>'] ] ].
	^out contents! !

!WikiInclude methodsFor: 'initialize-release' stamp: ' 21/4/07 22:07'!
contents: aString 
	self name: aString! !

!WikiInclude methodsFor: 'testing' stamp: ' 21/8/07 09:38'!
isGallery
	"image gallery"
	| nme |
	nme := self name readStream upToSeparator.
	^nme = 'GALLERY' or: [nme  = 'GALERIJA']! !

!WikiInclude methodsFor: 'testing' stamp: 'janko 3/22/2008 14:34'!
isMethod
	"method invocation, method name must start with # "
	| nme |
	nme := self name readStream upToSeparator.
	^nme notEmpty and: [nme first = $# ]! !

!WikiInclude methodsFor: 'testing' stamp: ' 21/4/07 22:07'!
isTOC
	"table of contents"
	| nme |
	nme := self name readStream upToSeparator.
	^nme = 'TOC' or: [nme  = 'KAZALO']! !

!WikiInclude methodsFor: 'accessing' stamp: ' 21/4/07 22:07'!
name
	^name! !

!WikiInclude methodsFor: 'accessing' stamp: ' 21/4/07 22:07'!
name: anObject
	name := anObject! !

!WikiInclude methodsFor: 'accessing' stamp: ' 21/4/07 22:07'!
parent
	^parent! !

!WikiInclude methodsFor: 'accessing' stamp: ' 21/4/07 22:07'!
parent: aWikiRenderer
	parent := aWikiRenderer! !

Object subclass: #WikiLink
	instanceVariableNames: 'address name siblingReference isMethod fragment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scribo-Wiki'!

!WikiLink commentStamp: '<historical>' prior: 0!
From WikiWorks, Thanks to authors for such a wonderfull job!!

Instance Variables:
	address	<SequenceableCollection>	description of address
	fragment	<Object>	description of fragment
	isMethod	<Boolean>	description of isMethod
	name	<Object>	description of name
	siblingReference	<Object >	description of siblingReference

!

!WikiLink methodsFor: 'accessing' stamp: ' 21/4/07 22:07'!
address
	^address! !

!WikiLink methodsFor: 'initialize-release' stamp: 'janko 3/16/2008 23:36'!
contents: aString 
	| realString rs isAnonymous |
	realString := aString trimBlanks. rs := realString readStream.
	(rs contents containsSubstring: '&gt;') "named char for > "
		ifTrue: [name := (rs upToAll: '&gt;') trimBlanks. "rs skip: 4"] 
		ifFalse: [name := (rs upTo: $> escaper: $\) trimBlanks].
	isMethod := (rs peekForAll: '>#') | (rs peekForAll: '&gt;#').
	isMethod ifTrue: [address := rs upToEnd trimBlanks asSymbol. ^self].
	isAnonymous := rs atEnd.
	address := isAnonymous ifTrue: [name] ifFalse: [rs upToEnd trimBlanks].
	isAnonymous ifTrue: [name := nil].
	self isExternalLink ifTrue: [^self].
	rs := address readStream. address := (rs upTo: $!! escaper: $\) trimBlanks.
	rs atEnd ifFalse: 	[siblingReference := address. 	address := rs upToEnd trimBlanks]! !

!WikiLink methodsFor: 'constants' stamp: ' 21/4/07 22:07'!
externalLinkPrefixes
	^#('http://*' 'https://*' 'mailto:*' 'file:/*' 'ftp://*' 'news:*' 'nntp://*' 'telnet://*' 'prospero://*' 'gopher://*' 'wais://*')! !

!WikiLink methodsFor: 'accessing' stamp: ' 21/4/07 22:07'!
fragment
	^fragment! !

!WikiLink methodsFor: 'initialize-release' stamp: ' 21/4/07 22:07'!
fragmentize
	| rs |
	rs := address readStream.
	address := rs upTo: $# escaper: $\.
	rs atEnd ifFalse: [fragment := rs upToEnd]! !

!WikiLink methodsFor: 'testing' stamp: ' 21/4/07 22:07'!
hasFragment
	^fragment notNil! !

!WikiLink methodsFor: 'constants' stamp: ' 21/4/07 22:07'!
imageLinkSuffixes
	^#('*.gif' '*.jpeg' '*.jpg' '*.jpe')! !

!WikiLink methodsFor: 'initialize-release' stamp: ' 21/4/07 22:07'!
initialize
	isMethod := false! !

!WikiLink methodsFor: 'testing' stamp: ' 21/4/07 22:07'!
isAnonymous
	^name isNil! !

!WikiLink methodsFor: 'testing' stamp: ' 21/4/07 22:07'!
isExternalLink
	^self externalLinkPrefixes contains: [:each | each match: address]! !

!WikiLink methodsFor: 'testing' stamp: ' 21/4/07 22:07'!
isImage
	^self imageLinkSuffixes contains: [:each | each match: address]! !

!WikiLink methodsFor: 'testing' stamp: ' 21/4/07 22:07'!
isMethod
	^isMethod! !

!WikiLink methodsFor: 'accessing' stamp: ' 21/4/07 22:07'!
name
	| externalLinkPrefix |
	self isAnonymous ifFalse: [^name].
	externalLinkPrefix := self externalLinkPrefixes 
				detect: [:each | each match: address]
				ifNone: [^address].
	^address copyFrom: externalLinkPrefix size to: address size! !

!WikiLink methodsFor: 'accessing' stamp: ' 21/4/07 22:07'!
siblingReference
	^siblingReference! !

DefaultWebStyle subclass: #ScriboStyle
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scribo-Core'!

!ScriboStyle methodsFor: '*Scribo-RSS' stamp: 'np 4/5/2008 20:02'!
addRSSLinkInHeaderFor: anObject view: aSymbol title: aString 
	self app addHeader: 'link' value: 'rel="alternate" type="application/rss+xml" title="', aString, '"  href="', ((WebLink new linkTo: anObject; view: aSymbol) composeURLOn: self app session), '"'! !

!ScriboStyle methodsFor: 'frame printing' stamp: 'np 6/23/2008 00:25'!
blogClass
	"override that if you have your own Blog and BlogApp subclasses"
	^Blog! !

!ScriboStyle methodsFor: 'frame printing' stamp: 'np 4/11/2008 00:30'!
blogFooterElement
	| e |
	e := WebElement new id: #blogFooter.
	e addText: 'Powered by Aida/Scribo'.
	e addBreak.
	e addPng: #bulletFeedGif; addLinkTo: (self site blog) text: ' Entries (RSS)' view: #RSSPosts.
	e addText: ' and '.
	e addPng: #bulletFeedGif; addLinkTo: (self site blog) text: ' Comments (RSS)' view: #RSSComments.
	^e! !

!ScriboStyle methodsFor: 'frame printing' stamp: 'np 1/23/2008 20:40'!
blogPageFrameWith: aWebElement title: aTitleString
	^self blogPageFrameWith: aWebElement wide: WebElement new title: aTitleString! !

!ScriboStyle methodsFor: 'frame printing' stamp: 'np 2/1/2008 20:11'!
blogPageFrameWith: aWebElement wide: aWideElement title: aTitleString 
	"set a blog page with standard  page look (navigation bar, header) "
	"Wide element comes below content besides navigation and it have full page width"
	| element header |
	header := (WebElement newId: #blogHeader)
		addLinkTo: self app site blog text: self app site blog title header: 1;
		addText:  self app site blog tagline header: 2;
		yourself.
	self app clear;  title: aTitleString. self app htmlHeaderElements.
	element := (WebElement newId: #container)
		add: self headerElement; 	add: self headerDashboard;
		add: ((WebElement newId: #BlogPage) 
			add: self navigationBarElement; add: header; 
			add: aWebElement; 
			add: self blogFooterElement; yourself); 
		add: ((WebElement newId: #contentWide)
			add: aWideElement; yourself);
		yourself.
	^self app add: element; yourself! !

!ScriboStyle methodsFor: 'imgs-bullets' stamp: 'np 1/29/2008 19:16'!
bulletCommentPng
	 ^#(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 22 0 0 0 22 8 3 0 0 0 243 106 156 9 0 0 0 46 116 69 88 116 67 114 101 97 116 105 111 110 32 84 105 109 101 0 100 105 109 46 32 55 32 106 97 110 118 46 32 50 48 48 55 32 49 57 58 52 48 58 51 55 32 43 48 49 48 48 110 225 199 157 0 0 0 7 116 73 77 69 7 215 5 12 11 19 44 30 187 116 111 0 0 0 9 112 72 89 115 0 0 10 240 0 0 10 240 1 66 172 52 152 0 0 0 4 103 65 77 65 0 0 177 143 11 252 97 5 0 0 3 0 80 76 84 69 206 206 206 214 214 214 222 222 222 231 231 231 239 239 239 247 247 247 255 0 0 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 86 170 118 100 0 0 0 7 116 82 78 83 255 255 255 255 255 255 0 26 75 3 70 0 0 0 108 73 68 65 84 120 218 189 209 81 14 128 48 8 3 208 182 128 220 255 198 50 39 145 68 191 237 231 27 97 176 225 248 12 254 96 163 42 180 156 44 69 86 34 234 244 225 141 165 238 38 52 15 117 51 114 115 218 84 17 121 177 251 214 216 74 216 197 1 239 198 75 187 250 0 41 43 210 66 66 247 149 1 62 169 22 61 96 59 64 197 152 123 81 53 242 152 203 171 170 236 245 38 14 122 254 247 13 39 144 84 9 126 179 14 127 121 0 0 0 0 73 69 78 68 174 66 96 130)! !

!ScriboStyle methodsFor: 'imgs-bullets' stamp: 'np 1/29/2008 21:18'!
bulletFeedGif
	 ^#(71 73 70 56 57 97 16 0 16 0 231 1 0 0 0 0 255 255 255 255 255 254 255 254 251 255 190 101 255 192 105 255 200 128 255 200 129 255 204 134 255 250 243 255 252 248 255 149 24 255 150 24 255 151 24 255 194 121 255 196 124 255 197 125 255 198 127 255 199 129 255 199 131 255 251 246 255 141 14 255 142 17 255 142 19 255 143 20 255 144 20 255 142 21 255 144 22 255 146 22 255 146 23 255 148 23 255 144 24 255 146 24 255 148 24 255 174 86 255 177 90 255 176 91 255 180 100 255 182 104 255 187 112 255 190 116 255 190 120 255 192 123 255 193 123 255 194 124 255 193 126 255 195 126 255 194 129 255 226 195 255 229 201 255 236 215 255 136 17 255 165 74 255 166 79 255 169 81 255 171 82 255 172 84 255 172 85 255 171 86 255 172 88 255 175 90 255 176 97 255 178 97 255 179 99 255 186 113 255 184 114 255 186 114 255 185 117 255 188 117 255 187 118 255 187 119 255 188 119 255 189 120 255 191 124 255 192 128 255 197 136 255 202 147 255 203 149 255 211 168 255 216 175 255 224 192 255 228 200 255 233 210 255 246 237 255 250 245 255 252 249 255 253 251 255 134 23 255 133 24 255 166 80 255 164 81 255 165 84 255 173 94 255 175 101 255 179 107 255 180 108 255 198 144 255 201 149 255 208 165 255 211 169 255 221 189 255 234 214 255 129 22 255 158 74 255 157 78 255 163 83 255 169 97 255 175 107 255 176 107 255 177 110 255 181 121 255 186 130 255 198 150 255 213 179 255 239 226 255 242 231 255 122 22 255 126 23 255 146 63 255 148 67 255 159 83 255 168 102 255 170 104 255 199 155 255 199 158 255 201 159 255 202 163 255 220 194 255 236 221 255 251 248 255 118 22 255 134 52 255 145 72 255 154 83 255 160 95 255 163 101 255 175 119 254 234 220 255 110 22 255 115 23 255 148 83 255 158 99 255 163 107 255 194 157 255 104 22 255 108 22 255 149 86 255 153 97 255 159 106 255 205 176 255 233 221 255 245 239 255 99 20 255 138 75 255 147 91 255 151 95 255 153 102 255 165 118 255 167 123 255 253 252 255 95 20 255 97 22 255 129 73 255 146 94 255 191 161 255 220 203 254 231 220 255 90 19 255 91 21 255 113 51 255 132 81 255 164 125 255 166 128 254 230 220 255 78 12 255 82 17 255 83 19 255 83 20 254 228 220 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 33 249 4 1 0 0 255 0 44 0 0 0 0 16 0 16 0 0 8 241 0 255 9 28 72 176 224 192 27 24 46 100 240 16 34 68 3 6 13 26 164 57 56 66 201 146 23 39 80 60 136 32 193 0 130 2 120 4 86 64 194 199 210 31 48 94 104 216 16 145 131 196 132 25 2 53 28 233 115 41 64 128 57 78 124 224 224 145 5 9 22 129 31 82 104 233 98 100 140 130 0 81 126 212 56 19 164 142 64 14 42 224 196 8 211 3 136 140 0 48 182 216 105 35 72 224 134 22 113 2 124 154 146 196 68 153 0 123 6 233 81 36 16 196 10 29 69 160 88 161 50 132 77 21 64 140 12 65 18 184 128 197 14 33 37 154 12 144 131 198 79 0 79 146 66 9 236 224 128 73 32 41 92 200 88 65 228 72 0 169 73 167 158 66 120 18 32 129 26 55 1 42 101 162 80 138 210 43 129 22 14 16 17 243 230 14 161 71 157 82 177 90 197 201 149 64 60 4 92 16 249 178 38 207 161 70 155 52 141 18 165 106 96 161 43 102 232 44 138 132 9 20 170 88 176 138 27 156 78 48 32 0 59)! !

!ScriboStyle methodsFor: 'imgs-bullets' stamp: 'np 2/1/2008 20:04'!
bulletFeedGreyPng
	 ^#(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 16 0 0 0 16 8 6 0 0 0 31 243 255 97 0 0 0 1 115 82 71 66 0 174 206 28 233 0 0 0 6 98 75 71 68 0 255 0 255 0 255 160 189 167 147 0 0 0 9 112 72 89 115 0 0 11 19 0 0 11 19 1 0 154 156 24 0 0 0 7 116 73 77 69 7 216 2 1 19 3 4 194 229 138 20 0 0 0 25 116 69 88 116 67 111 109 109 101 110 116 0 67 114 101 97 116 101 100 32 119 105 116 104 32 71 73 77 80 87 129 14 23 0 0 2 112 73 68 65 84 56 203 117 147 77 75 243 78 20 197 127 147 137 181 196 164 165 180 46 76 41 70 84 16 92 184 113 217 101 139 186 116 233 194 101 191 135 75 87 126 129 126 8 191 130 138 123 41 104 17 223 10 197 215 216 10 141 85 170 201 204 60 11 73 120 94 254 255 129 129 203 192 57 247 220 51 231 10 128 118 187 109 194 48 4 192 178 44 132 16 8 33 254 168 127 191 90 107 60 207 163 213 106 9 209 110 183 205 112 56 36 142 99 44 203 66 74 137 101 89 255 212 66 8 108 219 206 72 128 159 183 48 12 209 90 83 42 149 88 91 91 195 178 44 238 239 239 121 124 124 252 95 176 16 2 165 20 31 31 31 216 169 236 82 169 68 189 94 39 61 147 201 132 139 139 11 58 157 14 113 28 255 3 142 227 24 99 12 178 217 108 238 165 114 191 190 190 120 127 127 103 122 122 154 153 153 25 124 223 103 117 117 149 40 138 24 141 70 127 128 147 36 65 41 133 216 223 223 55 255 53 179 239 251 52 26 13 10 133 2 0 199 199 199 92 94 94 102 224 148 64 54 155 205 61 41 37 181 90 141 221 221 93 124 223 199 113 28 158 159 159 233 116 58 120 158 71 185 92 38 8 2 194 48 228 245 245 53 35 208 90 99 165 157 109 219 38 151 203 17 4 1 245 122 157 157 157 29 42 149 10 39 39 39 116 187 93 0 26 141 6 82 202 172 59 128 220 216 216 216 179 109 155 241 120 204 205 205 13 131 193 128 114 185 140 227 56 44 46 46 210 235 245 56 63 63 103 101 101 5 199 113 136 227 152 94 175 71 146 36 63 89 73 3 35 165 100 52 26 113 125 125 205 225 225 33 87 87 87 228 114 57 54 55 55 145 82 114 116 116 4 192 250 250 122 166 64 41 245 67 144 154 183 181 181 197 246 246 54 65 16 112 122 122 74 20 69 20 10 5 230 231 231 233 118 187 76 38 19 242 249 60 149 74 37 27 193 74 83 53 55 55 71 16 4 204 206 206 178 188 188 204 231 231 39 103 103 103 0 44 45 45 161 148 162 223 239 3 176 176 176 128 82 234 199 196 84 193 120 60 230 251 251 27 128 167 167 39 146 36 225 229 229 5 0 215 117 73 146 132 135 135 7 0 166 166 166 80 74 97 140 65 28 28 28 24 215 117 17 66 224 56 14 249 124 158 126 191 159 125 85 181 90 69 107 205 237 237 45 158 231 81 44 22 25 12 6 12 6 3 138 197 34 182 231 121 24 99 80 74 241 246 246 150 1 83 163 238 238 238 50 195 134 195 33 233 214 186 174 75 181 90 69 164 235 28 69 17 198 24 180 214 104 173 51 147 254 174 141 49 8 33 168 213 106 180 90 45 241 11 195 156 83 249 37 17 222 107 0 0 0 0 73 69 78 68 174 66 96 130)! !

!ScriboStyle methodsFor: 'imgs-bullets' stamp: 'np 1/29/2008 19:39'!
bulletTagRedPng
	 ^#(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 16 0 0 0 16 8 6 0 0 0 31 243 255 97 0 0 0 1 115 82 71 66 0 174 206 28 233 0 0 0 6 98 75 71 68 0 255 0 255 0 255 160 189 167 147 0 0 0 9 112 72 89 115 0 0 11 19 0 0 11 19 1 0 154 156 24 0 0 0 7 116 73 77 69 7 216 1 29 18 38 3 232 223 55 144 0 0 2 198 73 68 65 84 56 203 109 147 223 75 91 103 24 199 63 239 121 211 179 96 202 54 116 42 106 142 195 105 183 238 66 93 196 155 49 71 193 65 47 218 81 232 197 110 7 219 216 213 24 251 11 118 177 191 97 119 50 118 177 31 12 6 14 44 46 113 22 236 172 195 49 82 219 138 164 77 68 130 72 2 146 164 169 193 230 196 156 228 60 207 46 60 182 221 143 23 30 120 224 253 190 31 120 225 243 53 185 92 78 85 21 17 65 85 121 126 159 158 158 190 99 173 93 6 22 128 10 240 2 208 3 248 128 11 188 198 206 206 142 134 97 248 159 41 149 74 186 181 181 165 65 16 252 166 170 159 158 193 163 113 85 213 81 85 98 170 10 64 185 92 166 86 171 209 219 219 139 231 121 12 13 13 33 34 108 111 111 95 78 165 82 9 107 109 28 248 154 211 19 0 51 0 142 136 0 80 173 86 73 165 82 166 82 169 220 245 125 31 17 97 100 100 132 254 254 126 178 217 236 59 34 242 5 48 22 1 226 192 206 63 0 125 125 125 100 179 217 182 136 244 199 98 49 168 63 34 252 227 54 158 231 49 56 56 200 230 230 230 184 136 252 10 244 2 93 32 1 60 251 130 231 121 36 147 73 183 211 233 120 231 158 60 65 126 250 17 218 1 161 42 175 190 123 9 17 97 99 99 227 205 185 185 185 159 173 181 11 192 47 128 239 136 72 171 94 175 3 32 34 196 26 13 228 135 239 48 137 243 152 129 1 216 190 79 184 177 206 216 216 24 195 195 195 172 175 175 191 215 237 118 175 2 31 0 129 51 53 53 117 127 111 111 175 85 171 213 176 214 162 245 71 208 9 192 113 32 22 195 188 244 242 83 200 248 248 56 201 100 146 181 181 181 15 187 221 238 231 192 190 227 186 238 103 147 147 147 55 118 119 119 91 213 106 21 251 198 69 184 118 29 105 52 78 65 214 158 66 238 221 37 252 253 22 19 19 19 140 142 142 178 186 186 250 182 170 186 14 112 148 72 36 190 157 153 153 185 153 207 231 91 149 74 5 123 225 2 230 202 251 200 81 4 49 6 206 185 180 31 228 64 4 199 113 112 28 7 160 235 0 10 220 238 233 233 249 107 118 118 246 102 46 151 107 29 30 30 62 131 60 126 140 54 142 232 196 227 184 31 125 204 94 177 72 177 88 100 126 126 254 150 49 38 142 170 190 168 170 54 50 236 173 102 179 153 89 89 89 241 75 165 146 134 97 168 193 195 7 218 254 102 65 195 86 75 11 133 130 102 50 25 13 130 224 207 40 111 81 213 248 115 0 163 170 55 26 141 198 247 203 203 203 254 193 193 193 83 181 11 133 130 166 211 105 109 54 155 95 169 234 165 51 173 255 15 96 84 245 245 227 227 227 165 165 165 37 127 127 127 95 243 249 188 166 211 105 109 183 219 43 170 218 23 101 80 213 87 206 0 67 81 65 226 209 133 163 170 159 156 156 156 108 45 46 46 250 209 227 59 255 42 148 85 213 139 38 50 241 172 162 78 228 186 68 251 151 34 82 54 198 148 141 49 153 40 55 16 233 12 192 223 23 191 253 55 206 50 98 212 0 0 0 0 73 69 78 68 174 66 96 130)! !

!ScriboStyle methodsFor: 'imgs' stamp: 'np 1/29/2008 20:04'!
commentBGPng
	 ^#(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 52 0 0 0 42 8 6 0 0 0 252 164 120 0 0 0 0 1 115 82 71 66 0 174 206 28 233 0 0 0 6 98 75 71 68 0 212 0 212 0 212 142 8 233 199 0 0 0 9 112 72 89 115 0 0 11 19 0 0 11 19 1 0 154 156 24 0 0 0 7 116 73 77 69 7 216 1 29 19 2 56 169 254 85 37 0 0 0 25 116 69 88 116 67 111 109 109 101 110 116 0 67 114 101 97 116 101 100 32 119 105 116 104 32 71 73 77 80 87 129 14 23 0 0 2 127 73 68 65 84 104 222 237 153 205 178 162 48 16 70 191 78 32 17 16 197 247 127 65 183 10 5 10 249 185 139 41 44 7 17 19 2 183 102 44 178 84 234 164 78 210 233 238 0 157 207 103 139 47 25 68 4 134 47 27 155 208 38 244 45 66 68 132 182 109 87 225 18 209 219 255 163 181 100 46 151 11 172 181 224 156 131 115 190 56 55 207 115 48 198 214 19 34 34 116 93 7 173 53 154 166 1 99 12 68 4 173 117 144 80 207 85 74 225 126 191 63 118 71 41 5 33 196 58 66 214 90 212 117 13 165 212 159 56 126 90 185 166 105 32 165 132 181 54 152 219 203 16 209 91 110 180 84 24 76 197 245 111 114 131 132 234 186 70 215 117 111 39 141 162 8 73 146 120 239 142 11 55 77 211 81 238 44 33 198 24 202 178 132 82 234 101 82 107 45 118 187 29 56 231 136 227 216 75 102 138 107 140 65 146 36 31 185 209 156 80 40 203 18 90 235 209 21 44 138 226 49 153 143 12 17 225 122 189 194 24 51 202 61 157 78 78 92 111 161 166 105 160 181 30 13 131 44 203 102 29 254 62 204 140 49 193 220 200 39 28 170 170 122 137 109 99 12 242 60 71 20 69 179 100 222 113 251 90 195 57 247 226 58 11 85 85 245 18 219 214 90 28 14 7 48 198 102 201 16 209 36 151 136 188 185 78 173 143 214 26 93 215 189 252 158 101 217 104 181 118 29 93 215 189 229 206 45 3 204 245 220 140 77 16 199 113 80 173 185 221 110 47 92 34 10 226 58 239 208 48 53 31 143 199 217 9 96 138 123 56 28 130 184 147 103 200 24 131 178 44 95 86 113 110 2 112 225 174 122 125 104 219 118 180 112 38 73 242 177 141 159 26 207 77 230 51 55 77 211 96 161 104 110 102 2 0 41 37 164 148 139 245 110 101 89 6 115 163 169 176 24 91 201 225 74 223 110 55 0 128 16 2 73 146 56 157 155 177 157 31 38 139 158 43 165 196 110 183 251 189 27 107 31 122 109 219 162 174 235 160 52 62 100 18 17 238 247 187 23 119 177 43 56 17 65 41 133 170 170 22 189 74 60 115 183 151 36 155 208 38 244 31 10 133 182 67 255 156 208 126 191 95 69 42 203 178 48 33 198 152 87 43 98 173 117 234 197 56 231 171 112 157 118 72 8 129 52 77 71 175 198 195 73 251 103 93 118 199 135 43 165 116 230 126 20 234 87 39 207 243 183 64 107 45 138 162 112 106 123 134 220 253 126 63 249 76 81 20 94 109 15 0 144 235 23 188 190 250 63 119 2 113 28 67 8 17 116 102 198 184 66 8 239 87 96 143 150 201 247 147 228 240 238 191 100 139 19 202 37 34 255 235 195 90 105 121 41 238 86 88 55 161 77 104 19 250 107 252 0 16 15 149 14 72 233 35 46 0 0 0 0 73 69 78 68 174 66 96 130)! !

!ScriboStyle methodsFor: 'styles-screen' stamp: 'np 1/24/2008 13:16'!
css451Document
	^'
#documentMain { }
#documentEdit td { font-size: 10px; }
#documentEdit input { font-size: 12px; }
#documentEdit textarea { font-size: 12px; }
'! !

!ScriboStyle methodsFor: 'styles-screen' stamp: 'np 1/24/2008 13:16'!
css452DocumentActions
	^'
/* img links to common actions on this document like print ... */
.documentActions {
	float: right;
	margin: -1.5em 0 0 0;
	padding-bottom: 5px;
}
.documentActions ul,
.documentActions li {
	display: inline;
	list-style: none;
	list-style-image: none;
}
.documentActions a {
	border: 0;
	text-decoration: none;
}
'! !

!ScriboStyle methodsFor: 'styles-screen' stamp: 'np 1/24/2008 13:17'!
css453ClassificationLevel
	^'
/* level of classified docs */
#classificationLevel  {
	font-size: 10pt; font-weight: bold;
	color: #800000; background-color: #FAFAD2;
	width: 290px; padding: 5px;
}
'! !

!ScriboStyle methodsFor: 'styles-screen' stamp: 'np 1/24/2008 13:14'!
css51Wiki
	^'
#wikiPage {
	margin: 10px 15px 10px 10px;
	padding-top: 20px;
	font-size: 90%;
	text-align: left;
	margin-top/* */: 0; /* IE5.0 Win wont see this - fixes weird float bug for hp */
	}
html>body #wikiPage  { margin-top: 0; 	}
#wikiPage { margin-left: 15px; padding-left: 0; }
#wikiPage td { font-size: 80% }
#wikiPage input, textarea { font-size: 100% }
#wikiPage table.webGrid { font-size: 120% }
table.wikiTable td { border: thin solid black; padding: 1px; margin: 0px }

#wikiPage {
	margin-left: 135px;
	padding-left: 0;
	}
'! !

!ScriboStyle methodsFor: 'styles-screen' stamp: 'np 2/4/2008 12:21'!
css52Blog
	^'
#BlogPage {
	margin: 10px 15px 10px 10px;
	padding-top: 20px;
	font-size: 90%;
	text-align: left;
	margin-top/* */: 0; /* IE5.0 Win wont see this - fixes weird float bug for hp */
	}
html>body #BlogPage  { margin-top: 0; 	}
#BlogPage { margin-left: 15px; padding-left: 0; }
#BlogPage td { font-size: 80% }
#BlogPage input, textarea { font-size: 100% }
#BlogPage table.webGrid { font-size: 120% }
table.wikiTable td { border: thin solid black; padding: 1px; margin: 0px }

#BlogPage {
	margin-left: 135px;
	padding-left: 0;
	}

#BlogPage h1{
	border-bottom: none;
	}

#BlogHeader h1{
	font-size: 22px;
	border-bottom: none;
	font-weight: bold;
	margin-bottom: 10px;
	}

#BlogHeader {
	margin-bottom: 20px;
	}

#BlogPage .post {
	margin-bottom: 25px;
	}

#BlogPage .postHeader{
	color: grey;
	margin-bottom: 10px;
	font-style: italic;}

#BlogPage .postHeader h1{
	margin-bottom: 2px;
	font-style: normal;
	color: #013466;
	border-bottom: 1px solid;
	border-color: #bebebe;
	}

#BlogPage .postHeader h1:hover{
	color: #3670A8;
	}


.post pre{
	/**font-family: Courier, Courier New, Sans Serif;**/
	border: #2F6FAB dashed 1px;
	background-color: #F9F9F9;
	padding: 0.5em;
	margin-bottom: 1em;
	}


#BlogPage .postFooter{
	margin: 10px;
	padding: 3px;
	color: grey;
	border: #fbabab dotted 1px;
	background-color: #ffefef;
	font-size: 90%;
	}

#BlogPage .blogComment{
	margin: 20px;
	width: 70%;
	padding: 5px;
	padding-left: 55px;
	color: grey;
	border-top: #c1c1c1 solid 2px;
	border-bottom: #c1c1c1 solid 2px;
	background: url(/img/commentBGPng) no-repeat;
	background-color: #e8e8e8;
	font-size: 80%;
	}
	
#BlogPage .batcher{
	text-align: center;
	}

#blogFooter {
	margin-top: 35px;
	border-top: 1px solid;
	border-color: #bebebe;
	color: grey;
	text-align: center;
	}

#blogFooter a{
	color: grey;
	}
	
#blogFooter a:hover{
	color: #bebebe;
	}
'! !

!ScriboStyle methodsFor: '*Scribo-Shout' stamp: 'np 2/3/2008 17:11'!
css55ShoutCode
	^ '.shout span.default {
	color: #000;
}
.shout span.invalid {
	color: #000;
}
.shout span.excessCode {
	color: #000;
}
.shout span.comment {
	color: #080;
}
.shout span.unfinishedComment {
	color: #f00;
}
.shout span.character {
	color: #808;
}
.shout span.integer {
	color: #808;
}
.shout span.number {
	color: #808;
}
.shout span.symbol {
	color: #808;
}
.shout span.stringSymbol {
	color: #808;
}
.shout span.literalArray {
	color: #808;
}
.shout span.string {
	color: #808;
}
.shout span.unfinishedString {
	color: #f00;
}
.shout span.assignment {
	color: #000;
}
.shout span.ansiAssignment {
	color: #000;
}
.shout span.literal {
	color: #000;
}
.shout span.keyword {
	color: #000;
}
.shout span.binary {
	color: #000;
}
.shout span.unary {
	color: #000;
}
.shout span.incompleteKeyword {
	color: #f00;
}
.shout span.incompleteBinary {
	color: #000;
}
.shout span.incompleteUnary {
	color: #000;
}
.shout span.undefinedKeyword {
	color: #000;
}
.shout span.undefinedBinary {
	color: #000;
}
.shout span.undefinedUnary {
	color: #000;
}
.shout span.patternKeyword {
	color: #000;
	font-weight: bold;
}
.shout span.patternBinary {
	color: #000;
	font-weight: bold;
}
.shout span.patternUnary {
	color: #000;
	font-weight: bold;
}
.shout span.self {
	color: #088;
}
.shout span.super {
	color: #088;
}
.shout span.true {
	color: #088;
}
.shout span.false {
	color: #088;
}
.shout span.nil {
	color: #088;
}
.shout span.thisContext {
	color: #088;
}
.shout span.return {
	color: #000;
}
.shout span.patternArg {
	color: #008;
}
.shout span.methodArg {
	color: #008;
}
.shout span.blockPatternArg {
	color: #008;
}
.shout span.blockArg {
	color: #008;
}
.shout span.argument {
	color: #008;
}
.shout span.blockArgColon {
	color: #000;
}
.shout span.leftParenthesis {
	color: #000;
}
.shout span.rightParenthesis {
	color: #000;
}
.shout span.leftParenthesis1 {
	color: #000;
}
.shout span.rightParenthesis1 {
	color: #000;
}
.shout span.leftParenthesis2 {
	color: #000;
}
.shout span.rightParenthesis2 {
	color: #000;
}
.shout span.leftParenthesis3 {
	color: #000;
}
.shout span.rightParenthesis3 {
	color: #000;
}
.shout span.leftParenthesis4 {
	color: #000;
}
.shout span.rightParenthesis4 {
	color: #000;
}
.shout span.leftParenthesis5 {
	color: #000;
}
.shout span.rightParenthesis5 {
	color: #000;
}
.shout span.leftParenthesis6 {
	color: #000;
}
.shout span.rightParenthesis6 {
	color: #000;
}
.shout span.leftParenthesis7 {
	color: #000;
}
.shout span.rightParenthesis7 {
	color: #000;
}
.shout span.blockStart {
	color: #000;
}
.shout span.blockEnd {
	color: #000;
}
.shout span.blockStart1 {
	color: #000;
}
.shout span.blockEnd1 {
	color: #000;
}
.shout span.blockStart2 {
	color: #000;
}
.shout span.blockEnd2 {
	color: #000;
}
.shout span.blockStart3 {
	color: #000;
}
.shout span.blockEnd3 {
	color: #000;
}
.shout span.blockStart4 {
	color: #000;
}
.shout span.blockEnd4 {
	color: #000;
}
.shout span.blockStart5 {
	color: #000;
}
.shout span.blockEnd5 {
	color: #000;
}
.shout span.blockStart6 {
	color: #000;
}
.shout span.blockEnd6 {
	color: #000;
}
.shout span.blockStart7 {
	color: #000;
}
.shout span.blockEnd7 {
	color: #000;
}
.shout span.arrayStart {
	color: #000;
}
.shout span.arrayEnd {
	color: #000;
}
.shout span.arrayStart1 {
	color: #000;
}
.shout span.arrayEnd1 {
	color: #000;
}
.shout span.leftBrace {
	color: #000;
}
.shout span.rightBrace {
	color: #000;
}
.shout span.cascadeSeparator {
	color: #000;
}
.shout span.statementSeparator {
	color: #000;
}
.shout span.externalCallType {
	color: #000;
}
.shout span.externalCallTypePointerIndicator {
	color: #000;
}
.shout span.primitiveOrExternalCallStart {
	color: #000;
	font-weight: bold;
}
.shout span.primitiveOrExternalCallEnd {
	color: #000;
	font-weight: bold;
}
.shout span.methodTempBar {
	color: #000;
}
.shout span.blockTempBar {
	color: #000;
}
.shout span.blockArgsBar {
	color: #000;
}
.shout span.primitive {
	color: #444;
}
.shout span.pragmaKeyword {
	color: #444;
}
.shout span.pragmaUnary {
	color: #444;
}
.shout span.pragmaBinary {
	color: #444;
}
.shout span.externalFunctionCallingConvention {
	color: #444;
}
.shout span.module {
	color: #444;
}
.shout span.blockTempVar {
	color: #008;
}
.shout span.blockPatternTempVar {
	color: #008;
}
.shout span.instVar {
	color: #008;
}
.shout span.workspaceVar {
	color: #008;
}
.shout span.undefinedIdentifier {
	color: #008;
}
.shout span.incompleteIdentifier {
	color: #008;
}
.shout span.tempVar {
	color: #008;
}
.shout span.patternTempVar {
	color: #008;
}
.shout span.poolConstant {
	color: #008;
}
.shout span.classVar {
	color: #008;
}
.shout span.globalVar {
	color: #008;
}'! !

!ScriboStyle methodsFor: 'frame printing' stamp: 'np 4/2/2008 23:20'!
defaultPageTitle
	^'First page'! !

!ScriboStyle methodsFor: 'testing' stamp: 'np 1/23/2008 13:01'!
isFirstPageDifferent
	"for Wikis and sites, if first page is different than others"
	^true! !

!ScriboStyle methodsFor: 'frame navigation' stamp: 'np 2/12/2008 17:17'!
navBarArchivesElement
	| element list archives |
	(self observee isBlog | self observee isBlogPost | self observee isBlogComment) ifFalse: [^WebElement new]. 
	element := (WebElement newClass: #navdiv)
		add: (self navHeader: ' Archives' bullet: #bulletCalendarTranspWhiteGif);
		yourself.
		archives := OrderedCollection new.
		list := WebList newUnordered.
		self site blog posts do: [:each | | month |
			month := each createdTimestamp asMonth.
			(archives includes: month) ifFalse:
			[archives add: month]].
		(archives asSortedCollection: [:m1 :m2 | m1 > m2]) do: [:each |
			list addLinkTo: self site blog text: each view: #archive parameter: 'archive' value: each].
		element add: list.
	^element! !

!ScriboStyle methodsFor: 'frame navigation' stamp: 'np 2/3/2008 22:42'!
navBarCategoriesElement
	| element list |
	(self observee isBlog | self observee isBlogPost | self observee isBlogComment) ifFalse: [^WebElement new]. 
	element := (WebElement newClass: #navdiv)
		add: (self navHeader: ' CATEGORIES' bullet: #bulletFindTranspWhiteGif);
		yourself.
		list := WebList newUnordered.
		self site blog postsCategories do: [:each |
			list addLinkTo: self site blog text: each  view: #category parameter: 'category' value: each].
		element add: list.
	^element! !

!ScriboStyle methodsFor: 'frame navigation' stamp: 'np 1/28/2008 18:35'!
navBarSearchElement
	| element |
	element := (WebElement newClass: #navdiv)
		addInputFieldAspect: #search for: self app size: 8; addText: ' ';
		add: (self searchButton registerId; yourself); 
		yourself. 
	^element! !

!ScriboStyle methodsFor: 'frame navigation' stamp: 'np 8/19/2008 17:16'!
navigationBarElement
	| element |
	element := WebElement newId: #navigation.
	element add: self navBarMainLinksElement.
	self navBarDemosIn: element.
	element add: self navBarArchivesElement.
	element add: self navBarCategoriesElement.
	element add: self navBarAdminElement.
	element add: self navBarSearchElement.
	element add: self navBarContactElement.
	^element! !

!ScriboStyle methodsFor: 'frame printing' stamp: 'np 3/28/2008 21:58'!
postFooterElementFor: aPost
	|e|
	e := WebElement new class: #postFooter.
	e addPng: #bulletTagRedPng; addText: ' Tags: '.
	aPost tokenizedTags do: [:each |
		e addLinkTo: self app observee text: each view: #tag parameter: 'tag' value: each; addText: ' '].
	e addText: ' |'.
	e addPng: #bulletCommentPng; 
		addLinkTo: aPost text: aPost approvedComments size asString, ' comments' view: #addComment.
	^e! !

!ScriboStyle methodsFor: 'frame printing' stamp: 'np 3/22/2008 02:27'!
postHeaderElementFor: aPost
	| e author |
	aPost modifiedByText isEmpty 
		ifTrue: [author := aPost createdByText]
		ifFalse: [author := aPost modifiedByText].
	e := WebElement new class: #postHeader.
	e addLinkTo: aPost text: aPost title header: 1.
	e addPng: #calendar5Gif; addText: aPost readyTimestampText,' by ', author.
	^e! !

!ScriboStyle methodsFor: 'frame printing' stamp: 'np 1/23/2008 13:00'!
siteContentClass
	"override that if you have your own SiteContent and SiteContentApp subclasses"
	^SiteContent! !

!ScriboStyle methodsFor: 'frame printing' stamp: 'np 1/23/2008 13:00'!
sitePageClass
	"override that if you have your own SitePage and App subclasses"
	^SitePage! !

!ScriboStyle methodsFor: 'frame printing' stamp: 'np 2/2/2008 21:51'!
sitePageFrameWith: aWebElement title: aTitleString
	| element |
	self app title: aTitleString.
	element := (WebElement newId: #container)
		add: self headerElement;
			add: ((WebElement newId: #sitePage)
			add: aWebElement;  
			yourself); 
		yourself.
	^self app add: element; yourself! !

!ScriboStyle methodsFor: 'frame printing' stamp: 'np 1/23/2008 12:58'!
tabsElement
 	| tabs |
	tabs := WikiPageTabs new
		addFirstPageWithDescription: 'Introduction';
		addPage: 'News' description: 'News';
		addPage: 'Products' description: 'Products';
		addPage: 'Services' description: 'Services';
		addPage: 'Partners' description: 'Partners';
		addPage: 'Customers' description: 'Customers';
		addPage: 'About' description: 'About Us'.
	^tabs! !

!ScriboStyle methodsFor: 'frame printing' stamp: 'np 1/23/2008 12:57'!
wikiClass
	"override that if you have your own Wiki and WikiApp subclasses"
	^Wiki! !

!ScriboStyle methodsFor: 'frame printing' stamp: 'np 1/23/2008 12:57'!
wikiPageClass
	"override that if you have your own WikiPage and WikiPageApp subclasses"
	^WikiPage! !

!ScriboStyle methodsFor: 'frame printing' stamp: 'np 1/24/2008 20:29'!
wikiPageFrameWith: aWebElement title: aTitleString
	"called from WikiPageApp and SitePageApp"
	^self wikiPageFrameWith: aWebElement wide: WebElement new title: aTitleString
	! !

!ScriboStyle methodsFor: 'frame printing' stamp: 'np 1/24/2008 20:29'!
wikiPageFrameWith: aWebElement wide: aWideElement title: aTitleString
	"set a wiki page with standard  page look (navigation bar, header) "
	"Wide element comes below content besides navigation and it have full page width"
	| element |
	self app clear;  title: aTitleString. self app htmlHeaderElements.
	element := (WebElement newId: #container)
		add: self headerElement; 	add: self headerDashboard;
		add: ((WebElement newId: #wikiPage) 
			add: self navigationBarElement; add: aWebElement;  yourself); 
		add: ((WebElement newId: #contentWide)
			add: aWideElement; yourself);
		yourself.
	^self app add: element; yourself! !

WebMethodResource subclass: #WebRSSResource
	instanceVariableNames: 'description title url generator webMaster feeds feedEntries'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scribo-RSS'!

!WebRSSResource class methodsFor: 'instance creation' stamp: 'np 10/28/2007 13:29'!
new
	^super new initialize! !

!WebRSSResource class methodsFor: 'instance creation' stamp: 'np 6/21/2008 19:42'!
newFor: aSite
	^super new 
		site: aSite;
		initialize;
		yourself! !

!WebRSSResource methodsFor: 'accessing' stamp: 'np 10/28/2007 19:15'!
contentType
	contentType isNil ifTrue: [contentType := 'application/rss+xml'].
	^contentType! !

!WebRSSResource methodsFor: 'accessing' stamp: 'np 10/31/2007 21:06'!
defaultGenerator
	^'AIDA/Web, Smalltalk Web Application Server'.! !

!WebRSSResource methodsFor: 'accessing' stamp: 'np 4/5/2008 14:38'!
description
	description isNil ifTrue: [description := ''].
	^description! !

!WebRSSResource methodsFor: 'accessing' stamp: 'np 10/28/2007 03:17'!
description: aString
	description := aString! !

!WebRSSResource methodsFor: 'accessing' stamp: 'np 10/28/2007 23:39'!
feedEntries
	^feedEntries! !

!WebRSSResource methodsFor: 'accessing' stamp: 'np 10/28/2007 23:39'!
feedEntries: aCollection
	feedEntries := aCollection! !

!WebRSSResource methodsFor: 'accessing' stamp: 'np 10/28/2007 03:20'!
generator
	^generator! !

!WebRSSResource methodsFor: 'accessing' stamp: 'np 10/28/2007 03:21'!
generator: aString
	generator := aString! !

!WebRSSResource methodsFor: 'initialize-release' stamp: 'np 10/31/2007 21:06'!
initialize
	super initialize.
	self feedEntries: OrderedCollection new.
	self generator: self defaultGenerator.! !

!WebRSSResource methodsFor: 'printing' stamp: 'np 1/25/2008 19:25'!
printFeedEntry: aFeedEntry on: aStream forSession: aSession
	| author |
	aStream nextPutAll: '<item>'; cr.
		aStream nextPutAll: '<title>'; nextPutAll: aFeedEntry title; nextPutAll: '</title>'; cr.
		aStream nextPutAll: '<link>'; nextPutAll: aFeedEntry directUrl; nextPutAll: '</link>'; cr.
		
		"description"
		aStream nextPutAll: '<description>'.
		aStream nextPutAll: '<!![CDATA[', aFeedEntry message, ']]>'. 
		aStream nextPutAll: '</description>'; cr.
		
		"pubDate"
		aStream nextPutAll: '<pubDate>'.
		aStream nextPutAll: aFeedEntry timeStamp printHttpFormat.
		aStream nextPutAll: '</pubDate>'; cr.
		
		"author"
		author := aFeedEntry author.
		author notNil ifTrue: [
			aStream nextPutAll: '<author>'; nextPutAll: author; nextPutAll: '</author>'; cr ].

		"category"
		aFeedEntry tags notNil ifTrue: [
			aStream nextPutAll: '<category>'.
			aFeedEntry tags do: [ :each |
				aStream nextPutAll: ', '.
				aStream nextPutAll: each].
			aStream nextPutAll: '</category>'; cr.].
		
	aStream nextPutAll: '</item>'; cr.! !

!WebRSSResource methodsFor: 'printing' stamp: 'janko 7/18/2008 20:41'!
printHTMLPageOn: aStream for: aRequest on: aSession 
	aStream
		nextPutAll: '<?xml version="1.0" encoding="iso-8859-1"?>' ;
		cr.
	aStream
		nextPutAll: '<rss version="2.0">' ;
		cr.
	aStream
		nextPutAll: '<channel>' ;
		cr ;
		nextPutAll: '  <title>' , (AIDASite 
					convertToWeb: self title
					on: aSession) , '</title>' ;
		cr.
	aStream
		nextPutAll: '<description>' ;
		nextPutAll: (AIDASite 
				convertToWeb: self description
				on: aSession) ;
		nextPutAll: '</description>' ;
		cr.
	aStream
		nextPutAll: '<link>' ;
		nextPutAll: self url ;
		nextPutAll: '</link>' ;
		cr.
	aStream
		nextPutAll: '<generator>' ;
		nextPutAll: (AIDASite 
				convertToWeb: self generator
				on: aSession) ;
		nextPutAll: '</generator>' ;
		cr.
	aStream
		nextPutAll: '<webMaster>' ;
		nextPutAll: (AIDASite 
				convertToWeb: self webMaster email
				on: aSession) ;
		nextPutAll: '</webMaster>' ;
		cr.
	aStream
		nextPutAll: '<docs>' ;
		nextPutAll: 'http://www.rssboard.org/rss-specification' ;
		nextPutAll: '</docs>' ;
		cr.
	self 
		printListingOn: aStream
		forSession: aSession.
	aStream
		nextPutAll: '</channel>' ;
		cr.
	aStream
		nextPutAll: '</rss>' ;
		cr! !

!WebRSSResource methodsFor: 'printing' stamp: 'np 10/28/2007 23:38'!
printListingOn: aStream forSession: aSession
	self feedEntries do: [ :feedEntry |
		self printFeedEntry: feedEntry on: aStream forSession: aSession]! !

!WebRSSResource methodsFor: 'accessing' stamp: 'np 4/5/2008 14:38'!
title
	title isNil ifTrue: [title := ''].
	^title! !

!WebRSSResource methodsFor: 'accessing' stamp: 'np 10/28/2007 16:05'!
title: aString
	title := aString! !

!WebRSSResource methodsFor: 'accessing' stamp: 'np 1/25/2008 19:31'!
url
	url isNil ifTrue: [url := 'http://', self site host, ':', self site port printString].
	^url! !

!WebRSSResource methodsFor: 'accessing' stamp: 'np 10/28/2007 03:20'!
url: aString
	url := aString! !

!WebRSSResource methodsFor: 'accessing' stamp: 'np 4/5/2008 19:50'!
webMaster
	webMaster isNil ifTrue: [webMaster := WebUser new].
	^webMaster! !

!WebRSSResource methodsFor: 'accessing' stamp: 'np 10/28/2007 03:21'!
webMaster: aString
	webMaster := aString! !

!SpDate methodsFor: '*Scribo-Core' stamp: 'np 3/29/2008 05:27'!
asSeconds
	^self underlyingDate asSeconds ! !

!SpTimestamp methodsFor: '*Scribo-Blog' stamp: 'np 2/2/2008 16:33'!
asMonth
	^self underlyingTimestamp asMonth! !

!SpTimestamp methodsFor: '*Scribo-RSS' stamp: 'np 10/28/2007 23:32'!
printHttpFormat
	^String streamContents: [ :strm | self printHttpFormatOn: strm]! !

!SpTimestamp methodsFor: '*Scribo-RSS' stamp: 'np 10/28/2007 23:35'!
printHttpFormatOn: aStream
	"Print receiver's date and time on aStream in HTTP format;
	'<day>, DD <mth> YYYY HH:MM:SS GMT' ->	'Thu, 01 Dec 1994 16:00:00 GMT'
	"
	
	| d t |
	d := self asDate underlyingDate.
	t := self asTime.
	aStream nextPutAll: (d weekday copyFrom: 1 to: 3).
	aStream nextPutAll: ', '.
	d printOn: aStream format: #(1 2 3 $  2 1 2).
	aStream nextPut: $ .
	t print24: true on: aStream.
	aStream nextPutAll: ' GMT'.! !

!PositionableStream methodsFor: '*Scribo-Wiki' stamp: 'np 1/23/2008 09:49'!
insensitivePeekForAll: aCollection 
	| orig |
	self atEnd ifTrue: [^false].
	orig := self position.
	((self next: aCollection size) sameAs: aCollection) 
		ifTrue: [^true].
	self position: orig.
	^false! !

!PositionableStream methodsFor: '*Scribo-Wiki' stamp: 'np 1/23/2008 09:49'!
peekForAll: aCollection 
	| orig |
	self atEnd ifTrue: [^false].
	orig := self position.
	(self next: aCollection size) = aCollection ifTrue: [^true].
	self position: orig.
	^false! !

!PositionableStream methodsFor: '*Scribo-Wiki' stamp: 'np 1/23/2008 09:49'!
skipThrough: anObject
	"Skip forward to the occurrence of anObject.
	 Leaves positioned after anObject. 
	If the object is not found the stream is positioned at the end and nil is returned."

	[self atEnd ifTrue: [^nil].
	self next = anObject ifTrue: [^self]] repeat! !

!PositionableStream methodsFor: '*Scribo-Wiki' stamp: 'np 1/23/2008 09:49'!
through: anObject
	"Answer a subcollection from the current position to the occurrence (if any, inclusive)
	of anObject. If not there, answer everything."

	| newStream element |
	newStream := (collection species new: 64) writeStream.
	[self atEnd]
		whileFalse:
			[element := self next.
			newStream nextPut: element.
			element = anObject ifTrue: [^newStream contents]].
	^newStream contents! !

!PositionableStream methodsFor: '*Scribo-Wiki' stamp: 'np 1/23/2008 09:48'!
upTo: anObject escaper: anotherObject 
	"from WikiWorks"
	| newStream |
	newStream := (collection species new: 64) writeStream.
	[self atEnd] whileFalse: 
			[| element |
			(element := self next) = anotherObject 
				ifTrue: 
					[newStream nextPut: ((self peekFor: anObject) 
								ifTrue: [anObject]
								ifFalse: [anotherObject])]
				ifFalse: 
					[element = anObject ifTrue: [^newStream contents].
					newStream nextPut: element]].
	^newStream contents! !

VersionedObject subclass: #Information
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scribo-Core'!

Information subclass: #DocGroup
	instanceVariableNames: 'documents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scribo-Core'!

!DocGroup methodsFor: 'adding-removing' stamp: 'np 1/18/2008 10:58'!
add: aDocument
	self documents add: aDocument.
	aDocument docGroup: self.
	^aDocument! !

!DocGroup methodsFor: 'accessing' stamp: 'np 1/18/2008 10:58'!
documents
	documents isNil ifTrue: [self initDocuments].
	^documents! !

!DocGroup methodsFor: 'initialize-release' stamp: 'np 1/18/2008 10:57'!
initDocuments
	documents := Set new.! !

Information subclass: #Document
	instanceVariableNames: 'acl attachments attributes other persons references subdocuments timestamps body id parent title type status'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scribo-Core'!

Document subclass: #BlogComment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scribo-Blog'!

!BlogComment methodsFor: 'accessing' stamp: 'np 6/21/2008 19:40'!
asRSSFeed
	^WebRSSFeedEntry new
		title: self title;
		author: self createdByText;
		message: self htmlBody;
		directUrl: self blog rssRootUrl, self preferedUrl;
		timeStamp: self createdTimestamp;
		yourself! !

!BlogComment methodsFor: 'accessing' stamp: 'np 2/1/2008 13:48'!
blog
	^self post blog! !

!BlogComment methodsFor: 'private' stamp: 'np 3/20/2008 03:43'!
copyContentsTo: aBlogComment
	"to start a new version from current content"
	super copyContentsTo: aBlogComment.
	aBlogComment status: self status.
	self copyTimestampsTo: aBlogComment.
	aBlogComment setModifiedTimestamp.! !

!BlogComment methodsFor: 'private' stamp: 'np 3/20/2008 03:43'!
copyTimestampsTo: anObject
	super copyTimestampsTo: anObject.
	anObject timestampsAt: #created put: (self timestampsAt: #created)! !

!BlogComment methodsFor: 'accessing' stamp: 'np 1/30/2008 16:35'!
htmlBody
	| htmlBody |
	(self body isNil) ifTrue: [htmlBody := '']
		ifFalse: 
		[htmlBody := self body 
		 	copyReplaceAll: (String with: Character cr)
			with: '<br>'].
	^htmlBody! !

!BlogComment methodsFor: 'testing' stamp: 'np 1/23/2008 15:07'!
isBlogComment
	^true! !

!BlogComment methodsFor: 'accessing' stamp: 'np 2/2/2008 16:43'!
post
	^self parent! !

!BlogComment methodsFor: 'private' stamp: 'np 3/28/2008 21:57'!
preferedUrl
	| url |
	url :=  ('/blog/', (self post title replaceSpecialCharacters asLowercase 
		copyReplaceAll: '/' with: '-'), '/comments/', 
		((self post approvedComments) indexOf: self) printString).
	^url, '.html'! !

!BlogComment methodsFor: 'actions' stamp: 'np 3/28/2008 20:00'!
setApprovedBy: aWebUser
	"one approver is enough for a comment!!"
	self setReadyBy: aWebUser.
	self approvedBy: aWebUser.
	self status:  #approved.
	self setApprovedTimestamp.
	self setModifiedBy: aWebUser.! !

!BlogComment methodsFor: 'accessing' stamp: 'np 1/23/2008 15:10'!
subdocuments
	"Comments do not have subdocuments"
	^nil! !

!BlogComment methodsFor: 'accessing' stamp: 'np 1/25/2008 17:45'!
title
	^'Comment on ''', self post title, ''''! !

!BlogComment methodsFor: 'accessing' stamp: 'np 2/13/2008 02:38'!
updateUrl
	self post repository site urlResolver changeToPreferedURL: self newestVersion! !

Document subclass: #Comment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scribo-Core'!

!Comment methodsFor: 'testing' stamp: 'np 1/21/2008 08:31'!
isComment
	^true! !

!Document class methodsFor: 'instance creation' stamp: 'np 6/23/2008 00:20'!
newCreatedBy: aWebUser
	^self new 
		setCreatedTimestamp; 
		createdBy: aWebUser;
		yourself! !

!Document class methodsFor: 'printing' stamp: 'np 1/17/2008 22:53'!
printOn: aStream
	aStream nextPutAll: self name! !

!Document methodsFor: 'accessing-persons' stamp: 'np 1/17/2008 18:34'!
accessedBy
	"who last accessed"
	^self personsAt: #accessedBy! !

!Document methodsFor: 'accessing-persons' stamp: 'np 1/19/2008 11:43'!
accessedBy: aWebUserOrPerson
	self personsAt: #accessedBy put: (aWebUserOrPerson asPerson)! !

!Document methodsFor: 'accessing-timestamps' stamp: 'np 1/17/2008 19:13'!
accessedTimestamp
	^self timestampsAt: #accessed! !

!Document methodsFor: 'private' stamp: 'np 1/17/2008 22:45'!
acl
	"access rights list"
	^acl! !

!Document methodsFor: 'accessing-persons' stamp: 'np 1/20/2008 11:12'!
addApprover: aPerson
	(self approvers includes: aPerson asPerson) ifFalse: [self basicApprovers add: aPerson asPerson].! !

!Document methodsFor: 'attachments' stamp: 'np 1/17/2008 22:38'!
addAttachment: anAttachment
	attachments isNil ifTrue: [self initAttachments].
	(self attachments includes: anAttachment) ifTrue: [^nil].
	self attachments add: anAttachment.
	anAttachment parent: self.! !

!Document methodsFor: 'accessing-persons' stamp: 'np 1/20/2008 11:13'!
addAuthor: aPerson
	(self authors includes: aPerson asPerson) ifFalse: [self basicAuthors add: aPerson asPerson].! !

!Document methodsFor: 'adding-removing' stamp: 'np 1/17/2008 22:36'!
addChapter
	"just add an empty chapter"
	self addChapter: DocumentChapter new! !

!Document methodsFor: 'adding-removing' stamp: 'np 1/17/2008 22:36'!
addChapter: aDocumentChapter
	aDocumentChapter isChapter ifFalse: [^nil].
	self addSubdocument: aDocumentChapter! !

!Document methodsFor: 'adding-removing' stamp: 'np 1/17/2008 22:36'!
addComment: aComment
	aComment isComment ifFalse: [^nil].
	self addSubdocument: aComment! !

!Document methodsFor: 'adding-removing' stamp: 'np 1/17/2008 22:37'!
addDocument: aDocument
	"a subdocument actually!! "
	(aDocument isKindOf: Document) ifFalse: [^nil].
	self addSubdocument: aDocument! !

!Document methodsFor: 'adding-removing' stamp: 'np 1/17/2008 22:37'!
addGallery: aGallery
	aGallery isGallery ifFalse: [^nil].
	self addSubdocument: aGallery! !

!Document methodsFor: 'multilingual' stamp: 'np 1/17/2008 22:41'!
addLanguage: aLanguageCodeSymbol
	"add a document in that language to a doc group, if not already, and return it"
	(self existLanguage: aLanguageCodeSymbol) ifTrue: [^self forLanguage: aLanguageCodeSymbol].
	self isInDocGroup ifFalse: [self initDocGroup].
	^self docGroup add: (self class new language: aLanguageCodeSymbol)! !

!Document methodsFor: 'adding-removing' stamp: 'np 1/17/2008 22:37'!
addReference: aDocLink
	references isNil ifTrue: [self initReferences].
	(self references includes: aDocLink) ifTrue: [^nil].
	self references add: aDocLink.! !

!Document methodsFor: 'adding-removing' stamp: 'np 1/17/2008 22:37'!
addSubdocument: aDocument
	subdocuments isNil ifTrue: [self initSubdocuments].
	(self subdocuments includes: aDocument) ifTrue: [^nil].
	self subdocuments add: aDocument.
	aDocument parent: self.! !

!Document methodsFor: 'locking' stamp: ' 19/3/08 18:13'!
aidaIsLocked
	"is document locked permanently or temporary and not yet timeout?"
	self isLockTypeNone ifTrue: [^false].
	self isLockTypePermanent ifTrue: [^true].
	^self isLockExpired not! !

!Document methodsFor: 'locking' stamp: ' 19/3/08 18:13'!
aidaIsLockedOn: aWebSession
	"is document locked exclusively on that session?"
	^WebTransactionMonitor critical:
		[self aidaIsLocked and: [self lockedOn == aWebSession] ]! !

!Document methodsFor: 'locking' stamp: ' 19/3/08 18:13'!
aidaLockOn: aWebSession
	"get an permanent exclusive lock on that document. Until unlocked, noone else can get that lock. 
	Return false if already locked on some other session, true if successfull"
	^WebTransactionMonitor critical:
		[self aidaIsLocked ifTrue: [^self lockedOn == aWebSession].
		self setLockTimestamp.
		self setLockTypePermanent.
		self setLockedOn: aWebSession.
		true].! !

!Document methodsFor: 'locking' stamp: ' 19/3/08 18:13'!
aidaLockTemporaryOn: aWebSession
	"get or regrant a temporary exclusive lock on that document. Until lock expires or unlocked,
	noone else can get that lock. User needs to regrant lock before it expires to retain it, otherwise it will 
	loose it. Handy for web editing forms, which with Ajax periodically updating element regrant that lock,       until user submit or go to some other page.
	Return false if already locked on some other session, true if successfull"
	^WebTransactionMonitor critical:
		[self aidaIsLocked ifTrue: [(self aidaIsLockedOn: aWebSession) ifFalse: [^false] ].
		self setLockTimestamp.
		self setLockTypeTemporary.
		self setLockedOn: aWebSession.
		true].! !

!Document methodsFor: 'locking' stamp: ' 19/3/08 18:13'!
aidaUnlock
	"release an exclusive lock if any"
	^WebTransactionMonitor critical:
		[self setLockTypeNone.
		self setLockTimestamp.
		true]! !

!Document methodsFor: 'access rights' stamp: 'np 1/17/2008 18:27'!
allAccessors
	"Empty means all!!"
	self acl isNil ifTrue: [^OrderedCollection new].
	^(self acl at: #access ifAbsent: [#()]) asOrderedCollection! !

!Document methodsFor: 'accessing' stamp: 'np 1/17/2008 18:30'!
allChapters
	^self subdocuments select: [:each | each isChapter]! !

!Document methodsFor: 'accessing' stamp: 'np 1/17/2008 18:30'!
allComments
	^self subdocuments select: [:each | each isComment]! !

!Document methodsFor: 'access rights' stamp: 'np 1/17/2008 18:27'!
allDeletors
	"Empty means all!!"
	self acl isNil ifTrue: [^OrderedCollection new].
	^(self acl at: #delete ifAbsent: [#()]) asOrderedCollection! !

!Document methodsFor: 'accessing' stamp: 'np 1/17/2008 18:30'!
allGalleries
	"all image galeries on this page"
	^self subdocuments select: [:each | each isGallery]! !

!Document methodsFor: 'access rights' stamp: 'np 1/17/2008 18:28'!
allUpdators
	"Empty means all!!"
	self acl isNil ifTrue: [^OrderedCollection new].
	^(self acl at: #update ifAbsent: [#()]) asOrderedCollection! !

!Document methodsFor: 'access rights' stamp: 'np 1/20/2008 10:33'!
allowAccessTo: aPersonOrWebUserOrWebGroup
	| acls entry |
	self acl isNil ifTrue: [self initAcl].
	acls := self acl at: #access ifAbsentPut: [Set new].
	entry := aPersonOrWebUserOrWebGroup isWebUser
		ifTrue: [aPersonOrWebUserOrWebGroup asPerson]
		ifFalse: [aPersonOrWebUserOrWebGroup].
	acls add: entry! !

!Document methodsFor: 'access rights' stamp: 'np 1/17/2008 18:27'!
allowAccessToAll
	self initAcl.! !

!Document methodsFor: 'access rights' stamp: 'np 1/20/2008 10:34'!
allowDeleteTo: aPersonOrWebUserOrWebGroup
	| acls entry |
	self acl isNil ifTrue: [self initAcl].
	acls := self acl at: #delete ifAbsentPut: [Set new].
	entry := aPersonOrWebUserOrWebGroup isWebUser
		ifTrue: [aPersonOrWebUserOrWebGroup asPerson]
		ifFalse: [aPersonOrWebUserOrWebGroup].
	acls add: entry! !

!Document methodsFor: 'access rights' stamp: 'np 1/20/2008 10:34'!
allowPrintingTo: aPersonOrWebUserOrWebGroup
	| acls entry |
	self acl isNil ifTrue: [self initAcl].
	acls := self acl at: #printing ifAbsentPut: [Set new].
	entry := aPersonOrWebUserOrWebGroup isWebUser
		ifTrue: [aPersonOrWebUserOrWebGroup asPerson]
		ifFalse: [aPersonOrWebUserOrWebGroup].
	acls add: entry! !

!Document methodsFor: 'access rights' stamp: 'np 1/20/2008 10:34'!
allowUpdateTo: aPersonOrWebUserOrWebGroup
	| acls entry |
	self acl isNil ifTrue: [self initAcl].
	acls := self acl at: #update ifAbsentPut: [Set new].
	entry := aPersonOrWebUserOrWebGroup isWebUser
		ifTrue: [aPersonOrWebUserOrWebGroup asPerson]
		ifFalse: [aPersonOrWebUserOrWebGroup].
	acls add: entry! !

!Document methodsFor: 'accessing' stamp: 'np 1/17/2008 18:30'!
app
	"a WebApplication who is calling that doc if any. Find it from stack"
	^self firstAppFromStack! !

!Document methodsFor: 'accessing-persons' stamp: 'np 1/17/2008 18:34'!
approvedBy
	"a dictionary of approvers and timestamps of their approval"
	| dict person |
	dict := self personsAt: #approvedBy ifAbsent: [self personsAt: #approvedBy put: Dictionary new]. 
	dict class == Dictionary ifFalse: "migrate from single approver"
		[person := dict asPerson notNil ifTrue: [dict asPerson] ifFalse: [dict].
		dict := Dictionary new at: person  put: self approvedTimestamp; yourself.
		self personsAt: #approvedBy put: dict].
	^dict! !

!Document methodsFor: 'accessing-persons' stamp: 'np 1/17/2008 18:34'!
approvedBy: aWebUser
	| person |
	person := aWebUser asPerson notNil ifTrue: [aWebUser asPerson] ifFalse: [aWebUser].
	((self approvers includes: person) or: [self isApproversDeputy: person])
		ifFalse: [aWebUser asWebUser isAdmin ifFalse: [^nil]]. "don't allow everyone to approve!! "
	(self hasRoleAsApproversDeputy: person)
		ifFalse: [self approvedBy at: person put: SpTimestamp now]
		ifTrue: [self approvedByDeputy: aWebUser]! !

!Document methodsFor: 'accessing-persons' stamp: 'np 1/17/2008 18:35'!
approvedByDeputy: aWebUser
	| person deputyOf |
	person := aWebUser asPerson notNil ifTrue: [aWebUser asPerson] ifFalse: [aWebUser].
	deputyOf := person allDeputyOf  detect: [:each | self approversYetToApprove includes: each].
	self approvedBy at: deputyOf put: SpTimestamp now.
	self approversDeputies add: (person -> deputyOf )! !

!Document methodsFor: 'accessing-timestamps' stamp: 'np 1/19/2008 20:27'!
approvedDate
	self approvedTimestamp isNil ifTrue: [^nil].
	^self approvedTimestamp asDate! !

!Document methodsFor: 'private' stamp: 'np 1/17/2008 22:45'!
approvedDate: aDateOrString
	| date |
	date := (aDateOrString isKindOf: String) 
		ifTrue: [date := Date readSloFrom: aDateOrString readStream] ifFalse: [aDateOrString].
	date isNil ifTrue: [^nil].
	self timestampsAt: #approved put: date asSpTimestamp.! !

!Document methodsFor: 'accessing-timestamps' stamp: 'np 1/17/2008 19:14'!
approvedTimestamp
	^self timestampsAt: #approved! !

!Document methodsFor: 'accessing-persons' stamp: 'np 1/20/2008 11:10'!
approvers
	"all approvers, including owner, who is a main one. All need to approve a doc before status is 
	changed to approved!!"
	| set |
	set := self basicApprovers copy.
	self owner notNil ifTrue: [set add: self owner].
	^set! !

!Document methodsFor: 'accessing-persons' stamp: 'np 1/17/2008 18:35'!
approversDeputies
	"if a deputy approved, then put him here!! "
	| deputies |
	deputies := self personsAt: #approversDeputies.
	deputies isNil ifTrue: [deputies := self personsAt:  #approversDeputies put: Set new].
	^deputies! !

!Document methodsFor: 'accessing-persons' stamp: 'np 1/17/2008 18:36'!
approversYetToApprove
	"those who need to approve yet a document"
	| yet deputiesOf |
	yet := self approvers reject: [:each | self approvedBy includesKey: each].
	deputiesOf :=  self approversDeputies collect: [:each | each value "deputy of who"].
	^yet reject: [:each | deputiesOf includes: each].! !

!Document methodsFor: 'access rights' stamp: 'np 1/17/2008 18:28'!
areAccessRightsSet
	^self acl notNil and: [(self acl includesKey: #access) and: [(self acl at: #access) notEmpty]]! !

!Document methodsFor: 'accessing' stamp: 'np 1/17/2008 18:30'!
asHtmlWithSubchapters
	"one Html with all subchapters, handy for printing and PDF creation. No CSS!! "
	| out subchapter |
	out := WriteStream on: (String new: 10000).
	out nextPutAll: '<html><head><title>', self title, '</title></head>'.
	out nextPutAll: '<body><h1>', self title, '</h1>'.
	out nextPutAll: self body.
	self allChapters do: [:chapter |
		subchapter := (chapter id notEmpty ifTrue: [chapter id, ' '] ifFalse: ['']), chapter title.
		out nextPutAll: '<h2>', subchapter, '</h2>'.
		out nextPutAll: chapter body].
	out nextPutAll: '</body></html>'.
	^out contents! !

!Document methodsFor: 'accessing-other' stamp: 'np 1/17/2008 18:33'!
asPDFCreatorResource
	| creator |
	^self otherAt: #PDFCreatorResource ifAbsent: 
		[creator := (WebLivePDFCreator fromHtmlMethod: #asHtmlWithSubchapters 
			on: self site: self repository site).
		self otherAt:  #PDFCreatorResource put: creator.
		^creator]! !

!Document methodsFor: 'attachments' stamp: 'np 1/17/2008 22:39'!
attachFile: aFilenameString named: aString
	"attach a file from disk and name it differently"
	| attachment |
	attachment := Attachment new parent: self.
	attachment 	
		origFilename: aString;
		setUrl; setContentType;
		storeContentFromFilename: aFilenameString.
	self addAttachment: attachment.
	attachment makeProxy.
	^attachment! !

!Document methodsFor: 'attachments' stamp: 'np 1/17/2008 22:39'!
attachFilename: aString
	"attach a file from disk"
	^self attachFile: aString named: (SpFilename named: aString) tail! !

!Document methodsFor: 'attachments' stamp: 'np 1/17/2008 22:40'!
attachFilename: aString content: aByteArray
	"save content as an attachment with that filename"
	| attachment |
	attachment := Attachment new parent: self.
	attachment 	
		origFilename: aString;
		setUrl; setContentType;
		storeContent: aByteArray.
	self addAttachment: attachment.
	attachment makeProxy.
	^attachment! !

!Document methodsFor: 'attachments' stamp: 'np 1/17/2008 22:40'!
attachmentWithFilename: aString
	^self attachments detect: [:each | each origFilename = aString] ifNone: [nil]! !

!Document methodsFor: 'attachments' stamp: 'np 1/17/2008 22:40'!
attachmentWithUuid: aString
	^self attachments detect: [:each | each uuid = aString] ifNone: [nil]! !

!Document methodsFor: 'private' stamp: 'np 1/17/2008 22:45'!
attachments
	attachments isNil ifTrue: [^OrderedCollection new].
	^attachments! !

!Document methodsFor: 'private' stamp: 'np 1/17/2008 22:45'!
attachments: anOrderedCollection
	attachments := anOrderedCollection! !

!Document methodsFor: 'private' stamp: 'np 1/17/2008 22:45'!
attributes
	^attributes! !

!Document methodsFor: 'private' stamp: 'janko 3/16/2008 13:38'!
attributesAt: aSymbol
	^self attributesAt: aSymbol ifAbsent: [nil]! !

!Document methodsFor: 'private' stamp: 'janko 3/16/2008 14:24'!
attributesAt: aSymbol  ifAbsent: aBlock
	self attributes isNil ifTrue: [^aBlock value].
	^self attributes at: aSymbol  ifAbsent: aBlock! !

!Document methodsFor: 'private' stamp: 'janko 3/16/2008 14:25'!
attributesAt: aSymbol put: anObject
	self attributes isNil ifTrue: [self initAttributes].
	self attributes at: aSymbol put: anObject! !

!Document methodsFor: 'accessing-persons' stamp: 'np 1/20/2008 11:13'!
authors
	"all authors including maintainer, who is a main one"
	| set |
	set := self basicAuthors copy.
	self maintainer notNil ifTrue: [set add: self maintainer].
	^set! !

!Document methodsFor: 'private-maintenance' stamp: 'np 1/17/2008 22:51'!
backFromObsoletePersonsAndTimestamps
	self removeObsoleteBy.
	self removeObsoleteTimestamp.
	(self backFromObsoleteStatus ~= #released) ifTrue:
		[self removeReleasedBy.
		self removeReleasedTimestamp].
	(#(approved released) includes: self backFromObsoleteStatus) not ifTrue:
		[self removeApprovedBy.
		self removeApprovedTimestamp].! !

!Document methodsFor: 'private-maintenance' stamp: 'np 1/17/2008 22:51'!
backFromObsoleteStatus
	self releasedTimestamp notNil ifTrue: [^#released].
	self approvedTimestamp notNil ifTrue: [^#approved].
	^#ready! !

!Document methodsFor: 'accessing-persons' stamp: 'np 1/20/2008 11:10'!
basicApprovers
	| set |
	set := (self personsAt: #approvers ifAbsent: 
		[self personsAt: #approvers put: Set new]).
	^set! !

!Document methodsFor: 'accessing-persons' stamp: 'np 1/20/2008 11:12'!
basicAuthors
	| set |
	set := (self personsAt: #authors ifAbsent: 
		[self personsAt: #authors put: Set new]).
	^set! !

!Document methodsFor: 'accessing' stamp: 'np 1/17/2008 18:30'!
body
	body isNil ifTrue: [^''].
	^body! !

!Document methodsFor: 'accessing' stamp: 'np 1/17/2008 18:30'!
body: aString
	"content of document"
	body := aString! !

!Document methodsFor: 'versions' stamp: 'np 1/17/2008 22:44'!
canOpenNewVersion
	^(self isNewestVersion & self isCurrentVersion)! !

!Document methodsFor: 'accessing-timestamps' stamp: 'np 1/17/2008 19:14'!
checkValidFromDate
	"if set, it should be equal or greater from released date!! Set to released date, if not so"
	self validFromDate isNil ifTrue: [^nil].
	(self isReleased and: [self releasedDate > self validFromDate])
		ifTrue: [self validFromDate: self releasedDate].! !

!Document methodsFor: 'accessing-other' stamp: 'np 1/21/2008 08:13'!
classificationLevel
	"level of doc sensivity and restriction of access (like 'top secret'). 
	See ClassificationLevel class for more"
	^self otherAt: #classificationLevel ifAbsent: [nil]! !

!Document methodsFor: 'accessing-other' stamp: 'np 1/21/2008 08:13'!
classificationLevel: aClassificationLevel
	"level of doc sensivity and restriction of access (like 'top secret'). 
	See ClassificationLevel class for more"
	^self otherAt: #classificationLevel put: aClassificationLevel! !

!Document methodsFor: 'accessing-other' stamp: 'np 1/21/2008 08:13'!
classificationLevelName
	"display name of level of doc sensivity and restriction of access (like 'top secret'). 
	See ClassificationLevel class for more"
	^(self otherAt: #classificationLevel ifAbsent: [^'']) name! !

!Document methodsFor: 'accessing-persons' stamp: 'np 1/17/2008 18:36'!
coApprovers
	"all approvers, except owner. You can add or remove directly from that collection!!"
	^self personsAt: #approvers ifAbsent: 
		[self personsAt: #approvers put: Set new]! !

!Document methodsFor: 'accessing-persons' stamp: 'np 1/17/2008 18:37'!
coAuthors
	"all authors, except maintainer. You can add or remove authors sirecty to this collection"
	^self personsAt: #authors ifAbsent: 
		[self personsAt: #authors put: Set new]! !

!Document methodsFor: 'private-maintenance' stamp: 'np 1/17/2008 22:51'!
convertFromFullToLinksOnlyWikiFormat
	"after rich text editor is introduced, we need to convert full wiki content to normal html
	except links in square brackets, which are still very usefull!! "
	self body: self body asWikiExceptLinksHtml! !

!Document methodsFor: 'private-copying' stamp: 'np 1/17/2008 22:50'!
copyAccessListTo: anObject
	self acl isNil ifTrue: [^nil].
	anObject initAcl.
	self acl keysAndValuesDo: [:key :set | anObject acl at: key put: set copy]! !

!Document methodsFor: 'private-copying' stamp: 'np 3/28/2008 03:08'!
copyAttachment: anAttachment filename: aFilenameString to: anObject
	| stream |
	[stream := (SpFilename named: anAttachment filePath) readStream binary.
	anObject attachFilename: aFilenameString content: stream contents] 
		ensure: [stream notNil ifTrue: [stream close] ]! !

!Document methodsFor: 'private-copying' stamp: 'np 1/17/2008 22:50'!
copyAttachment: anAttachment to: anObject
	self copyAttachment: anAttachment filename: anAttachment origFilename to: anObject! !

!Document methodsFor: 'private-copying' stamp: 'np 1/17/2008 22:50'!
copyAttachmentsTo: anObject
	"copy attached files too!! "
	self attachments isNil ifTrue: [^nil].
	anObject initAttachments.
	self attachments do: [:each |
		each exists ifTrue: "file still exist"
			[each isImageAttachment 
				ifTrue: [self copyImageAttachment: each to: anObject] "don't copy image files"
				ifFalse: [self copyAttachment: each to: anObject] ] ]! !

!Document methodsFor: 'private-copying' stamp: 'np 1/17/2008 22:50'!
copyAttributesTo: anObject
	self attributes isNil ifTrue: [^nil].
	anObject initAttributes.
	self attributes keysAndValuesDo: [:key :value | anObject attributesAt: key put: value copy].! !

!Document methodsFor: 'private-copying' stamp: 'np 1/17/2008 22:50'!
copyContentsTo: aDocument
	"to start a new version from current content"
	super copyContentsTo: aDocument.
	aDocument id: self id copy. aDocument title: self title copy. aDocument body: self body copy.
	aDocument type: self type copy. aDocument setPending.
	aDocument parent: self parent.
	self copyTimestampsTo: aDocument. self copyPersonsTo: aDocument. 
	self copyAttributesTo: aDocument. self copyOtherTo: aDocument.
	self copyAccessListTo: aDocument.
	self copySubdocumentsTo: aDocument.
	aDocument references: self references copy.
	aDocument setCreatedTimestamp. "to be sure a new directory will be set for new doc"
	self copyAttachmentsTo: aDocument.! !

!Document methodsFor: 'private-copying' stamp: 'np 1/17/2008 22:50'!
copyImageAttachment: anAttachment to: anObject
	"subclasses can redefine that"
	^self copyAttachment: anAttachment to: anObject! !

!Document methodsFor: 'private-copying' stamp: 'np 1/22/2008 14:17'!
copyOtherTo: anObject
	self other isNil ifTrue: [^nil].
	anObject initOther.
	#(#classificationLevel #notificationReport) do: [:each | 
		(self otherAt: each) notNil ifTrue: [anObject otherAt: each put: (self otherAt: each) copy]].! !

!Document methodsFor: 'private-copying' stamp: 'np 1/17/2008 22:51'!
copyPersonsTo: anObject
	self persons isNil ifTrue: [^nil].
	anObject initPersons.
	#(#created #owner #maintainer) do: [:each | 
		(self personsAt: each) notNil ifTrue: [anObject personsAt: each put: (self personsAt: each)]].
	self coAuthors do: [:each | anObject addAuthor: each]. "maintainer is first one!!"
	self coApprovers do: [:each | anObject addApprover: each]. "owner is first one!!"! !

!Document methodsFor: 'private-copying' stamp: 'np 1/17/2008 22:51'!
copySubdocumentsTo: anObject
	| new |
	self subdocuments isNil ifTrue: [^nil].
	anObject initSubdocuments.
	self subdocuments do: [:each |
		each isComment ifFalse:   "don't copy comments, we don't need them in a new version"
			[new := each class new. 
			each copyContentsTo: new.
			anObject addSubdocument: new] ]! !

!Document methodsFor: 'private-copying' stamp: 'np 1/17/2008 22:51'!
copyTimestampsTo: anObject
	self timestamps isNil ifTrue: [^nil].
	anObject initTimestamps.
	#(#validFromDate #validToDate) do: [:each | (self timestamps includes: each) 
		ifTrue: [anObject timestampsAt: each put: (self timestampsAt: each)] ]! !

!Document methodsFor: 'private-storage' stamp: 'np 6/11/2008 04:25'!
correctDir: aString
	"because already exist, add something to the name to make it unique!! "
	| dir |
	dir := aString, '-', (Random new next * 1000) rounded printString.
	(SpFilename named: dir ) exists 
		ifTrue: [self error: 'directory name still not unique!!']
		ifFalse: [(SpFilename named: dir ) asAbsoluteFilename makeDirectory].
	^dir! !

!Document methodsFor: 'accessing-persons' stamp: 'np 1/17/2008 18:37'!
createdBy
	^self personsAt: #created! !

!Document methodsFor: 'accessing-persons' stamp: 'np 1/19/2008 11:44'!
createdBy: aWebUserOrPerson
	self personsAt: #created put: aWebUserOrPerson asPerson! !

!Document methodsFor: 'accessing-persons' stamp: 'np 1/17/2008 18:38'!
createdByText
	^self createdBy notNil
		ifTrue: [self createdBy nameSurname] ifFalse: ['']! !

!Document methodsFor: 'accessing-timestamps' stamp: 'np 1/17/2008 19:14'!
createdDate
	self createdTimestamp isNil ifTrue: [self setCreatedTimestamp].
	^self createdTimestamp asDate! !

!Document methodsFor: 'accessing-timestamps' stamp: 'np 1/17/2008 19:14'!
createdTimestamp
	"creation of THIS version, not first one!!"
	^self timestampsAt: #created! !

!Document methodsFor: 'accessing-timestamps' stamp: 'np 1/17/2008 19:14'!
createdTimestampText
	^self createdTimestamp notNil
		ifTrue: [self createdTimestamp printSloString] ifFalse: ['']! !

!Document methodsFor: 'accessing-timestamps' stamp: 'np 1/17/2008 19:14'!
dateForStoring
	"..in daily values, for defining doc directory etc."
	^self createdDate! !

!Document methodsFor: 'multilingual' stamp: 'np 1/21/2008 17:34'!
defaultLanguage
	^self repository site defaultLanguage! !

!Document methodsFor: 'access rights' stamp: 'np 1/20/2008 10:35'!
disallowAccessTo: aPersonOrWebUserOrWebGroup
	| acls entry |
	self acl isNil ifTrue: [^self].
	acls := self acl at: #access ifAbsentPut: [Set new].
	entry := aPersonOrWebUserOrWebGroup isWebUser
		ifTrue: [aPersonOrWebUserOrWebGroup asPerson]
		ifFalse: [aPersonOrWebUserOrWebGroup].
	acls remove: entry ifAbsent: []! !

!Document methodsFor: 'access rights' stamp: 'np 1/20/2008 10:36'!
disallowDeleteTo: aPersonOrWebUserOrWebGroup
	| acls entry |
	self acl isNil ifTrue: [^self].
	acls := self acl at: #delete ifAbsentPut: [Set new].
	entry := aPersonOrWebUserOrWebGroup isWebUser
		ifTrue: [aPersonOrWebUserOrWebGroup asPerson]
		ifFalse: [aPersonOrWebUserOrWebGroup].
	acls remove: entry ifAbsent: []! !

!Document methodsFor: 'access rights' stamp: 'np 1/20/2008 10:36'!
disallowPrintingTo: aPersonOrWebUserOrWebGroup
	| acls entry |
	self acl isNil ifTrue: [^self].
	acls := self acl at: #printing ifAbsentPut: [Set new].
	entry := aPersonOrWebUserOrWebGroup isWebUser
		ifTrue: [aPersonOrWebUserOrWebGroup asPerson]
		ifFalse: [aPersonOrWebUserOrWebGroup].
	acls remove: entry ifAbsent: []! !

!Document methodsFor: 'access rights' stamp: 'np 1/20/2008 10:36'!
disallowUpdateTo: aPersonOrWebUserOrWebGroup
	| acls entry |
	self acl isNil ifTrue: [^self].
	acls := self acl at: #update ifAbsentPut: [Set new].
	entry := aPersonOrWebUserOrWebGroup isWebUser
		ifTrue: [aPersonOrWebUserOrWebGroup asPerson]
		ifFalse: [aPersonOrWebUserOrWebGroup].
	acls remove: entry ifAbsent: []! !

!Document methodsFor: 'accessing-other' stamp: 'np 1/17/2008 18:33'!
docGroup
	^self otherAt: #docGroup ifAbsent: [nil]! !

!Document methodsFor: 'accessing-other' stamp: 'np 1/17/2008 18:33'!
docGroup: aDocGroup
	^self otherAt: #docGroup put: aDocGroup! !

!Document methodsFor: 'private-storage' stamp: 'np 1/22/2008 17:40'!
documentDirectory
	"repository-root-dir/year of creation/month-day/prefered url without .html - version nr/
	example: repository-biart/2005/05-16/SOP-12-10-1/ "
	| dir |
	^self otherAt: #documentDirectory ifAbsent:
		[dir := self repository rootDirectory, '/', self dateForStoring year printString.
		(SpFilename named: dir) asAbsoluteFilename exists ifFalse: [(SpFilename named: dir) asAbsoluteFilename makeDirectory].
		dir := dir, '/',  self dateForStoring monthAndDayString.
		(SpFilename named: dir) asAbsoluteFilename exists ifFalse: [(SpFilename named: dir) asAbsoluteFilename makeDirectory].
		dir := dir, '/', self preferedUrlName, '-v', self versionNumber.
		(SpFilename named: dir) asAbsoluteFilename exists ifFalse: [(SpFilename named: dir) asAbsoluteFilename makeDirectory] ifTrue: [dir := self correctDir: dir].
		self documentDirectory: dir.
		dir].! !

!Document methodsFor: 'private-storage' stamp: 'np 1/17/2008 22:52'!
documentDirectory: aDirectoryString
	self otherAt: #documentDirectory put: aDirectoryString! !

!Document methodsFor: 'attachments' stamp: 'np 1/17/2008 22:40'!
existAttachmentWithFilename: aString
	^(self attachmentWithFilename: aString) notNil! !

!Document methodsFor: 'multilingual' stamp: 'np 1/17/2008 22:41'!
existLanguage: aLanguageCodeSymbol
	"check if  a document in that language exist"
	self language = aLanguageCodeSymbol ifTrue: [^true].
	self isInDocGroup ifFalse: [^false].
	^self docGroup contains: [:each | each language = aLanguageCodeSymbol]! !

!Document methodsFor: 'attachments' stamp: 'np 1/17/2008 22:40'!
firstAttachment
	self attachments isEmpty ifTrue: [^nil].
	^self attachments first! !

!Document methodsFor: 'accessing' stamp: 'np 1/17/2008 18:30'!
firstGallery
	"return first image gallery and if absent, create one"
	self allGalleries isEmpty ifTrue: [self openNewGallery].
	^self allGalleries first! !

!Document methodsFor: 'multilingual' stamp: 'np 1/17/2008 22:42'!
forLanguage: aLanguageCodeSymbol
	"return a document in that language if exist, otherwise return itself"
	self language = aLanguageCodeSymbol ifTrue: [^self].
	self isInDocGroup ifFalse: [^self].
	^self docGroup detect: [:each | each language = aLanguageCodeSymbol] ifNone: [self].! !

!Document methodsFor: 'testing' stamp: 'np 1/17/2008 22:42'!
hasChapters
	^self allChapters notEmpty! !

!Document methodsFor: 'testing' stamp: 'np 1/17/2008 22:42'!
hasCoApprovers
	^(self coApprovers copy remove: self owner ifAbsent: []; yourself) notEmpty! !

!Document methodsFor: 'testing' stamp: 'np 1/17/2008 22:42'!
hasCoAuthors
	^(self coAuthors copy remove: self maintainer ifAbsent: []; yourself) notEmpty! !

!Document methodsFor: 'testing' stamp: 'np 1/17/2008 22:43'!
hasRoleAsApproversDeputy: aPerson
	"special case is when person is both approver and deputy of some other approver!!"
	(self isApproversDeputy: aPerson) ifFalse: [^false].
	(self approvers includes: aPerson) ifFalse: [^true]. "then it is only a deputy, no double role"
	^(self approversYetToApprove includes: aPerson) not "as approver already approved"! !

!Document methodsFor: 'accessing' stamp: 'np 1/17/2008 18:31'!
id
	id isNil ifTrue: [^''].
	^id! !

!Document methodsFor: 'accessing' stamp: 'np 1/17/2008 18:31'!
id: aString
	"id of document, user defined"
	id := aString! !

!Document methodsFor: 'attachments' stamp: 'np 1/17/2008 22:41'!
imageAttachments
	"all attachments with images"
	| imageTypes |
	imageTypes := #('image/gif' 'image/jpeg' 'image/png').
	^self attachments select: [:each | imageTypes includes: each contentType]! !

!Document methodsFor: 'accessing' stamp: 'np 3/21/2008 23:03'!
indexText
	^self body withoutHtmlTags! !

!Document methodsFor: 'accessing' stamp: 'np 3/21/2008 23:03'!
indexTitle
	^self title! !

!Document methodsFor: 'initialize-release' stamp: 'np 1/17/2008 18:25'!
initAcl
	acl := Dictionary new.! !

!Document methodsFor: 'initialize-release' stamp: 'np 1/17/2008 18:25'!
initAttachments
	attachments := OrderedCollection new! !

!Document methodsFor: 'initialize-release' stamp: 'np 1/17/2008 18:25'!
initAttributes
	attributes := Dictionary new.! !

!Document methodsFor: 'initialize-release' stamp: 'np 1/17/2008 18:25'!
initDocGroup
	self isInDocGroup ifTrue: [^nil].
	self docGroup: (DocGroup new add: self; yourself)! !

!Document methodsFor: 'initialize-release' stamp: 'np 1/17/2008 18:26'!
initOther
	other := Dictionary new.! !

!Document methodsFor: 'initialize-release' stamp: 'np 1/17/2008 18:26'!
initPersons
	persons := Dictionary new.! !

!Document methodsFor: 'initialize-release' stamp: 'np 1/17/2008 18:26'!
initReferences
	references := OrderedCollection new! !

!Document methodsFor: 'initialize-release' stamp: 'np 1/17/2008 18:26'!
initSubdocuments
	subdocuments := OrderedCollection new! !

!Document methodsFor: 'initialize-release' stamp: 'np 1/17/2008 18:27'!
initTimestamps
	timestamps := Dictionary new.! !

!Document methodsFor: 'initialize-release' stamp: 'np 1/17/2008 18:26'!
initialize
	self setCreatedTimestamp.
	self setPending! !

!Document methodsFor: 'private-access rights' stamp: 'np 1/20/2008 13:22'!
isACLAccessAllowedFor: aPersonOrWebUser
	| acls |
	self areAccessRightsSet ifFalse: [^false]. 
	acls := self acl at: #access.
	(acls includes: aPersonOrWebUser asPerson) ifTrue: [^true].
	^acls contains: [:each | each isWebUserGroup and: [each includes: aPersonOrWebUser asWebUser]]! !

!Document methodsFor: 'private-access rights' stamp: 'np 1/20/2008 13:22'!
isACLDeleteAllowedFor: aPersonOrWebUser
	"for delete you need first access rights!! If nothing specified, then it is allowed!!"
	| acls |
	self areAccessRightsSet ifFalse: [^false]. 
	(self isAccessAllowedFor: aPersonOrWebUser) ifFalse: [^false].
	acls := self acl at: #delete ifAbsent: [^false].
	(acls includes: aPersonOrWebUser asPerson) ifTrue: [^true].
	^acls contains: [:each | each isWebUserGroup and: [each includes: aPersonOrWebUser asWebUser]]! !

!Document methodsFor: 'private-access rights' stamp: 'np 1/20/2008 13:22'!
isACLPrintingAllowedFor: aPersonOrWebUser
	| acls |
	self areAccessRightsSet ifFalse: [^false]. 
	acls := self acl at: #printing.
	(acls includes: aPersonOrWebUser asPerson) ifTrue: [^true].
	^acls contains: [:each | each isWebUserGroup and: [each includes: aPersonOrWebUser asWebUser]]! !

!Document methodsFor: 'private-access rights' stamp: 'np 1/20/2008 13:22'!
isACLUpdateAllowedFor: aPersonOrWebUser
	"for update you need first access rights!! If nothing specified, then it is allowed!!"
	| acls |
	self areAccessRightsSet ifFalse: [^false]. 
	(self isAccessAllowedFor: aPersonOrWebUser) ifFalse: [^false].
	acls := self acl at: #update ifAbsent: [^false].
	(acls includes: aPersonOrWebUser asPerson) ifTrue: [^true].
	^acls contains: [:each | each isWebUserGroup and: [each includes: aPersonOrWebUser asWebUser]]! !

!Document methodsFor: 'private-access rights' stamp: 'np 1/17/2008 22:48'!
isAccessAdditionallyAllowedFor: aPersonOrWebUser
	"access to all if released doc is not secret or top secret"
	self isSecret not ifTrue: [self isReleased ifTrue: [^true]]. 
	"authors, approvers, notified"
	(self authors includes: aPersonOrWebUser asPerson) ifTrue: [^true].
	(self approvers includes: aPersonOrWebUser asPerson) ifTrue: [^true].
	(self isReleased and: 
		[self notificationReport allPersons includes: aPersonOrWebUser asPerson]) ifTrue: [^true].
	((self isMaintainerDeputy: aPersonOrWebUser) or: [self isApproversDeputy: aPersonOrWebUser])
		ifTrue: [^true].
	^false! !

!Document methodsFor: 'access rights' stamp: 'np 1/18/2008 11:54'!
isAccessAllowedFor: aPersonOrWebUser
	aPersonOrWebUser asWebUser isAdmin ifTrue: [^true].
	(self isACLAccessAllowedFor: aPersonOrWebUser)  ifTrue: [^true].
	^self isAccessAdditionallyAllowedFor: aPersonOrWebUser! !

!Document methodsFor: 'accessing-states' stamp: 'np 1/17/2008 18:41'!
isApproved	
	^self status = #approved! !

!Document methodsFor: 'testing' stamp: 'np 1/17/2008 22:43'!
isApproversDeputy: aPersonOrWebUser
	"is aPerson a deputy of any approver?"
	self approvers isEmpty ifTrue: [^false].
	self approvers do: [:each | 
		(each haveDeputies and: [each allDeputies first == aPersonOrWebUser asPerson]) ifTrue: [^true] ].
	^false! !

!Document methodsFor: 'testing' stamp: 'np 1/17/2008 22:43'!
isApprovingComplete
	"all approvers (or their deputies) did approve?"
	^self approversYetToApprove isEmpty! !

!Document methodsFor: 'testing' stamp: 'np 1/17/2008 22:43'!
isChapter
	^false! !

!Document methodsFor: 'testing' stamp: 'np 1/17/2008 22:43'!
isComment
	^false! !

!Document methodsFor: 'private-access rights' stamp: 'np 1/17/2008 22:49'!
isDeleteAdditionallyAllowedFor: aPersonOrWebUser
	^self maintainer == aPersonOrWebUser asPerson	
		or: [self owner == aPersonOrWebUser asPerson]! !

!Document methodsFor: 'access rights' stamp: 'np 1/17/2008 18:29'!
isDeleteAllowedFor: aPersonOrWebUser
	"for delete you need first access rights!! If nothing specified, then it is allowed!!"
	aPersonOrWebUser asWebUser isAdmin ifTrue: [^true].
	(self isACLDeleteAllowedFor: aPersonOrWebUser) ifTrue: [^true].
	^self isDeleteAdditionallyAllowedFor: aPersonOrWebUser! !

!Document methodsFor: 'testing' stamp: 'np 1/17/2008 22:43'!
isDocument
	^true! !

!Document methodsFor: 'private-storage' stamp: 'np 1/17/2008 22:52'!
isDocumentDirectoryCreated
	^(self otherAt: #documentDirectory ifAbsent: [nil]) notNil! !

!Document methodsFor: 'testing' stamp: 'np 1/17/2008 22:43'!
isFolder
	^false! !

!Document methodsFor: 'testing' stamp: 'np 1/17/2008 22:43'!
isGallery
	"image gallery"
	^false! !

!Document methodsFor: 'multilingual' stamp: 'np 1/17/2008 22:42'!
isInDocGroup
	^self docGroup notNil! !

!Document methodsFor: 'private-locking' stamp: ' 19/3/08 18:13'!
isLockExpired
	"if lock is temporary and there were no lock regrant since lockTimeout seconds"
	^(SpTimestamp now asSeconds - self lockTimestamp asSeconds) > self lockTimeout! !

!Document methodsFor: 'private-locking' stamp: ' 19/3/08 18:13'!
isLockTypeNone
	^(self otherAt: #lockType ifAbsent: [^true]) = #none! !

!Document methodsFor: 'private-locking' stamp: ' 19/3/08 18:13'!
isLockTypePermanent
	^(self otherAt: #lockType) = #permanent! !

!Document methodsFor: 'private-locking' stamp: ' 19/3/08 18:13'!
isLockTypeTemporary
	^(self otherAt: #lockType) = #temporary! !

!Document methodsFor: 'testing' stamp: 'np 1/17/2008 22:43'!
isMaintainerDeputy: aPersonOrWebUser
	"is aPerson a deputy of maintainer?"
	self maintainer isNil ifTrue: [^false].
	^self maintainer haveDeputies and: [self maintainer allDeputies first == aPersonOrWebUser asPerson]! !

!Document methodsFor: 'multilingual' stamp: 'np 1/17/2008 22:42'!
isMultilingual
	^true! !

!Document methodsFor: 'testing' stamp: 'np 1/17/2008 22:43'!
isNearInvalidy
	"a month until document will expire"
	^self isReleased and: [self validToDate notNil and: [self validToDate < (Date today addDays: 31)]]! !

!Document methodsFor: 'testing' stamp: 'np 1/17/2008 22:43'!
isNearInvalidyExactly30days
	"exactly a month until document will expire"
	^self isReleased and: [self validToDate notNil and: [self validToDate = (Date today addDays: 30)]]! !

!Document methodsFor: 'testing' stamp: 'np 1/17/2008 22:44'!
isNoMoreValid
	^self isReleased and: [self validToDate notNil and: [self validToDate < Date today]]! !

!Document methodsFor: 'accessing-states' stamp: 'np 1/17/2008 18:41'!
isObsolete	
	^self status = #obsolete! !

!Document methodsFor: 'accessing-states' stamp: 'np 1/17/2008 18:41'!
isPending	
	^self status = #pending! !

!Document methodsFor: 'private-access rights' stamp: 'np 1/17/2008 22:49'!
isPrintingAdditionallyAllowedFor: aPersonOrWebUser
	self printOnlyForOwnerAndMaintainer ifFalse: [^true].
	^self owner == aPersonOrWebUser asPerson	
		or: [self maintainer == aPersonOrWebUser asPerson]! !

!Document methodsFor: 'access rights' stamp: 'np 1/18/2008 11:55'!
isPrintingAllowedFor: aPersonOrWebUser
	aPersonOrWebUser asWebUser isAdmin ifTrue: [^true].
	(self isACLPrintingAllowedFor: aPersonOrWebUser)  ifTrue: [^true].
	^self isPrintingAdditionallyAllowedFor: aPersonOrWebUser! !

!Document methodsFor: 'testing' stamp: 'np 1/25/2008 17:36'!
isProcess
	^false! !

!Document methodsFor: 'testing' stamp: 'np 1/25/2008 17:37'!
isQualityManual
	^false! !

!Document methodsFor: 'accessing-states' stamp: 'np 1/17/2008 18:41'!
isReady
	^self status = #ready! !

!Document methodsFor: 'accessing-states' stamp: 'np 1/17/2008 18:41'!
isReleased	
	^self status = #released! !

!Document methodsFor: 'testing' stamp: 'np 1/17/2008 22:44'!
isRepository
	^false! !

!Document methodsFor: 'testing' stamp: 'np 1/21/2008 08:14'!
isSecret
	"secret or top secret level of classification"
	self classificationLevel isNil ifTrue: [^false].
	 ^#( #secret #topSecret) includes: self classificationLevel id! !

!Document methodsFor: 'private-access rights' stamp: 'np 8/22/2008 00:21'!
isUpdateAdditionallyAllowedFor: aPersonOrWebUser
	"allowed for authors and owner"
	^(self owner == aPersonOrWebUser asPerson) 
		or: [self authors includes: aPersonOrWebUser asPerson]! !

!Document methodsFor: 'access rights' stamp: 'np 8/22/2008 00:21'!
isUpdateAllowedFor: aPersonOrWebUser
	"for update you need first access rights!! If nothing specified, then it is allowed!!"
	aPersonOrWebUser asWebUser isAdmin ifTrue: [^true].
	(self isACLUpdateAllowedFor: aPersonOrWebUser) ifTrue: [^true].
	^self isUpdateAdditionallyAllowedFor: aPersonOrWebUser! !

!Document methodsFor: 'accessing-attributes' stamp: 'janko 3/16/2008 13:39'!
keywords
	"or tags, if you like"
	^self attributesAt: #keywords ifAbsent: ['']! !

!Document methodsFor: 'accessing-attributes' stamp: 'janko 3/16/2008 13:39'!
keywords: aString
	"or tags, if you like"
	^self attributesAt: #keywords put: aString! !

!Document methodsFor: 'multilingual' stamp: 'np 1/17/2008 22:42'!
language
	"in which language is content of that document. In ISO 2-letter symbol"
	^self otherAt: #language ifAbsent: [self defaultLanguage]! !

!Document methodsFor: 'multilingual' stamp: 'np 1/17/2008 22:42'!
language: aLanguageCodeSymbol
	"in which language is content of that document. In ISO 2-letter symbol"
	^self otherAt: #language put: aLanguageCodeSymbol! !

!Document methodsFor: 'multilingual' stamp: 'np 1/17/2008 22:42'!
languages
	"all languages in which is content of that document. In ISO 2-letter symbol"
	self isInDocGroup ifFalse: [^Array with: self language].
	^self docGroup documents collect: [:each | each language].! !

!Document methodsFor: 'private-locking' stamp: ' 19/3/08 18:13'!
lockTimeout
	"how long a temporary lock stands until need to be regranted"
	^5 "seconds"! !

!Document methodsFor: 'private-locking' stamp: ' 19/3/08 18:13'!
lockTimestamp
	^self otherAt: #lockTimestamp! !

!Document methodsFor: 'private-locking' stamp: ' 19/3/08 18:13'!
lockedBy
	"whom a lock is granted"
	^self lockedOn notNil 
		ifTrue: [self lockedOn user] ifFalse: [nil]! !

!Document methodsFor: 'private-locking' stamp: ' 19/3/08 18:13'!
lockedOn
	"on which sesssion a lock is granted"
	^self otherAt: #lockedOnSession ifAbsent: [nil]! !

!Document methodsFor: 'accessing-persons' stamp: 'np 1/17/2008 18:38'!
maintainer
	"return creator if maintainer is not yet defined"
	| person |
	person := self personsAt: #maintainer ifAbsent: [self createdBy].
	^person notNil ifTrue: [person asPerson] ifFalse: [nil]! !

!Document methodsFor: 'accessing-persons' stamp: 'np 1/19/2008 10:03'!
maintainer: aPersonOrWebUser
	"who maintains a document, (change it, release it, prepare content)"
	self removeAuthor: self maintainer.
	aPersonOrWebUser isNil ifTrue: [^self personsAt: #maintainer put: nil].
	aPersonOrWebUser asPerson notNil ifTrue:
		[self personsAt: #maintainer put: aPersonOrWebUser asPerson.
		self addAuthor: aPersonOrWebUser asPerson]! !

!Document methodsFor: 'accessing-persons' stamp: 'np 1/17/2008 18:38'!
maintainerDeputy
	^self personsAt: #maintainerDeputy.! !

!Document methodsFor: 'accessing-persons' stamp: 'np 1/17/2008 18:38'!
maintainerDeputy: aPerson
	^self personsAt: #maintainerDeputy put: aPerson! !

!Document methodsFor: 'accessing-persons' stamp: 'np 1/17/2008 18:38'!
maintainerRoleText
	| person |
	self maintainer isNil ifTrue: [^''].
	person := self maintainer asPerson.
	person isNil ifTrue: [^''].
	^person jobRole notNil ifTrue: [', ', person jobRole name] ifFalse: ['']! !

!Document methodsFor: 'accessing-persons' stamp: 'np 1/17/2008 18:38'!
maintainerText
	^self maintainer notNil
		ifTrue: [self maintainer nameSurname] ifFalse: ['']! !

!Document methodsFor: 'accessing-persons' stamp: 'np 1/17/2008 18:38'!
modifiedBy
	^self personsAt: #modified! !

!Document methodsFor: 'accessing-persons' stamp: 'np 1/19/2008 11:44'!
modifiedBy: aWebUserOrPerson
	self personsAt: #modified put: aWebUserOrPerson asPerson! !

!Document methodsFor: 'accessing-persons' stamp: 'np 1/17/2008 18:39'!
modifiedByText
	^self modifiedBy notNil
		ifTrue: [self modifiedBy nameSurname] ifFalse: ['']! !

!Document methodsFor: 'accessing-timestamps' stamp: 'np 1/17/2008 19:14'!
modifiedTimestamp
	"any kind of modification, content or state!! "
	^self timestampsAt: #modified! !

!Document methodsFor: 'accessing-timestamps' stamp: 'np 1/17/2008 19:14'!
modifiedTimestampText
	^self modifiedTimestamp notNil
		ifTrue: [self modifiedTimestamp printSloString] ifFalse: ['']! !

!Document methodsFor: 'private' stamp: 'mu 6/24/2008 11:56'!
neutralFilenameFrom: originalName
	"Encode original string to external platform neutral filename (represented ASCII characters only)"
	"Currently just uses base64 for simlicity. Probably Punycode-like encoding is preferable, because you can guess original name easier"
	
	| lastSuffixIndex main suffix encodedMain |
	
	originalName isByteString ifTrue: [^originalName].
	
	lastSuffixIndex := originalName lastIndexOf: $..
	lastSuffixIndex <= 1 ifTrue: [^(Base64MimeConverter mimeEncode: originalName readStream) contents].
	
	main := originalName copyFrom: 1 to: lastSuffixIndex.
	suffix := originalName copyFrom: lastSuffixIndex+1 to: originalName size.
	
	encodedMain := (Base64MimeConverter mimeEncode: main readStream) contents.
	
	^encodedMain, '.', suffix
	! !

!Document methodsFor: 'accessing-persons' stamp: 'np 1/17/2008 18:39'!
obsoleteBy
	^self personsAt: #obsoleteBy! !

!Document methodsFor: 'accessing-persons' stamp: 'np 1/19/2008 11:44'!
obsoleteBy: aWebUserOrPerson
	self personsAt: #obsoleteBy put: aWebUserOrPerson asPerson! !

!Document methodsFor: 'accessing-timestamps' stamp: 'np 1/17/2008 19:15'!
obsoleteTimestamp
	^self timestampsAt: #obsolete! !

!Document methodsFor: 'accessing-persons' stamp: 'np 1/17/2008 18:39'!
ofWhichApproversIsDeputy: aPerson
	| deputyOf |
	deputyOf := aPerson allDeputyOf asSet.
	^self approvers select: [:each | deputyOf includes: each]! !

!Document methodsFor: 'adding-removing' stamp: 'np 1/17/2008 22:37'!
openNewGallery
	"create a new iamge gallery and add it to that document"
	self addGallery: (Gallery new)! !

!Document methodsFor: 'versions' stamp: 'np 1/17/2008 22:44'!
openNewVersion
	"if not already opened, make new version"
	self canOpenNewVersion ifTrue: [^self asNewVersion]! !

!Document methodsFor: 'private' stamp: 'np 1/17/2008 22:45'!
other
	^other! !

!Document methodsFor: 'private' stamp: 'np 1/17/2008 22:45'!
otherAt: aSymbol
	"other values"
	^self otherAt: aSymbol ifAbsent: [nil]! !

!Document methodsFor: 'private' stamp: 'np 1/17/2008 22:45'!
otherAt: aSymbol ifAbsent: aBlock
	"other values"
	self other isNil ifTrue: [^aBlock value].
	^self other at: aSymbol ifAbsent: aBlock! !

!Document methodsFor: 'private' stamp: 'np 1/17/2008 22:45'!
otherAt: aSymbol ifAbsentPut: aBlock
	self other isNil ifTrue: [self initOther].
	^self other at: aSymbol ifAbsent: [self other at: aSymbol put: aBlock value]! !

!Document methodsFor: 'private' stamp: 'np 1/17/2008 22:46'!
otherAt: aSymbol put: anObject
	self other isNil ifTrue: [self initOther].
	^self other at: aSymbol put: anObject! !

!Document methodsFor: 'accessing-persons' stamp: 'np 1/17/2008 18:39'!
owner
	^self personsAt: #owner! !

!Document methodsFor: 'accessing-persons' stamp: 'np 1/17/2008 18:39'!
owner: aPersonOrWebUser
	"who own a document, it is responsible for, it can aprrove it. Add him to approvers"
	self removeApprover: self owner. 
	aPersonOrWebUser isNil ifTrue: [^self personsAt: #owner put: nil].
	self personsAt: #owner put: 
		(aPersonOrWebUser asPerson notNil ifTrue: [aPersonOrWebUser asPerson] ifFalse: [nil]).
	self addApprover: aPersonOrWebUser asPerson! !

!Document methodsFor: 'accessing-persons' stamp: 'np 1/17/2008 18:39'!
ownerRoleText
	| person |
	self owner isNil ifTrue: [^''].
	person := self owner asPerson.
	person isNil ifTrue: [^''].
	^person jobRole notNil ifTrue: [', ', person jobRole name] ifFalse: ['']! !

!Document methodsFor: 'accessing-persons' stamp: 'np 1/17/2008 18:39'!
ownerText
	^self owner notNil
		ifTrue: [self owner nameSurname] ifFalse: ['']! !

!Document methodsFor: 'accessing' stamp: 'np 1/17/2008 18:31'!
parent
	"parent from main hierarchy if any"
	^parent! !

!Document methodsFor: 'private' stamp: 'np 1/17/2008 22:46'!
parent: aDocument
	parent := aDocument! !

!Document methodsFor: 'private' stamp: 'np 1/17/2008 22:46'!
persons
	^persons! !

!Document methodsFor: 'private' stamp: 'np 1/17/2008 22:46'!
personsAt: aSymbol
	"who #created, #edited, #approved, #published etc a document"
	^self personsAt: aSymbol ifAbsent: [nil]! !

!Document methodsFor: 'private' stamp: 'np 1/17/2008 22:46'!
personsAt: aSymbol ifAbsent: aBlock
	self persons isNil ifTrue: [^aBlock value].
	^self persons at: aSymbol ifAbsent: aBlock! !

!Document methodsFor: 'private' stamp: 'np 1/17/2008 22:46'!
personsAt: aSymbol put: aWebUser
	self persons isNil ifTrue: [self initPersons].
	^self persons at: aSymbol put: aWebUser! !

!Document methodsFor: 'private' stamp: 'np 1/17/2008 22:46'!
preferedUrl
	| name |
	name := self preferedUrlName. name isNil ifTrue: [^nil].
	name := name ensureUnicodeSloveneChars asSloveneWithoutCircumflexes.
	^'/document/', name, '.html'.! !

!Document methodsFor: 'private' stamp: 'mu 6/24/2008 11:59'!
preferedUrlName
	| name |
	(self id isEmpty and: [self title isEmpty]) 
		ifTrue:  [^'doc', ((Random new next * 1000) truncated printString)].
	name := self id notEmpty ifTrue: [self id] ifFalse: [self title].
	^self neutralFilenameFrom: name.! !

!Document methodsFor: 'accessing-other' stamp: 'np 1/21/2008 08:19'!
printOnlyForOwnerAndMaintainer
	"is true, only those two can print that doc"
	^self otherAt: #printOnlyForOwnerAndMaintainer ifAbsent: [false]! !

!Document methodsFor: 'accessing-other' stamp: 'np 1/21/2008 08:19'!
printOnlyForOwnerAndMaintainer: aBoolean
	"is true, only those two can print that doc"
	self otherAt: #printOnlyForOwnerAndMaintainer put: aBoolean! !

!Document methodsFor: 'private' stamp: 'np 1/17/2008 22:46'!
printString
	^'aDocument: ', self id, ' ', self title! !

!Document methodsFor: 'accessing-timestamps' stamp: 'np 1/17/2008 19:15'!
readyDate
	self readyTimestamp isNil ifTrue: [^nil].
	^self readyTimestamp asDate! !

!Document methodsFor: 'accessing-timestamps' stamp: 'np 1/17/2008 19:15'!
readyTimestamp
	^self timestampsAt: #ready! !

!Document methodsFor: 'accessing-timestamps' stamp: 'np 2/3/2008 16:58'!
readyTimestampText
	^self readyTimestamp notNil
		ifTrue: [self readyTimestamp printSloString] ifFalse: ['']! !

!Document methodsFor: 'private-maintenance' stamp: 'np 1/17/2008 22:51'!
reconnectSubchapters
	"they somehow still point to previous version after publishing"
	self allChapters do: [:each | each parent: self]! !

!Document methodsFor: 'accessing' stamp: 'np 1/17/2008 18:31'!
referenceWithUuid: aString
	^self references detect: [:each | each uuid = aString] ifNone: [nil]! !

!Document methodsFor: 'private' stamp: 'np 1/17/2008 22:46'!
references
	references isNil ifTrue: [^OrderedCollection new].
	^references! !

!Document methodsFor: 'private' stamp: 'np 1/17/2008 22:46'!
references: anOrderedCollection
	references := anOrderedCollection! !

!Document methodsFor: 'accessing-persons' stamp: 'np 1/17/2008 18:40'!
releasedBy
	^self personsAt: #releasedBy! !

!Document methodsFor: 'accessing-persons' stamp: 'np 1/19/2008 11:45'!
releasedBy: aWebUserOrPerson
	self personsAt: #releasedBy put: aWebUserOrPerson asPerson! !

!Document methodsFor: 'accessing-timestamps' stamp: 'np 1/17/2008 19:15'!
releasedDate
	self releasedTimestamp isNil ifTrue: [^nil].
	^self releasedTimestamp asDate! !

!Document methodsFor: 'private' stamp: 'np 1/17/2008 22:47'!
releasedDate: aDateOrString
	| date |
	date := (aDateOrString isKindOf: String) 
		ifTrue: [date := Date readSloFrom: aDateOrString readStream] ifFalse: [aDateOrString].
	date isNil ifTrue: [^nil].
	self timestampsAt: #released put: date asSpTimestamp.! !

!Document methodsFor: 'accessing-timestamps' stamp: 'np 1/17/2008 19:15'!
releasedTimestamp
	^self timestampsAt: #released! !

!Document methodsFor: 'accessing-persons' stamp: 'np 1/17/2008 18:40'!
removeApprovedBy
	self removePersonAt: #approvedBy.
	self removePersonAt: #approversDeputies! !

!Document methodsFor: 'accessing-timestamps' stamp: 'np 1/17/2008 19:15'!
removeApprovedTimestamp
	self removeTimestampAt: #approved.! !

!Document methodsFor: 'accessing-persons' stamp: 'np 1/17/2008 18:40'!
removeApprover: aPerson
	aPerson isNil ifTrue: [^nil].
	self approvers remove: aPerson asPerson ifAbsent: []! !

!Document methodsFor: 'attachments' stamp: 'janko 3/19/2008 12:35'!
removeAttachment: anAttachment
	attachments isNil ifTrue: [^nil].
	self attachments remove: anAttachment ifAbsent: [^nil].
"	anAttachment   "" don't remove attached file, because it can be used for previous versions!!""
		removeProxy;
		removeFile;
		parent: nil. "! !

!Document methodsFor: 'accessing-persons' stamp: 'np 1/17/2008 18:40'!
removeAuthor: aPerson
	aPerson isNil ifTrue: [^nil].
	self authors remove: aPerson asPerson ifAbsent: []! !

!Document methodsFor: 'adding-removing' stamp: 'np 1/17/2008 22:37'!
removeChapter: aDocumentChapter
	aDocumentChapter isChapter ifFalse: [^nil].
	self removeSubdocument: aDocumentChapter! !

!Document methodsFor: 'adding-removing' stamp: 'np 1/17/2008 22:37'!
removeComment: aComment
	aComment isComment ifFalse: [^nil].
	self removeSubdocument: aComment! !

!Document methodsFor: 'accessing-persons' stamp: 'np 1/17/2008 18:40'!
removeCreatedBy
	^self removePersonAt: #created! !

!Document methodsFor: 'adding-removing' stamp: 'np 1/17/2008 22:38'!
removeDocument: aDocument
	self removeSubdocument: aDocument! !

!Document methodsFor: 'private-storage' stamp: 'np 1/17/2008 22:52'!
removeDocumentDirectory
	self isDocumentDirectoryCreated ifFalse: [^nil].
	self documentDirectory asFilename deleteRecursively.
	self other removeKey: #documentDirectory.! !

!Document methodsFor: 'accessing-persons' stamp: 'np 1/17/2008 18:40'!
removeObsoleteBy
	^self removePersonAt: #obsoleteBy! !

!Document methodsFor: 'accessing-timestamps' stamp: 'np 1/17/2008 19:15'!
removeObsoleteTimestamp
	self removeTimestampAt: #obsolete! !

!Document methodsFor: 'private' stamp: 'np 1/17/2008 22:47'!
removePersonAt: aSymbol
	self persons isNil ifTrue: [^nil].
	^self persons removeKey: aSymbol ifAbsent: [nil]! !

!Document methodsFor: 'accessing-timestamps' stamp: 'np 1/17/2008 19:16'!
removeReadyTimestamp
	self removeTimestampAt: #ready! !

!Document methodsFor: 'adding-removing' stamp: 'np 1/17/2008 22:38'!
removeReference: aDocLink
	references isNil ifTrue: [^nil].
	self references remove: aDocLink ifAbsent: [^nil].! !

!Document methodsFor: 'accessing-persons' stamp: 'np 1/17/2008 18:40'!
removeReleasedBy
	^self removePersonAt: #releasedBy! !

!Document methodsFor: 'accessing-timestamps' stamp: 'np 1/17/2008 19:16'!
removeReleasedTimestamp
	self removeTimestampAt: #released! !

!Document methodsFor: 'adding-removing' stamp: 'np 1/17/2008 22:38'!
removeSubdocument: aDocument
	subdocuments isNil ifTrue: [^nil].
	self subdocuments remove: aDocument ifAbsent: [^nil].
	aDocument parent == self ifTrue: [aDocument parent: nil].! !

!Document methodsFor: 'private' stamp: 'np 1/17/2008 22:47'!
removeTimestampAt: aSymbol
	self timestamps isNil ifTrue: [^nil].
	^self timestamps removeKey: aSymbol ifAbsent: [nil]! !

!Document methodsFor: 'adding-removing' stamp: 'np 1/17/2008 22:38'!
removeYourself
	"complete remove from everywhere: parent folder, url resolver, also all files on filesystem"
	"must be completely obsolete!!"
	(self allVersions contains: [:doc | doc isObsolete not]) ifTrue: [^nil].
	self allVersions do: [:doc |
		doc repository notNil ifTrue: [doc repository site urlResolver removeObject: doc].
		doc removeDocumentDirectory.
		doc parent notNil ifTrue:[doc parent removeDocument: doc] ]! !

!Document methodsFor: 'accessing' stamp: 'np 1/17/2008 18:31'!
repository
	"where this document is stored"
	parent isNil ifTrue: [^self app site repository]. "maybe we can find it that way?"
	(parent isKindOf: Company) ifTrue: [^parent repository].
	parent isRepository ifTrue: [^parent].
	^parent repository! !

!Document methodsFor: 'accessing-states' stamp: 'np 3/29/2008 05:09'!
setAccessedBy: aWebUser
	"last access when and by who"
	self accessedBy: aWebUser.
	self setAccessedTimestamp.
	self repository eventLog logAccessed: self by: aWebUser! !

!Document methodsFor: 'accessing-timestamps' stamp: 'np 1/17/2008 19:16'!
setAccessedTimestamp
	self timestampsAt: #accessed put: SpTimestamp now.! !

!Document methodsFor: 'accessing-states' stamp: 'np 1/17/2008 18:42'!
setApprovedAllApprovers
	self approvers do: [:each || person |
		person := (each notNil ifTrue: [each] ifFalse: [^nil]) asWebUser.
		self setApprovedBy: person]! !

!Document methodsFor: 'accessing-states' stamp: 'np 3/29/2008 05:09'!
setApprovedBy: aWebUser
	"change status after all people approved!! "
	self isReady ifFalse: [^nil].
	self approvedBy: aWebUser.
	self isApprovingComplete ifTrue:
		[self status:  #approved.
		self setApprovedTimestamp.
		self repository eventLog logApproved: self by: aWebUser].
	self modifiedBy: aWebUser.
	self setModifiedTimestamp.! !

!Document methodsFor: 'accessing-states' stamp: 'np 1/17/2008 18:42'!
setApprovedByOwner
	"owner usually approves doc anyway"
	| person |
	person := (self owner notNil ifTrue: [self owner] ifFalse: [^nil]) asWebUser.
	self setApprovedBy: person! !

!Document methodsFor: 'accessing-timestamps' stamp: 'np 1/17/2008 19:16'!
setApprovedTimestamp
	self timestampsAt: #approved put: SpTimestamp now.! !

!Document methodsFor: 'accessing-states' stamp: 'np 3/29/2008 05:10'!
setCreatedBy: aWebUser
	"call this again when document is really added to repository"
	self createdBy: aWebUser.
	self setCreatedTimestamp.
	self repository eventLog logCreated: self by: aWebUser! !

!Document methodsFor: 'accessing-timestamps' stamp: 'np 1/17/2008 22:34'!
setCreatedTimestamp
	self timestampsAt: #created put: SpTimestamp now.
	self setModifiedTimestamp.! !

!Document methodsFor: 'private-locking' stamp: ' 19/3/08 18:13'!
setLockTimestamp
	^self otherAt: #lockTimestamp put: SpTimestamp now.! !

!Document methodsFor: 'private-locking' stamp: ' 19/3/08 18:13'!
setLockTypeNone
	^self otherAt: #lockType put: #none! !

!Document methodsFor: 'private-locking' stamp: ' 19/3/08 18:13'!
setLockTypePermanent
	^self otherAt: #lockType put: #permanent! !

!Document methodsFor: 'private-locking' stamp: ' 19/3/08 18:13'!
setLockTypeTemporary
	^self otherAt: #lockType put: #temporary! !

!Document methodsFor: 'private-locking' stamp: ' 19/3/08 18:13'!
setLockedOn: aWebSession
	"on which session lock is granted"
	self otherAt: #lockedOnSession put: aWebSession! !

!Document methodsFor: 'accessing-states' stamp: 'np 3/29/2008 05:10'!
setModifiedBy: aWebUser
	self modifiedBy: aWebUser.
	self setModifiedTimestamp.
	self repository eventLog logModified: self by: aWebUser! !

!Document methodsFor: 'accessing-timestamps' stamp: 'np 1/17/2008 22:34'!
setModifiedTimestamp
	self timestampsAt: #modified put: SpTimestamp now.! !

!Document methodsFor: 'accessing-states' stamp: 'np 6/10/2008 19:18'!
setObsoleteBy: aWebUser
	self status:  #obsolete.
	self obsoleteBy: aWebUser.
	self setObsoleteTimestamp.
	self modifiedBy: aWebUser.
	self setModifiedTimestamp.
	self nextVersion notNil ifTrue:  "obsolete newly opened version too"
		[self nextVersion  status: #obsolete; obsoleteBy: aWebUser;  setObsoleteTimestamp].
	self repository eventLog logObsolete: self by: aWebUser! !

!Document methodsFor: 'accessing-timestamps' stamp: 'np 1/17/2008 22:35'!
setObsoleteTimestamp
	self timestampsAt: #obsolete put: SpTimestamp now.! !

!Document methodsFor: 'accessing-states' stamp: 'np 1/17/2008 18:43'!
setPending	
	self status: #pending! !

!Document methodsFor: 'accessing-states' stamp: 'np 1/17/2008 18:43'!
setReadyApprovedReleased
	"do all lifecycle at once"
	self setReadyByMaintainer.
	self setApprovedByOwner.
	self setReleasedByMaintainer.! !

!Document methodsFor: 'accessing-states' stamp: 'np 1/17/2008 18:43'!
setReadyBy: aWebUser
	self isPending ifFalse: [^nil].
	self status:  #ready.
	self setReadyTimestamp.
	self modifiedBy: aWebUser.
	self setModifiedTimestamp.! !

!Document methodsFor: 'accessing-states' stamp: 'np 1/17/2008 18:43'!
setReadyByMaintainer
	"maintainer usually set ready doc anyway"
	| person |
	person := (self maintainer notNil ifTrue: [self maintainer] ifFalse: [^nil]) asWebUser.
	self setReadyBy: person! !

!Document methodsFor: 'accessing-timestamps' stamp: 'np 1/17/2008 22:35'!
setReadyTimestamp
	self timestampsAt: #ready put: SpTimestamp now.! !

!Document methodsFor: 'accessing-states' stamp: 'np 3/29/2008 05:11'!
setReleasedBy: aWebUser
	self isApproved ifFalse: [^nil].
	self status:  #released.
	self releasedBy: aWebUser.
	self setReleasedTimestamp.
	self modifiedBy: aWebUser.
	self setModifiedTimestamp.
	(self olderVersions do: [:each | each isReleased ifTrue: 
		[each status: #obsolete; obsoleteBy: aWebUser;  setObsoleteTimestamp] ]).
	self setCurrentVersion. "this can swap identities!! "
	self currentVersion reconnectSubchapters.
	self repository eventLog logReleased: self currentVersion by: aWebUser.! !

!Document methodsFor: 'accessing-states' stamp: 'np 1/17/2008 18:44'!
setReleasedByMaintainer
	"maintainer usually releases doc anyway"
	| person |
	person := (self maintainer notNil ifTrue: [self maintainer] ifFalse: [^nil]) asWebUser.
	self setReleasedBy: person! !

!Document methodsFor: 'accessing-timestamps' stamp: 'np 1/17/2008 22:35'!
setReleasedTimestamp
	self timestampsAt: #released put: SpTimestamp now.! !

!Document methodsFor: 'testing' stamp: 'np 1/17/2008 22:44'!
shouldKnow: aPerson
	"this person should know about that document"
	(self authors "and maintainer" includes: aPerson) ifTrue: [^true].
	(self approvers "and owner" includes: aPerson) ifTrue: [^true].
	^self notificationReport shouldBeNotified: aPerson! !

!Document methodsFor: 'private' stamp: 'np 1/17/2008 22:47'!
status
	^status! !

!Document methodsFor: 'private' stamp: 'np 1/17/2008 22:47'!
status: aSymbol
	"state of document during lifecycle: #pending #ready #approved #published #obsolete... "
	status := aSymbol! !

!Document methodsFor: 'private' stamp: 'np 1/17/2008 22:47'!
statusText
	self isReleased ifTrue: [^'Objavljen'].
	self isPending ifTrue: [^'V pripravi'].
	self isReady ifTrue: [^'C^aka odobritev'].
	self isApproved ifTrue: [^'Odobren'].
	self isObsolete ifTrue: [^'Umaknjen'].
	^''! !

!Document methodsFor: 'private' stamp: 'np 1/17/2008 22:48'!
subdocuments
	subdocuments isNil ifTrue: [^OrderedCollection new].
	^subdocuments! !

!Document methodsFor: 'private' stamp: 'np 1/17/2008 22:48'!
timestamps
	^timestamps! !

!Document methodsFor: 'private' stamp: 'np 1/17/2008 22:48'!
timestampsAt: aSymbol
	^self timestampsAt: aSymbol ifAbsent: [nil]! !

!Document methodsFor: 'private' stamp: 'np 1/17/2008 22:48'!
timestampsAt: aSymbol ifAbsent: aBlock
	self timestamps isNil ifTrue: [^aBlock value].
	^self timestamps at: aSymbol ifAbsent: aBlock! !

!Document methodsFor: 'private' stamp: 'np 1/17/2008 22:48'!
timestampsAt: aSymbol put: aTimestamp
	self timestamps isNil ifTrue: [self initTimestamps].
	self timestamps at: aSymbol put: aTimestamp! !

!Document methodsFor: 'accessing' stamp: 'np 1/17/2008 18:32'!
title
	title isNil ifTrue: [^''].
	^title! !

!Document methodsFor: 'accessing' stamp: 'np 1/17/2008 18:32'!
title: aString
	"title of this document"
	title := aString! !

!Document methodsFor: 'accessing' stamp: 'np 1/17/2008 18:32'!
type
	^type! !

!Document methodsFor: 'accessing' stamp: 'np 1/17/2008 18:32'!
type: aSymbol
	"type of this document, user defined"
	type := aSymbol! !

!Document methodsFor: 'accessing' stamp: 'np 1/17/2008 18:32'!
typeCode
	^'DOK'! !

!Document methodsFor: 'accessing-states' stamp: 'np 1/17/2008 18:44'!
unApproveBy: anApprover
	self isApproved ifFalse: [^nil].
	anApprover asPerson == self owner | anApprover isAdmin ifFalse: [^nil].
	self status:  #ready.
	self removeApprovedBy.
	self removeApprovedTimestamp.
	self modifiedBy: anApprover.
	self setModifiedTimestamp.! !

!Document methodsFor: 'accessing-states' stamp: 'np 1/17/2008 18:44'!
unObsoleteBy: aMaintainer
	"back to status before!!"
	aMaintainer == self obsoleteBy | aMaintainer isAdmin ifFalse: [^nil].
	self isObsolete ifFalse: [^nil].
	self status:  self backFromObsoleteStatus.
	self backFromObsoletePersonsAndTimestamps.
	self modifiedBy: aMaintainer.
	self nextVersion notNil ifTrue:  "un-obsolete newly opened version too"
		[self nextVersion  status: #pending; removeObsoleteBy;  removeObsoleteTimestamp].
	self setModifiedTimestamp.! !

!Document methodsFor: 'accessing-states' stamp: 'np 1/17/2008 18:44'!
unReadyBy: aPersonOrWebUser
	self isReady ifFalse: [^nil].
	self status:  #pending.
	self removeReadyTimestamp.
	self removeApprovedBy. "all approvalls are reset!! "
	self modifiedBy: aPersonOrWebUser.
	self setModifiedTimestamp.! !

!Document methodsFor: 'accessing-states' stamp: 'np 1/17/2008 18:44'!
unReleaseBy: aReleaser
	aReleaser == self releasedBy | aReleaser isAdmin ifFalse: [^nil].
	self isReleased ifFalse: [^nil].
	self status:  #approved.
	self removeReleasedBy.
	self removeReleasedTimestamp.
	self modifiedBy: aReleaser.
	self setModifiedTimestamp.
	self parentVersion notNil ifTrue:
		[self parentVersion unObsoleteBy: aReleaser. 
		self parentVersion setCurrentVersion]! !

!Document methodsFor: 'accessing' stamp: 'np 1/17/2008 18:32'!
url
	^self repository site urlResolver halfUrlFor: self! !

!Document methodsFor: 'accessing' stamp: 'np 1/17/2008 18:33'!
uuid
	"some unique identifier. Hash for now, probably unique enough!! "
	^self hash printString! !

!Document methodsFor: 'accessing-timestamps' stamp: 'np 1/17/2008 22:35'!
validFromDate
	^self timestampsAt: #validFromDate! !

!Document methodsFor: 'accessing-timestamps' stamp: 'np 1/19/2008 20:27'!
validFromDate: aDateOrString
	| date |
	(aDateOrString isKindOf: String) 
		ifTrue: [date := SpDate readSloFrom: aDateOrString readStream. date isNil ifTrue: [^nil] ]
		ifFalse: [date := aDateOrString].
	self timestampsAt: #validFromDate put: date! !

!Document methodsFor: 'accessing-timestamps' stamp: 'np 1/17/2008 22:35'!
validToDate
	^self timestampsAt: #validToDate! !

!Document methodsFor: 'accessing-timestamps' stamp: 'np 1/19/2008 20:27'!
validToDate: aDateOrString
	| date |
	(aDateOrString isKindOf: String) 
		ifTrue: [date := SpDate readSloFrom: aDateOrString readStream. date isNil ifTrue: [^nil] ]
		ifFalse: [date := aDateOrString].
	self timestampsAt: #validToDate put: date! !

Document subclass: #DocumentChapter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scribo-Core'!

!DocumentChapter methodsFor: 'testing' stamp: 'np 1/18/2008 10:56'!
isChapter
	^true! !

!DocumentChapter methodsFor: 'accessing' stamp: 'np 1/18/2008 10:56'!
preferedUrlName
	(self id isEmpty and: [self title isEmpty]) 
		ifTrue:  [^(Random new next * 1000) truncated printString].
	self parent isNil ifTrue: [^nil].
	^self parent preferedUrlName, '-ch', (self id notEmpty ifTrue: [self id] ifFalse: [self title]).! !

!DocumentChapter methodsFor: 'private' stamp: 'np 1/18/2008 10:57'!
printString
	^'aDocumentChapter: ', self id, ' ', self title! !

!DocumentChapter methodsFor: 'accessing-states' stamp: 'np 1/18/2008 10:56'!
setModifiedBy: aWebUser
	"add chapet to event log, but set modifications to both chapter and parent"
	super setModifiedBy: aWebUser.
	self parent modifiedBy: aWebUser.
	self parent setModifiedTimestamp.! !

Document subclass: #Folder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scribo-Core'!

!Folder class methodsFor: 'as yet unclassified' stamp: 'np 6/23/2008 00:20'!
newNamed: aString
	^self new 
		title: aString;
		yourself! !

!Folder methodsFor: 'adding-removing' stamp: 'np 1/18/2008 10:52'!
addDocument: aDocument
	aDocument isFolder ifTrue: [^nil].
	self addSubdocument: aDocument.
	aDocument parent: self! !

!Folder methodsFor: 'adding-removing' stamp: 'np 1/18/2008 10:52'!
addFolder: aFolder
	aFolder isFolder ifFalse: [^nil].
	self addSubdocument: aFolder.
	aFolder parent: self.
	self isProcessFolder ifTrue: [aFolder setProcessFolder].
	self isTemplateFolder ifTrue: [aFolder setTemplateFolder].! !

!Folder methodsFor: 'adding-removing' stamp: 'np 1/18/2008 10:53'!
addFolderNamed: aString
	self addFolder: (Folder newNamed: aString)! !

!Folder methodsFor: 'accessing' stamp: 'np 1/18/2008 10:48'!
allDocuments
	"collect all docs down the hierarchy. "
	| docs |
	docs := self subcontents select: [:each | each isDocument ].
	self subfolders inject: docs into: [:col :each | col addAll: each allDocuments; yourself].
	^docs! !

!Folder methodsFor: 'accessing' stamp: 'np 1/18/2008 10:49'!
allFolders
	"collect all folders including self down the hierarchy. "
	| folders |
	folders := OrderedCollection new add: self; yourself.
	self subfolders inject: folders into: [:col :each | col addAll: each allFolders; yourself].
	^folders! !

!Folder methodsFor: 'accessing' stamp: 'np 1/18/2008 10:49'!
allNearInvalidDocuments
	"a month or less until doc validToDate"
	^self allDocuments select: [:each | each isReleased and: [each isNearInvalidy] ]! !

!Folder methodsFor: 'accessing' stamp: 'np 1/18/2008 10:49'!
allNearInvalidExactly30daysDocuments
	"a month or less until doc validToDate"
	^self allDocuments select: [:each |  each isReleased and: [each isNearInvalidyExactly30days] ]! !

!Folder methodsFor: 'accessing' stamp: 'np 1/18/2008 10:49'!
allNoMoreValidDocuments
	^self allDocuments select: [:each |  each isReleased and: [each isNoMoreValid] ]! !

!Folder methodsFor: 'accessing' stamp: 'np 1/18/2008 10:49'!
allObsoleteDocuments
	"collect all obsolete docs down the hierarchy. "
	^self allDocuments select: [:each | each isObsolete ]! !

!Folder methodsFor: 'accessing' stamp: 'np 1/18/2008 10:49'!
allProcesses
	"collect all processes down the hierarchy"
	^self allDocuments select: [:each | each isProcess].! !

!Folder methodsFor: 'accessing' stamp: 'np 1/18/2008 10:50'!
documentWithId: aString
	"search for this document through hierarchy"
	| found |
	self subdocuments do: [:each | (each isFolder not and: [each id = aString]) 
		ifTrue: [each isObsolete not ifTrue: [^each]] ].
	self subfolders do: [:each | 
		found := each documentWithId: aString. found notNil ifTrue: [^found] ].
	^nil! !

!Folder methodsFor: 'accessing' stamp: 'np 1/18/2008 10:50'!
documentWithTitle: aString
	"search for this document through hierarchy"
	| found |
	self subdocuments do: [:each | (each isFolder not and: [each title = aString]) 
		ifTrue: [each isObsolete not ifTrue: [^each]] ].
	self subfolders do: [:each | 
		found := each documentWithTitle: aString. found notNil ifTrue: [^found] ].
	^nil! !

!Folder methodsFor: 'accessing' stamp: 'np 1/18/2008 10:50'!
documentWithUuid: aString
	"search for this document through hierarchy"
	| found |
	self subdocuments do: [:each | (each isFolder not and: [each uuid = aString]) ifTrue: [^each] ].
	self subfolders do: [:each | 
		found := each documentWithUuid: aString. found notNil ifTrue: [^found] ].
	^nil! !

!Folder methodsFor: 'accessing' stamp: 'np 1/18/2008 10:51'!
folderWithName: aString 
	"search for this folder through hierarchy strating from self"
	| found |
	self name trimBlanks = aString ifTrue: [^self].
	self subfolders do: [:each | each name trimBlanks = aString ifTrue: [^each]].
	self subfolders do: [:each | 
		found := each folderWithName: aString.
		found notNil ifTrue: [^found]].
	^nil! !

!Folder methodsFor: 'accessing' stamp: 'np 1/18/2008 10:51'!
folderWithUuid: aString
	"search for this folder through hierarchy strating from self"
	| found |
	self uuid = aString ifTrue: [^self].
	self subfolders do: [:each | each uuid = aString ifTrue: [^each] ].
	self subfolders do: [:each | found := each folderWithUuid: aString. found notNil ifTrue: [^found] ].
	^nil! !

!Folder methodsFor: 'initialize-release' stamp: 'np 1/18/2008 10:48'!
initialize
	self type: #folder.
	^self! !

!Folder methodsFor: 'testig' stamp: 'np 1/18/2008 10:53'!
isDocument
	^false! !

!Folder methodsFor: 'testig' stamp: 'np 1/18/2008 10:53'!
isFolder
	^true! !

!Folder methodsFor: 'testig' stamp: 'np 1/18/2008 10:54'!
isProcessFolder
	"folder with processes"
	^self type == #processFolder! !

!Folder methodsFor: 'testig' stamp: 'np 1/18/2008 10:54'!
isRepository
	^false! !

!Folder methodsFor: 'testig' stamp: 'np 1/18/2008 10:54'!
isRoot
	self parent isNil ifTrue: [^true].
	^self parent isRepository! !

!Folder methodsFor: 'testig' stamp: 'np 1/18/2008 10:54'!
isTemplateFolder
	"folder with templates"
	^self type == #templateFolder! !

!Folder methodsFor: 'accessing' stamp: 'np 1/18/2008 10:51'!
level
	"level in folder hierarchy, root is 0"
	self isRoot ifTrue: [^0].
	^self parent level + 1! !

!Folder methodsFor: 'accessing' stamp: 'np 1/18/2008 10:51'!
name
	^self title! !

!Folder methodsFor: 'accessing' stamp: 'np 1/18/2008 10:51'!
name: aString
	self title: aString! !

!Folder methodsFor: 'accessing' stamp: 'np 1/18/2008 10:51'!
nameWithLevelIdent
	"two spaces per level before name"
	| text |
	text := ''.
	self level timesRepeat: [text := text, '..']. 
	^text, self name trimBlanks! !

!Folder methodsFor: 'private' stamp: 'np 1/18/2008 10:54'!
printString
	^'aFolder: ', self name! !

!Folder methodsFor: 'adding-removing' stamp: 'np 1/18/2008 10:53'!
removeDocument: aDocument
	aDocument isFolder ifTrue: [^nil].
	self removeSubdocument: aDocument! !

!Folder methodsFor: 'adding-removing' stamp: 'np 1/18/2008 10:53'!
removeFolder: aFolder
	aFolder isFolder ifFalse: [^nil].
	self removeSubdocument: aFolder! !

!Folder methodsFor: 'adding-removing' stamp: 'np 1/18/2008 10:53'!
removeObsoleteDocuments
	"completely remove obsolete docs, also from url resolver and filesystem"
	self allDocuments do: [:doc | doc isObsolete ifTrue: [doc removeYourself] ]! !

!Folder methodsFor: 'accessing' stamp: 'np 1/18/2008 10:51'!
setProcessFolder
	self type: #processFolder! !

!Folder methodsFor: 'accessing' stamp: 'np 1/18/2008 10:51'!
setTemplateFolder
	self type: #templateFolder! !

!Folder methodsFor: 'accessing' stamp: 'np 1/18/2008 10:52'!
sortedSubcontentsWithProperVersionsFlat: aBoolean filter: aFilter
	"first folders (unsorted) then sorted docs which have id, then unsorted docs without id"
	"if flat, then add all contenty down to hiearchy!!"
	"filters: nil for all, 'released' for only released"
	"add new versions before released docs, also sorted as above"
	| sorted folders docs new released obsolete |
	sorted := OrderedCollection new. aBoolean ifFalse: [sorted addAll: self subfolders]. 
	folders := self subfolders asSet.
	docs := aBoolean ifTrue: [self allDocuments] ifFalse: [self subcontents].
	docs := docs reject: [:each | folders includes: each].
	new := docs inject: Set new into: [:col :each | 
		each isObsolete not & each isNewestVersion not ifTrue: [col add: each nextVersion]. col]. 
	new addAll: (docs reject: [:each | each isReleased | each isObsolete]).
	released := docs select: [:each | each isReleased]. 	obsolete := docs select: [:each | each isObsolete].
	aFilter = 'released' ifFalse: 
		[sorted addAll: (SortedCollection withAll: new sortBlock: [:a :b | a id < b id])].
	sorted addAll: (SortedCollection withAll: released sortBlock: [:a :b | a id < b id]).
	aFilter = 'released' ifFalse: 
		[sorted addAll: (SortedCollection withAll: obsolete sortBlock: [:a :b | a id < b id])].
	^sorted! !

!Folder methodsFor: 'accessing' stamp: 'np 1/18/2008 10:52'!
subcontents
	^self subdocuments! !

!Folder methodsFor: 'accessing' stamp: 'np 1/18/2008 10:52'!
subfolders
	^self subdocuments select: [:each | each isFolder]! !

!Folder methodsFor: 'accessing' stamp: 'np 1/18/2008 10:52'!
uuid
	"some unique identifier. Hash for now, probably unique enough!! "
	^self hash printString! !

Document subclass: #Gallery
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scribo-Components'!

!Gallery methodsFor: 'accessing' stamp: 'np 1/20/2008 16:01'!
allGalleryImages
	"all attached images, which are sized for our gallery"
	^SortedCollection
		withAll: (self imageAttachments select: [:each | '*-gallery.*' match: each origFilename ])
		sortBlock: [:a :b | a origFilename < b origFilename]! !

!Gallery methodsFor: 'accessing' stamp: 'np 1/20/2008 16:01'!
allThumbnailsImages
	"all attached images, which are sized for thumbnails"
	^SortedCollection
		withAll: (self imageAttachments select: [:each | '*-thumbnail.*' match: each origFilename ])
		sortBlock: [:a :b | a origFilename < b origFilename]! !

!Gallery methodsFor: 'accessing' stamp: 'np 1/20/2008 16:01'!
app
	^self webAppFor: self firstSessionFromStack! !

!Gallery methodsFor: 'uploading' stamp: 'np 1/20/2008 16:03'!
deleteImageIndex: aNumber
	"delete all images (original, gallery and thumbnail) shown on that position"
	| image fname images |
	image := self allGalleryImages at: aNumber.
	fname := image origFilename copyReplaceAll: '-gallery' with: ''.
	fname := fname copyFrom: 1 to: (fname lastIndexOf: $.)-1.  "that will be a base for search"
	images := self imageAttachments.
	images do: [:each |
		((fname, '*') match: each origFilename) ifTrue: [self removeAttachment: each] ]! !

!Gallery methodsFor: 'uploading' stamp: 'np 3/27/2008 03:04'!
galleryImgName: aString
	"example: DSC033.jpg = DSC033-gallery.jpg"
	| fname out |
	fname := (SpFilename named: aString). out := WriteStream on: String new.
	out 
		nextPutAll: (fname tail copyFrom: 1 to: (fname tail lastIndexOf: $.)-1);
		nextPutAll: '-gallery';
		nextPutAll: fname extension.
	^out contents

"Gallery new galleryImgName: 'DSC0123.jpg' "! !

!Gallery methodsFor: 'accessing' stamp: 'np 1/20/2008 16:01'!
gallerySize
	"a complete window size of gallery, in pixels"
	^600@540! !

!Gallery methodsFor: 'accessing' stamp: 'np 1/20/2008 16:01'!
imageSize
	"a main image size in pixels"
	^600@450! !

!Gallery methodsFor: 'testing' stamp: 'np 1/20/2008 16:02'!
isGallery
	^true! !

!Gallery methodsFor: 'uploading' stamp: 'np 1/20/2008 16:03'!
resizeAndAttachAttachment: anAttachment
	"resize to additional gallery and thumbnail images and attach them too"
	| attachment |
	attachment := self attachFile: anAttachment filePath 
		named: (self galleryImgName: anAttachment origFilename ).
	self resizeToGalleryImage: attachment filePath.
	attachment proxy refreshContent.
	attachment := self attachFile: anAttachment filePath 
		named: (self thumbnailImgName: anAttachment origFilename).
	self resizeToThumbnailImage: attachment filePath.
	attachment proxy refreshContent.! !

!Gallery methodsFor: 'image resizing' stamp: 'np 6/11/2008 17:57'!
resizeToGalleryImage: aFilename
	| fname geometry |
	fname := (SpFilename named: aFilename) asAbsoluteFilename.
	geometry := self imageSize x printString , 'x', self imageSize y printString ",'!! '" "strict" .
	OSProcess waitForCommand: ('convert "', fname asString, '" -resize ', geometry, ' -quality 80 "', 
		fname asString, '" ').! !

!Gallery methodsFor: 'image resizing' stamp: 'np 6/11/2008 17:57'!
resizeToThumbnailImage: aFilename
	| fname geometry |
	fname := (SpFilename named: aFilename) asAbsoluteFilename.
	geometry := self thumbnailSize x printString , 'x', self thumbnailSize y printString ",'!! '" "strict" .
	OSProcess waitForCommand: 
		('convert "', fname filename, '" -resize ', geometry, ' -quality 80 "', fname filename, '" ').! !

!Gallery methodsFor: 'uploading' stamp: 'np 3/25/2008 21:56'!
thumbnailImgName: aString
	"example: DSC033.jpg = DSC033-gallery.jpg"
	| fname out |
	fname := SpFilename named: aString. out := WriteStream on: String new.
	out 
		nextPutAll: (fname tail copyFrom: 1 to: (fname tail lastIndexOf: $.)-1);
		nextPutAll: '-thumbnail';
		nextPutAll: fname extension.
	^out contents

"Gallery new thumbnailImgName: 'DSC0123.jpg' "! !

!Gallery methodsFor: 'accessing' stamp: 'np 1/20/2008 16:01'!
thumbnailSize
	"a thumbnail image size in pixels"
	^53@40! !

!Gallery methodsFor: 'uploading' stamp: 'np 6/11/2008 17:54'!
unzipAndAttachAttachment: anAttachment
	"unzip to a temp directory then attach images one by one"
	| dir fname origImage |
	dir := (SpFilename named: ('temp', (Random new next * 100) truncated printString)).
	dir makeDirectory.
	fname := anAttachment filePath.
	(SpFilename named: fname) extension = '.gz'
		ifTrue: [OSProcess waitForCommand: ('cd ', dir asAbsoluteFilename filename, '; tar -xzf  ../', fname)]
		ifFalse: [OSProcess waitForCommand: ('cd ', dir asAbsoluteFilename filename, '; unzip ../', fname)].
	dir directoryContents do: [:each || image |
		image := SpFilename named: dir asAbsoluteFilename filename, dir separator asString, each.
		(#('.gif' '.jpg' '.jpeg' '.png') includes: image extension asLowercase) ifTrue: 
			[origImage := self attachFilename: image filename.
			self resizeAndAttachAttachment: origImage].
		 image delete].
	dir delete.
	self removeAttachment: anAttachment. "we don't need .zip file anymore!! "! !

Document subclass: #WikiPage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scribo-Wiki'!

WikiPage subclass: #BlogPost
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scribo-Blog'!

!BlogPost methodsFor: 'adding-removing' stamp: 'np 1/23/2008 15:08'!
addComment: aComment
	aComment isBlogComment ifFalse: [^nil].
	self addSubdocument: aComment 
	! !

!BlogPost methodsFor: 'accessing' stamp: 'np 3/29/2008 01:33'!
approvedComments
	"returns approved comments if comments need approval"
	self blog commentsNeedApproval 
		ifTrue: [^self comments select: [:each | each isApproved]]
		ifFalse: [^self comments]! !

!BlogPost methodsFor: 'accessing' stamp: 'np 8/17/2008 17:39'!
asRSSFeed
	| author |
	self modifiedByText isEmpty
		ifTrue: [author := self createdByText]
		ifFalse: [author := self modifiedByText].
	^WebRSSFeedEntry new
		title: self title;
		author: author;
		message: self htmlBody;
		directUrl: self blog rssRootUrl, self preferedUrl;
		tags: self tokenizedTags;
		timeStamp: self readyTimestamp;
		yourself! !

!BlogPost methodsFor: 'accessing' stamp: 'np 1/24/2008 16:35'!
blog
	^self parent! !

!BlogPost methodsFor: 'accessing' stamp: 'np 3/22/2008 02:17'!
categories
	^self attributesAt: #categories ifAbsent: ['']! !

!BlogPost methodsFor: 'accessing' stamp: 'np 3/22/2008 02:18'!
categories: aString
	self attributesAt: #categories put: aString! !

!BlogPost methodsFor: 'accessing' stamp: 'np 3/29/2008 01:32'!
comments
	^self subdocuments reject: [:each | each isObsolete]! !

!BlogPost methodsFor: 'testing' stamp: 'np 6/5/2008 09:52'!
commentsClosed
	self blog commentsTimeout isEmpty ifTrue: [^true].
	^((SpDate today asDays + self blog commentsTimeout asInteger) - self readyTimestamp asDate asDays) >= 0! !

!BlogPost methodsFor: 'accessing' stamp: 'np 3/29/2008 01:33'!
commentsWaitingApproval
	^self comments select: [:each | each isApproved not]! !

!BlogPost methodsFor: 'private' stamp: 'np 3/22/2008 02:15'!
copyContentsTo: aBlogPost
	"to start a new version from current content"
	super copyContentsTo: aBlogPost.
	aBlogPost status: self status.! !

!BlogPost methodsFor: 'private' stamp: 'np 3/20/2008 03:39'!
copyTimestampsTo: anObject
	super copyTimestampsTo: anObject.
	(self timestamps includesKey: #ready) ifTrue: [
		anObject timestampsAt: #ready put: (self timestampsAt: #ready)]! !

!BlogPost methodsFor: 'testing' stamp: 'np 1/23/2008 16:18'!
isBlogPost
	^true! !

!BlogPost methodsFor: 'testing' stamp: 'np 2/14/2008 02:03'!
isPublished
	^self published
! !

!BlogPost methodsFor: 'accessing' stamp: 'np 3/29/2008 01:37'!
obsoleteComments
	^self subdocuments select: [:each | each isObsolete]! !

!BlogPost methodsFor: 'private' stamp: 'np 2/3/2008 02:05'!
preferedUrl
	| url |
	url := '/blog/', self title replaceSpecialCharacters asLowercase copyReplaceAll: '$' with: '-'.
	^url, '.html'! !

!BlogPost methodsFor: 'accessing' stamp: 'np 3/28/2008 21:16'!
published
	^self status = #ready
! !

!BlogPost methodsFor: 'accessing' stamp: 'np 3/28/2008 21:16'!
published: aBoolean
	aBoolean ifTrue: [self setReadyByMaintainer]
! !

!BlogPost methodsFor: 'accessing' stamp: 'np 2/14/2008 02:04'!
publishedText
	self isPublished 
		ifTrue: [^'Yes']
		ifFalse: [^'No']
! !

!BlogPost methodsFor: 'accessing' stamp: 'np 3/22/2008 02:12'!
tags
	"just a better name for blog post keywords"
	^self keywords! !

!BlogPost methodsFor: 'accessing' stamp: 'np 3/28/2008 22:10'!
tokenizedCategories
	^(self categories subStrings: ',') collect: [:each | 
		each trimBlanksAtBeginAndEnd]! !

!BlogPost methodsFor: 'accessing' stamp: 'np 3/28/2008 22:11'!
tokenizedTags
	^(self tags subStrings: ',') collect: [:each |
		each trimBlanksAtBeginAndEnd]! !

!BlogPost methodsFor: 'accessing' stamp: 'np 3/28/2008 21:57'!
updateUrl
	"update the url of the post. Usefull when its title has changed"
	self parent repository site urlResolver changeToPreferedURL: self newestVersion.
	self approvedComments do: [:each | self parent repository site urlResolver changeToPreferedURL: each]! !

WikiPage subclass: #SitePage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scribo-Sites'!

!SitePage class methodsFor: 'instance creation' stamp: 'np 6/23/2008 00:22'!
newOnStyle: aWebStyle
	"find appropriate class for a new site page, defined in ScriboStyle sitePageClass"
	^aWebStyle sitePageClass new! !

!SitePage methodsFor: 'accessing' stamp: 'np 1/21/2008 10:55'!
content
	^self parent! !

!SitePage methodsFor: 'testing' stamp: 'janko 3/16/2008 13:45'!
isFirstPage
	^self isDefaultPage! !

!SitePage methodsFor: 'private' stamp: 'np 1/30/2008 23:04'!
preferedUrl
	^'/', self title replaceSpecialCharacters asLowercase, '.html'! !

!WikiPage class methodsFor: 'instance creation' stamp: 'np 1/21/2008 10:45'!
newOnStyle: aWebStyle
	"find appropriate class for a new wiki page, defined in BiArtStyle wikiPageClass"
	^aWebStyle wikiPageClass new! !

!WikiPage methodsFor: 'private' stamp: 'np 1/21/2008 10:44'!
copyImageAttachment: anAttachment to: anObject
	"copy attachment but there is no need for copy an image file"
	| attachment |
	attachment := Attachment new parent: self.
	attachment 	
		origFilename: anAttachment origFilename;
		contentType: anAttachment contentType;
		url: anAttachment url.
	anObject addAttachment: attachment.
	attachment makeProxy.
	^attachment! !

!WikiPage methodsFor: 'private' stamp: 'np 1/21/2008 10:44'!
deleteImageIndex: aNumber
	"delete an image attaachment shown on that position"
	| image |
	image := self imageAttachments at: aNumber.
	self removeAttachment: image! !

!WikiPage methodsFor: 'accessing' stamp: 'np 8/17/2008 18:00'!
htmlBody
	self isTinyMCEInstalled 
		ifTrue: [^WikiRender linksOnlyFrom: self body for: self]
		ifFalse: [^WikiRender linksOnlyFrom: self body for: self]! !

!WikiPage methodsFor: 'private-access rights' stamp: 'np 1/21/2008 10:44'!
isAccessAdditionallyAllowedFor: aPersonOrWebUser
	"if access rights are not set, then it is allowed by default!!"
	^self areAccessRightsSet not! !

!WikiPage methodsFor: 'testing' stamp: 'np 1/21/2008 10:44'!
isDefaultPage
	^self == self parent defaultPage! !

!WikiPage methodsFor: 'private-access rights' stamp: 'np 1/21/2008 10:45'!
isDeleteAdditionallyAllowedFor: aPersonOrWebUser
	"if access rights are not set, then it is allowed by default!!"
	^self areAccessRightsSet not! !

!WikiPage methodsFor: 'testing' stamp: 'np 3/15/2008 17:09'!
isTinyMCEInstalled
	| dir |
	dir := SpFilename named: 'tinymce'.
	^(dir exists & dir isDirectory)! !

!WikiPage methodsFor: 'private' stamp: 'np 1/30/2008 23:04'!
preferedUrl
	^'/wiki/', self title replaceSpecialCharacters asLowercase, '.html'! !

!WikiPage methodsFor: 'accessing' stamp: 'np 1/21/2008 17:36'!
repository
	self parent isNil ifTrue: [^nil].
	^self parent repository! !

!Information class methodsFor: 'instance creation' stamp: 'np 6/23/2008 00:19'!
new
	^self basicNew initialize! !

WebApplication subclass: #EventLogApp
	instanceVariableNames: 'seenTimestamp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scribo-Core'!

!EventLogApp methodsFor: 'printing-elements' stamp: 'np 5/13/2008 22:07'!
elementForEvents: aCollection in: aLogSymbol
	| e |
	e := WebElement new. 
	self seenTimestamp:  (self lastSeen: aLogSymbol).
	e add: (WebGrid new
		columnNames: #(nil 'date' 'time' 'document' 'user');
		columnAspects: #(nil dateString timeString objectName actorName);
		columnLinkAspects: #(nil nil nil object nil);
		columnAlign: #(#right #center #center);
		collection: aCollection;
		setNumbering; shortDates;
		rowGreenIfTrue: [:event | event isLaterThan: (self app seenTimestamp)];
		yourself).
	^e! !

!EventLogApp methodsFor: 'printing-elements' stamp: 'np 3/29/2008 04:58'!
introElement
	| e |
	e := WebElement new. e table width: 1 "100%"; class: #webGrid.
	e cell addTextH3: 'Dnevnik dogodkov'. 
	^e! !

!EventLogApp methodsFor: 'private-last seen' stamp: 'np 3/29/2008 05:00'!
lastSeen: aSymbol
	| symbol |
	symbol := ('biartEventLogLastSeen', aSymbol asString capitalized) asSymbol.
	^self user otherValuesAt: symbol ifAbsent: [self user otherValuesAt: symbol  put: SpTimestamp now].! !

!EventLogApp methodsFor: 'private-last seen' stamp: 'np 3/29/2008 05:00'!
lastSeenAccessed
	^self lastSeen: #accessed! !

!EventLogApp methodsFor: 'private-last seen' stamp: 'np 3/29/2008 05:00'!
lastSeenAll
	^self lastSeen: #all! !

!EventLogApp methodsFor: 'private-last seen' stamp: 'np 3/29/2008 05:00'!
lastSeenApproved
	^self lastSeen: #approved! !

!EventLogApp methodsFor: 'private-last seen' stamp: 'np 3/29/2008 05:00'!
lastSeenCreated
	^self lastSeen: #created! !

!EventLogApp methodsFor: 'private-last seen' stamp: 'np 3/29/2008 05:00'!
lastSeenModified
	^self lastSeen: #modified! !

!EventLogApp methodsFor: 'private-last seen' stamp: 'np 3/29/2008 05:00'!
lastSeenObsolete
	^self lastSeen: #obsolete! !

!EventLogApp methodsFor: 'private-last seen' stamp: 'np 3/29/2008 05:01'!
lastSeenReleased
	^self lastSeen: #released! !

!EventLogApp methodsFor: 'printing-elements' stamp: 'np 3/29/2008 04:58'!
nrOfAll
	| count |
	count := self observee numberOfAllSince: self lastSeenAll.
	count = 0 ifTrue: [^''].
	^' (', count printString, ')'! !

!EventLogApp methodsFor: 'printing-elements' stamp: 'np 3/29/2008 04:58'!
nrOfLogs: aSymbol
	| count |
	count := self observee numberOfLog: aSymbol since: (self lastSeen: aSymbol).
	count = 0 ifTrue: [^''].
	^' (', count printString, ')'! !

!EventLogApp methodsFor: 'accessing' stamp: 'np 3/29/2008 04:55'!
numberOfRows
	^100! !

!EventLogApp methodsFor: 'private-last seen' stamp: 'np 3/29/2008 05:01'!
seenTimestamp
	^seenTimestamp! !

!EventLogApp methodsFor: 'private-last seen' stamp: 'np 3/29/2008 05:01'!
seenTimestamp: anObject
	seenTimestamp := anObject! !

!EventLogApp methodsFor: 'private-last seen' stamp: 'np 3/29/2008 05:01'!
setLastSeen: aSymbol
	| symbol |
	symbol := ('biartEventLogLastSeen', aSymbol asString capitalized) asSymbol.
	^self user otherValuesAt: symbol put: SpTimestamp now.! !

!EventLogApp methodsFor: 'private-last seen' stamp: 'np 3/29/2008 05:01'!
setLastSeenAccessed
	self setLastSeen: #accessed! !

!EventLogApp methodsFor: 'private-last seen' stamp: 'np 3/29/2008 05:01'!
setLastSeenAll
	self setLastSeen: #all! !

!EventLogApp methodsFor: 'private-last seen' stamp: 'np 3/29/2008 05:01'!
setLastSeenApproved
	self setLastSeen: #approved! !

!EventLogApp methodsFor: 'private-last seen' stamp: 'np 3/29/2008 05:01'!
setLastSeenCreated
	self setLastSeen: #created! !

!EventLogApp methodsFor: 'private-last seen' stamp: 'np 3/29/2008 05:01'!
setLastSeenModified
	self setLastSeen: #modified! !

!EventLogApp methodsFor: 'private-last seen' stamp: 'np 3/29/2008 05:01'!
setLastSeenObsolete
	self setLastSeen: #obsolete! !

!EventLogApp methodsFor: 'private-last seen' stamp: 'np 3/29/2008 05:02'!
setLastSeenReleased
	self setLastSeen: #released! !

!EventLogApp methodsFor: 'printing-statistics' stamp: 'np 3/29/2008 04:59'!
statisticsElement
	| e statDict |
	e := WebElement new. e table width: 0.8; class: #actionTable.
	self observee modifiedLog allYears reverse do: [:year |
		statDict := self observee docStatsForYear: year.
		e cell colspan: 10; addTextH2: year printString. e newRow.
		self statsHeaderForTableIn: e.
		self statsTypes do: [:type |
			e cell addText: (self statsLabelForType: type). 
			e newCell align: #center; addText: ((statDict at: #created) at: type ifAbsent: ['&nbsp;']).
			e newCell align: #center; addText: ((statDict at: #modified) at: type ifAbsent: ['&nbsp;']).
			e newCell align: #center; addText: ((statDict at: #approved) at: type ifAbsent: ['&nbsp;']).
			e newCell align: #center; addText: ((statDict at: #released) at: type ifAbsent: ['&nbsp;']).
			e newCell align: #center; addText: ((statDict at: #obsolete) at: type ifAbsent: ['&nbsp;']).
			e newRow]].		
	^e! !

!EventLogApp methodsFor: 'printing-statistics' stamp: 'np 3/29/2008 04:59'!
statsHeaderForTableIn: e
	e newCell addText: 'Novo'.
	e newCell addText: 'Spremenjeno'.
	e newCell addText: 'Odobreno'.
	e newCell addText: 'Objavljeno'.
	e newCell addText: 'Umaknjeno'.
	e newRow.! !

!EventLogApp methodsFor: 'printing-statistics' stamp: 'np 3/29/2008 04:59'!
statsLabelForType: aType
	^aType asString! !

!EventLogApp methodsFor: 'printing-statistics' stamp: 'np 3/29/2008 05:00'!
statsTypes
	| types |
	types := OrderedCollection new.
	types addAll: self observee docTypeCodes.
	types addAll: #(otherDoc action meeting other).
	^types! !

!EventLogApp methodsFor: 'printing-elements' stamp: 'np 3/29/2008 05:56'!
tabsElement
 	^ViewTabs new
		addView: #main "created" description: ('<small>New', (self nrOfLogs: #created), '</small>');
		addView: #modified description: ('<small>Modified', (self nrOfLogs: #modified), '</small>');
		addView: #approved description: ('<small>Approved', (self nrOfLogs: #approved), '</small>');
		addView: #released description: ('<small>Released', (self nrOfLogs: #released), '</small>');
		addView: #obsolete description: ('<small>Removed', (self nrOfLogs: #obsolete), '</small>');
		addView: #accesses description: ('<small>Accessed', (self nrOfLogs: #accessed), '</small>');
		addView: #statistics description: '<small>Statistics</small>';
		yourself.! !

!EventLogApp methodsFor: 'printing' stamp: 'np 3/29/2008 04:55'!
viewAccesses
	| e |
	self title: 'BiArt - dnevnik dogodkov'.
	e := WebElement new.   e table width: self pageContentWidth.
	e cell add: self introElement. e newRow.
	e cell add: self tabsElement. e newRow.
	e cell add: (self elementForEvents: (self observee accessedLog last: self numberOfRows) 
		in: #accessed).
	self setLastSeenAccessed.
	self pageFrameWith: e title: self title! !

!EventLogApp methodsFor: 'printing' stamp: 'np 3/29/2008 04:56'!
viewApproved
	| e |
	self title: 'BiArt - dnevnik dogodkov'.
	e := WebElement new.   e table width: self pageContentWidth.
	e cell add: self introElement. e newRow.
	e cell add: self tabsElement. e newRow.
	e cell add: (self elementForEvents: (self observee approvedLog last: self numberOfRows)
		in: #approved).
	self setLastSeenApproved.
	self pageFrameWith: e title: self title! !

!EventLogApp methodsFor: 'printing' stamp: 'np 3/29/2008 04:56'!
viewCreated
	| e |
	self title: 'BiArt - dnevnik dogodkov'.
	e := WebElement new.   e table width: self pageContentWidth.
	e cell add: self introElement. e newRow.
	e cell add: self tabsElement. e newRow.
	e cell add: (self elementForEvents: (self observee createdLog last: self numberOfRows)
		in: #created).
	self setLastSeenCreated.
	self pageFrameWith: e title: self title! !

!EventLogApp methodsFor: 'printing' stamp: 'np 3/29/2008 04:56'!
viewMain
	self viewCreated! !

!EventLogApp methodsFor: 'printing' stamp: 'np 3/29/2008 04:56'!
viewModified
	| e |
	self title: 'BiArt - dnevnik dogodkov'.
	e := WebElement new.   e table width: self pageContentWidth.
	e cell add: self introElement. e newRow.
	e cell add: self tabsElement. e newRow.
	e cell add: (self elementForEvents: (self observee modifiedLog last: self numberOfRows)
		in: #modified).
	self setLastSeenModified.
	self pageFrameWith: e title: self title! !

!EventLogApp methodsFor: 'printing' stamp: 'np 3/29/2008 04:56'!
viewObsolete
	| e |
	self title: 'BiArt - dnevnik dogodkov'.
	e := WebElement new.   e table width: self pageContentWidth.
	e cell add: self introElement. e newRow.
	e cell add: self tabsElement. e newRow.
	e cell add: (self elementForEvents: (self observee obsoleteLog last: self numberOfRows)
		in: #obsolete).
	self setLastSeenObsolete.
	self pageFrameWith: e title: self title! !

!EventLogApp methodsFor: 'printing' stamp: 'np 3/29/2008 04:57'!
viewReleased
	| e |
	self title: 'BiArt - dnevnik dogodkov'.
	e := WebElement new.   e table width: self pageContentWidth.
	e cell add: self introElement. e newRow.
	e cell add: self tabsElement. e newRow.
	e cell add: (self elementForEvents: (self observee releasedLog last: self numberOfRows)
		in: #released).
	self setLastSeenReleased.
	self pageFrameWith: e title: self title! !

!EventLogApp methodsFor: 'printing' stamp: 'np 3/29/2008 04:57'!
viewStatistics
	| e |
	self title: 'BiArt - Statistika dokumentov'.
	e := WebElement new. e table width: self pageContentWidth.
	e cell add: self tabsElement. e newRow.
	e cell add: self statisticsElement.
	self pageFrameWith: e title: self title! !

WebApplication subclass: #GalleryApp
	instanceVariableNames: 'current attachContentType file filename'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scribo-Components'!

!GalleryApp methodsFor: 'actions' stamp: 'np 3/28/2008 00:26'!
actionMainAttach
	"upload .zip or idividual image to gallery"
	(self filename isNil or: [self filename isEmpty]) ifTrue: [^nil].
	self observee attachFilename: self filename content: self file.
	self isZipUploaded 
		ifTrue: [self observee unzipAndAttachAttachment: self observee attachments last]
		ifFalse:
			[self observee resizeAndAttachAttachment: self observee attachments last.
			self current: self observee allGalleryImages size]. "to immediatelly show newly uploaded" 	self redirectToView: #main! !

!GalleryApp methodsFor: 'printing-elements' stamp: 'np 1/20/2008 18:23'!
adminElement
	| e |
	e := WebElement new.
	e add: self uploadElement.
	^e! !

!GalleryApp methodsFor: 'accessing' stamp: 'np 3/28/2008 03:45'!
attachContentType
	"content type of attachment"
	^attachContentType! !

!GalleryApp methodsFor: 'accessing' stamp: 'np 3/28/2008 03:45'!
attachContentType: aString
	"content type of attachment"
	attachContentType := aString! !

!GalleryApp methodsFor: 'access rights' stamp: 'np 1/20/2008 18:22'!
canBeEdited
	^self user isAdmin! !

!GalleryApp methodsFor: 'accessing' stamp: 'np 1/20/2008 18:22'!
current
	"index of currently shown image"
	current isNil ifTrue: [self current: 1].
	^current! !

!GalleryApp methodsFor: 'accessing' stamp: 'np 1/20/2008 18:22'!
current: aNumber
	"index of currently shown image"
	current := aNumber! !

!GalleryApp methodsFor: 'accessing' stamp: 'np 3/27/2008 02:54'!
file
	^file! !

!GalleryApp methodsFor: 'accessing' stamp: 'np 3/27/2008 02:54'!
file: aByteArray
	"contents of file to attach"
	file := aByteArray! !

!GalleryApp methodsFor: 'accessing' stamp: 'np 3/27/2008 02:55'!
filename
	^filename! !

!GalleryApp methodsFor: 'accessing' stamp: 'np 3/27/2008 02:55'!
filename: aString
	"original name of attached file"
	filename := aString! !

!GalleryApp methodsFor: 'accessing' stamp: 'np 3/28/2008 04:01'!
gallerySize
	"bigger size for admins to add space for upload etc"
	^self canBeEdited
		ifTrue: [(self observee gallerySize x) @ (self observee gallerySize y + 60)]
		ifFalse: [self observee gallerySize]! !

!GalleryApp methodsFor: 'printing-elements' stamp: 'np 1/20/2008 18:23'!
imageIndexFromRequest
	"if url query part have index=<image index>, then set current"
	(self session lastRequest includesQuery: 'index') ifTrue:
		[self current: (self session lastRequest queryAt: 'index') asInteger]! !

!GalleryApp methodsFor: 'testing' stamp: 'np 3/27/2008 02:59'!
isZipUploaded
	".zip or .tar.gz uploaded"
	^#('.zip' '.gz') includes: ((SpFilename named: self observee attachments last origFilename) extension)! !

!GalleryApp methodsFor: 'printing-elements' stamp: 'np 1/20/2008 18:24'!
mainImageElement
	| e images image |
	e := WebElement new.
	images := self observee allGalleryImages.
	images isEmpty ifTrue: [^e].
	self current = 0 ifTrue: [self current: 1].
	self current > images size ifTrue: [self current: images size].
	image := (images at: self current).
	e addImage: image url.
	image title notEmpty | self canBeEdited 
		ifTrue: [e addBreak; add: (self subtitleElementFor: image)].
	^e! !

!GalleryApp methodsFor: 'printing-elements' stamp: 'np 1/20/2008 18:24'!
navigationElement
	"previous, number/all, next link"
	| e imgNumber |
	e := WebElement new.
	imgNumber := self observee allGalleryImages size.
	imgNumber = 0 ifTrue: [^e].
	self current = 1 
		ifTrue: [e addText: self galleryPrevText "from *Style class"]
		ifFalse: [e addGif: #arrowCircledRedLeftGif; addSpace;
			addLinkTo: self observee text: (self galleryPrevText, ' ') 
				parameter: 'index' value: (self current-1) printString].
	e addText: (' ', self current printString, '/', imgNumber printString, ' ').
	self current = imgNumber 
		ifTrue: [e addText: self galleryNextText]
		ifFalse: 
			[e addLinkTo: self observee text: self galleryNextText 
				parameter: 'index' value: (self current+1) printString.
			e addSpace; addGif: #arrowCircledRedGif].
	^e! !

!GalleryApp methodsFor: 'printing-elements' stamp: 'np 1/20/2008 18:24'!
subtitleElementFor: anAttachment
	| e  text |
	e := WebElement new.
 	text := ((WebInPlaceEditableText aspect: #title for: anAttachment
		size: 60 allow: self canBeEdited) 
		triggerElement: ((WebImage png: #buttonCommentPng) title: 'Opis^i sliko') ).
	^e add: text; yourself! !

!GalleryApp methodsFor: 'printing-elements' stamp: 'np 1/20/2008 18:24'!
thumbnailsElement
	| e images link selected |
	e := WebElement new. e table cellPadding: 0; cellSpacing: 1.
	images := self observee allThumbnailsImages. 	images isEmpty ifTrue: [^e].
	selected := self thumbnailsToShowFrom: images. "so that current will be in the middle"
	selected do: [:image || inx |
		inx := images indexOf: image.
		link := WebLink linkTo: self observee.
		link parameter: 'index' value: inx printString.
		link addImage: image url.
		e cell align: #center; style: 'text-align: center'; valign: #bottom; add: link.
		self canBeEdited ifTrue: 
			[link := WebLink new linkTo: self observee. 
			link add: (WebImage gif: #buttonCloseGif). 
			link view: #delete; parameter: 'index' value: inx printString.
			e cell addBreak; add: link].
		e newCell].
	^e! !

!GalleryApp methodsFor: 'printing-elements' stamp: 'np 1/20/2008 18:24'!
thumbnailsInLine
	"number of thumbnails which fit on width of gallery"
	^10! !

!GalleryApp methodsFor: 'printing-elements' stamp: 'np 1/20/2008 18:24'!
thumbnailsToShowFrom: aCollection
	"select only those which can be shown in the width of gallery, so that current will be in the middle"
	| start |
	aCollection size <= self thumbnailsInLine ifTrue: [^aCollection].
	start := (self current - (self thumbnailsInLine // 2)) max: 1.  "current should stay in the middle"
"	start := start min: self thumbnailsInLine. "
	^aCollection copyFrom: start to: ((start + self thumbnailsInLine) min: aCollection size)! !

!GalleryApp methodsFor: 'printing-elements' stamp: 'np 3/28/2008 03:59'!
uploadElement
	| e text popup |
	e := WebElement new. 
	popup := WebElement newClass: #popup. popup hide.
	text := WebLink text: 'Upload image', '.'  linkTo: 'javascript:nic()' .
	text onClickToggle: popup.
	popup
		addText: 'Image or .zip: ';
		add: (WebFileInputField aspect: #file filenameAspect: #filename 
			contentTypeAspect: #attachContentType forObject: self);
		addButtonText: 'Upload' action: #attach.
	e addGif: #arrowOrangeRightGif; addSpace; add: text.
	e add: popup.
	^e! !

!GalleryApp methodsFor: 'printing' stamp: 'np 1/20/2008 18:23'!
viewDelete
	self canBeEdited ifFalse: [^self].
	self imageIndexFromRequest.
	self observee deleteImageIndex: self current.
	self current: (self current min: self observee allGalleryImages size).
	self redirectToView: #main! !

!GalleryApp methodsFor: 'printing' stamp: 'np 1/20/2008 18:23'!
viewMain
	self imageIndexFromRequest.
	self table width: self observee gallerySize x.
	self cell align: #center; style: 'text-align: center'; add: self mainImageElement. self newRow.
	self cell align: #center; style: 'align: center; text-align: center'; 
		add: self thumbnailsElement. self newRow.
	self cell align: #center; style: 'align: center; text-align: center'; valign: #middle;
		add: self navigationElement. "example: 12/36"
	self canBeEdited ifTrue: [self cell addNbSp:4 ; add: self adminElement].! !

WebApplication subclass: #WikiApp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scribo-Wiki'!

WikiApp subclass: #BlogApp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scribo-Blog'!

!BlogApp methodsFor: 'actions' stamp: 'np 4/5/2008 20:06'!
actionEdit
	self redirectTo: self observee! !

!BlogApp methodsFor: 'printing-elements' stamp: 'np 5/6/2008 20:22'!
actionsLineElement
	| e |
	e := WebElement new. e table width: self pageContentWidth.
	e cell addLinkTo: self observee text: 'Settings' view: #edit; addSpace.
	e cell addLinkTo: self observee text: 'Write' view: #add; addSpace.
	e cell addLinkTo: self observee text: 'Posts' view: #posts; addSpace.
	e cell addLinkTo: self observee text: 'Comments' view: #comments; addSpace.
	e newCell align: #right.
	e cell addLinkTo: self site admin text: 'Logout' view: #logout; addSpace.
	^e! !

!BlogApp methodsFor: 'access rights' stamp: 'np 6/5/2008 09:49'!
canBeEdited
	^self user isAdmin! !

!BlogApp methodsFor: 'access rights' stamp: 'np 6/4/2008 20:14'!
canBeUpdated
	^self canBeEdited! !

!BlogApp methodsFor: 'printing-elements' stamp: 'np 5/7/2008 17:44'!
commentsGridElement
	| e |
	e := WebElement new.
	e add: (WebGrid new width: self pageContentWidth;
		columnNames: #(nil 'By' 'Title' 'Created');
		columnAspects: #(nil createdByText title createdTimestampText);
		columnLinkViews: #(nil nil main nil nil);
		collection: self observee comments;
		setNumbering;
		rowsOnPage: 50;
		yourself).
	e addBreak.
	self observee commentsNeedApproval ifTrue: [
		self observee commentsWaitingApproval notEmpty ifTrue: [
			e addLinkTo: self observee 
				text: self observee commentsWaitingApproval size printString, ' comments waiting approval' 
				view: #commentsWaitingApproval]].
	^e! !

!BlogApp methodsFor: 'printing' stamp: 'np 4/5/2008 20:05'!
ensureRSSInHeader
	self addRSSLinkInHeaderFor: self observee 
		view: #RSSPosts 
		title: self observee title.
	self addRSSLinkInHeaderFor: self observee 
		view: #RSSComments 
		title: self observee title, ' (Comments)'.! !

!BlogApp methodsFor: 'printing' stamp: 'np 4/1/2008 21:53'!
pageFrameWith: anElement title: aString
	^self style blogPageFrameWith: anElement title: aString! !

!BlogApp methodsFor: 'printing-elements' stamp: 'np 8/17/2008 17:37'!
postElementFor: aPost
	| e |
	e := WebElement new class: #post. 
	e add: (self postHeaderElementFor: aPost).
	e addText: aPost htmlBody.
	e add: (self postFooterElementFor: aPost).
	^e.! !

!BlogApp methodsFor: 'printing-elements' stamp: 'np 5/7/2008 17:44'!
postsGridElement
	| e |
	e := WebElement new.
	e add: (WebGrid new width: self pageContentWidth;
		columnNames: #(nil 'Title' 'Modified' 'Published' 'By');
		columnFilters: #(nil true nil nil nil);
		columnAspects: #(nil title modifiedTimestampText publishedText modifiedByText);
		collection: self observee posts;
		columnLinkViews: #(nil main nil nil);
		setNumbering;
		rowsOnPage: 50;
		yourself).
	e addBreak.
	e cell addLinkTo: self observee text: 'Write a new post' view: 'add'.
	^e! !

!BlogApp methodsFor: 'printing' stamp: 'mu 4/10/2008 20:00'!
viewAdd
	| pageTitle |
	pageTitle := 'New post'.
	(self session lastRequest includesQuery: 'title')  ifTrue: [
		pageTitle := self session queryStringAt: 'title'].
	pageTitle := pageTitle copyReplaceAll: '+' with: ' '. 
	self redirectTo: ((BlogPost newCreatedBy: self session user) parent: self observee; title: pageTitle) view: #add! !

!BlogApp methodsFor: 'printing' stamp: 'np 8/22/2008 00:18'!
viewArchive
	| e archiveDate posts page |
	e := WebElement new.
	self ensureRSSInHeader.
	self canBeEdited ifTrue: [e add: self actionsLineElement].
	posts := self observee publishedPosts select: [:each | each isAccessAllowedFor: self session user].
	page := 1.
	(self session lastRequest includesQuery: 'archive') 
		ifFalse: [^ self redirectToView: #main]
		ifTrue: 
			[archiveDate := self session queryStringAt: 'archive'.
			posts := posts select: [:each | each createdTimestamp asMonth asString = archiveDate].
			e addTextH1: 'Archive for ' , archiveDate asString].
	(self session lastRequest includesQuery: 'page') ifTrue: [ 
		page := (self session lastRequest queryAt: 'page') asInteger max: 1].
	e add: (BlogPostBatcher new
			page: page;
			view: #archive;
			addParameter: 'archive' value: archiveDate;
			posts: posts;
			class: 'batcher').
	self pageFrameWith: e title: self observee title! !

!BlogApp methodsFor: 'printing' stamp: 'np 8/22/2008 00:18'!
viewCategory
	| e category posts page |
	e := WebElement new.
	self ensureRSSInHeader.
	self canBeEdited ifTrue: [e add: self actionsLineElement].
	posts := self observee publishedPosts select: [:each | each isAccessAllowedFor: self session user].
	page := 1.
	(self session lastRequest includesQuery: 'category') 
		ifFalse: [^ self redirectToView: #main]
		ifTrue: [
			category := self session queryStringAt: 'category'.
			posts := posts select: [: each | each tokenizedCategories contains: [:t | t = category]].
			e addText: 'Archive for the category: ''' , category , '''' header: 1].
	(self session lastRequest includesQuery: 'page') ifTrue: [ 
		page := (self session lastRequest queryAt: 'page') asInteger max: 1].
	e add: (BlogPostBatcher new
			page: page;
			view: #category;
			addParameter: 'category' value: category;
			posts: posts;
			class: 'batcher').
	self pageFrameWith: e title: self observee title! !

!BlogApp methodsFor: 'printing' stamp: 'np 5/3/2008 20:22'!
viewComments
	| e |
	e := WebElement new.
	self ensureRSSInHeader.
	self title: 'Comments'.
	e addText: self title header: 1.
	e add: self commentsGridElement.
	self pageFrameWith: e title: self title! !

!BlogApp methodsFor: 'printing' stamp: 'np 8/17/2008 17:44'!
viewCommentsWaitingApproval
	| e f |
	e := WebElement new.
	self ensureRSSInHeader.
	self title: 'Comments waiting approval'.
	e addTextH1: self title.
	e newRow.
	self observee commentsWaitingApproval isEmpty ifTrue: [e addTextItalic: 'No comment waiting approval.'].
	self observee commentsWaitingApproval do: [:each |
		e addText: 'Comment for: ', each post title header: 2.
		f := WebElement new class: #blogComment.
		f addText: each createdTimestampText; addBreak.
		f addText: each createdByText, ' says :'; addBreak.
		f addText: each body.
		f addBreak.
		f addLinkTo: each text: 'Approve' view: #approve; addNbSp.
		f addLinkTo: each text: 'Remove' view: #remove; addNbSp.
		f addLinkTo: each text: 'Edit' view: #edit.
		e add: f].
	self pageFrameWith: e title: self title! !

!BlogApp methodsFor: 'printing' stamp: 'np 5/11/2008 01:49'!
viewEdit
	| e |
	e := WebElement new.
	self ensureRSSInHeader.
	self title: 'Settings'.
	e newRow.
	e table width: self pageContentWidth.
	e cell cell addTextH1: 'General settings'.
	e newRow.
	e cell add: (self smallText: 'Title: ' attributes: #bold).
	e newCell colspan: 3;
		add: (WebInputField new size: 50; aspect: #title for: self observee).
	e newRow.
	e cell add: (self smallText: 'Tagline: ' attributes: #bold).
	e newCell colspan: 3;
		add: (WebInputField new size: 50; aspect: #tagline for: self observee).
	e newRow.
	e cell addTextH1: 'RSS settings'.
	e newRow.
	e cell add: (self smallText: 'RSS feeds root url: ' attributes: #bold).
	e newCell colspan: 3;
		add: (WebInputField new size: 50; aspect: #rssRootUrl for: self observee).
	e newRow.
	e cell addTextH1: 'Comments settings'.
	e newRow.
	e cell add: (self smallText: 'Comments timeout (in days): ' attributes: #bold).
	e newCell colspan: 3;
		add: (WebInputField new size: 50; aspect: #commentsTimeout for: self observee).
	e newRow.
	e cell add: (self smallText: 'Comments need approval: ' attributes: #bold).
	e newCell colspan: 3;
		addCheckboxAspect: #commentsNeedApproval for: self observee.
		
	e newRow.
	e cell colspan: 3;
		add: (WebButton new text: 'Save'; type: #submit ).
	
	^self pageFrameWith: e title: self title.! !

!BlogApp methodsFor: 'printing' stamp: 'np 5/14/2008 01:57'!
viewMain
	| e page posts |
	e := WebElement new.
	self ensureRSSInHeader.
	self canBeUpdated ifTrue: [e add: self actionsLineElement].
	posts := self observee publishedPosts select: [:each | each isAccessAllowedFor: self session user].
	(self session lastRequest includesQuery: 'page') 
		ifTrue: [page := (self session lastRequest queryAt: 'page') asInteger max: 1 ]
		ifFalse: [page := 1].
	e add: (BlogPostBatcher new
			page: page;
			posts: posts;
			class: 'batcher').
	self pageFrameWith: e title: self observee title! !

!BlogApp methodsFor: 'printing' stamp: 'np 8/17/2008 20:20'!
viewPosts
	| e |
	e := WebElement new.
	self ensureRSSInHeader.
	self title: 'Posts'.
	e addText: self title header: 1; addBreak.
	e add: self postsGridElement.
	self pageFrameWith: e title: self title! !

!BlogApp methodsFor: 'printing' stamp: 'np 4/5/2008 19:52'!
viewRSSComments
	^(WebRSSResource newFor: self site)
		feedEntries: self observee commentsFeeds;
		title: self observee title, ' comments';
		description: self observee tagline;
		yourself.! !

!BlogApp methodsFor: 'printing' stamp: 'np 4/5/2008 19:51'!
viewRSSPosts
	^(WebRSSResource newFor: self site)
		feedEntries: self observee postFeeds;
		title: self observee title;
		description: self observee tagline;
		yourself.! !

!BlogApp methodsFor: 'printing' stamp: 'np 8/22/2008 00:19'!
viewTag
	| e tag posts page |
	e := WebElement new.
	self ensureRSSInHeader.
		self canBeEdited ifTrue: [e add: self actionsLineElement].
	posts := self observee publishedPosts select: [:each | each isAccessAllowedFor: self session user].
	page := 1.
	(self session lastRequest includesQuery: 'tag') 
		ifFalse: [^ self redirectToView: #main]
		ifTrue: [ 
			tag := self session queryStringAt: 'tag'.
			posts := posts select: [:each | each tokenizedTags contains: [:t | t = tag]].
			e addTextH1: 'Articles posted in ''' , tag , ''''].
	(self session lastRequest includesQuery: 'page') ifTrue: [ 
		page := (self session lastRequest queryAt: 'page') asInteger max: 1].
	e add: (BlogPostBatcher new
			page: page;
			view: #tag;
			addParameter: 'tag' value: tag;
			posts: posts;
			class: 'batcher').
	self blogPageFrameWith: e title: self observee title! !

WikiApp subclass: #SiteContentApp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scribo-Sites'!

!SiteContentApp methodsFor: 'printing' stamp: 'np 8/19/2008 17:10'!
pageFrameWith: anElement title: aString
	^self style sitePageFrameWith: anElement title: aString! !

!SiteContentApp methodsFor: 'printing' stamp: 'np 8/19/2008 17:10'!
pageFrameWith: aWebElement title: aTitleString tabs: aTabsElement
	| element |
	self clear;  title: aTitleString.
	element := (WebElement newId: #container)
		add: self headerElement; 
		add: ((WebElement newId: #siteTabs) 
			add: aTabsElement; 
			yourself); 
		addBreak; 
		add: ((WebElement newId: #sitePage) 
			add: aWebElement; 
			yourself); 
		yourself.
	^self app add: element; yourself! !

!SiteContentApp methodsFor: 'actions' stamp: 'janko 3/16/2008 23:57'!
viewAdd
	| pageTitle |
	pageTitle := AIDASite convert: (self session lastRequest queryAt: 'title') fromCodepage: #'iso8859-2'.
	pageTitle := pageTitle copyReplaceAll: '+' with: ' '. 
	self redirectTo: ((SitePage newOnStyle: self style) parent: self observee; title: pageTitle) view: #add! !

!WikiApp methodsFor: 'printing-elements' stamp: 'janko 7/31/2008 19:24'!
moveLinksForPage: aPage
	| e index first last |
	e := WebElement new.
	index := self observee ordered indexOf: aPage.
	first := aPage = self observee ordered first.
	last := aPage = self observee ordered last.
"	self canBeEdited ifFalse: [^e]. "
	first ifFalse: 
		[e addLinkTo: self observee
			gif: #arrowOrangeUpGif  title: 'Move up'
			view: #moveUp parameter: 'nr' value: index printString].
	last ifFalse: 
		[e addLinkTo: self observee 
			gif: #arrowOrangeDownGif  title: 'Move down'
			view: #moveDown parameter: 'nr' value: index printString].
	^e! !

!WikiApp methodsFor: 'printing' stamp: 'np 8/19/2008 17:10'!
pageFrameWith: anElement title: aString
	^self style wikiPageFrameWith: anElement title: aString ! !

!WikiApp methodsFor: 'printing' stamp: 'mu 4/10/2008 20:00'!
viewAdd
	| pageTitle |
	pageTitle := self session queryStringAt: 'title'.
	pageTitle := pageTitle copyReplaceAll: '+' with: ' '. 
	self redirectTo: ((WikiPage newOnStyle: self style) parent: self observee; title: pageTitle) view: #add! !

!WikiApp methodsFor: 'printing' stamp: 'np 8/17/2008 20:21'!
viewContents
	| e pages |
	self title: 'Contents of the website'.
	pages := self observee ordered.
	e := WebElement new.
	e addTextH1: self title; addBreak.
	e add: (WebGrid new width: self pageContentWidth;
		columnNames: #(nil 'title' 'version' 'modified' 'by' nil);
		columnAspects: #(nil title versionNumber modifiedTimestampText modifiedByText nil);
		columnLinkViews: #(nil main nil nil nil nil);
		columnFilters: #(nil true nil nil nil nil);
		column: 6 addBlock: [:page | self moveLinksForPage: page];
		collection: pages;
		setNumbering;
		rowsOnPage: 50;
		yourself).
	self pageFrameWith: e title: self title.
! !

!WikiApp methodsFor: 'printing' stamp: 'np 1/21/2008 10:42'!
viewMain
	self redirectTo: self observee defaultPage! !

!WikiApp methodsFor: 'printing' stamp: 'janko 7/31/2008 19:32'!
viewMoveDown
	| pageIndex |
	pageIndex := (self session lastRequest queryAt: 'nr') asInteger.
	self observee moveDownPage: (self observee ordered at: pageIndex).
	^self redirectToView: #contents! !

!WikiApp methodsFor: 'printing' stamp: 'janko 7/31/2008 19:32'!
viewMoveUp
	| pageIndex |
	pageIndex := (self session lastRequest queryAt: 'nr') asInteger.
	self observee moveUpPage: (self observee ordered at: pageIndex).
	^self redirectToView: #contents! !

!WikiApp methodsFor: 'accessing' stamp: 'np 1/21/2008 10:42'!
wiki
	^self observee! !

WebApplication subclass: #WikiPageApp
	instanceVariableNames: 'accessors contentType file filename'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scribo-Wiki'!

WikiPageApp subclass: #BlogCommentApp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scribo-Blog'!

!BlogCommentApp methodsFor: 'actions' stamp: 'np 4/5/2008 20:06'!
actionEdit
	self canBeUpdated ifFalse: [^self].
	self setAccessors.
	self observee newestVersion
		setModifiedBy: self user;
		setCurrentVersion.
	self redirectTo: self observee currentVersion view: #main! !

!BlogCommentApp methodsFor: 'printing-elements' stamp: 'np 3/28/2008 22:02'!
actionsLineElement
	| e |
	self session user isAdmin ifFalse: [^WebElement new].
	e := WebElement new. e table width: 1.
	e cell addLinkTo: self observee text: 'Edit' view: #edit; addSpace.
	e cell addLinkTo: self observee text: 'Remove' view: #remove; addSpace.
	e cell addLinkTo: self observee text: 'History' view: #history; addSpace.
	e newCell align: #right.
	e cell addLinkTo: self site admin text: 'Logout' view: #logout; addSpace.
	^e! !

!BlogCommentApp methodsFor: 'access rights' stamp: 'np 3/29/2008 06:00'!
canBeObsoleted
	self observee isObsolete ifTrue: [^false].
	self user isAdmin ifFalse: [^false].
	^true! !

!BlogCommentApp methodsFor: 'printing' stamp: 'np 4/5/2008 20:12'!
ensureRSSInHeader
	self addRSSLinkInHeaderFor: self observee blog 
		view: #RSSPosts 
		title: self observee blog title.
	self addRSSLinkInHeaderFor: self observee blog
		view: #RSSComments 
		title: self observee blog title, ' (Comments)'.! !

!BlogCommentApp methodsFor: 'printing' stamp: 'np 4/1/2008 21:53'!
pageFrameWith: anElement title: aString
	^self style blogPageFrameWith: anElement title: aString! !

!BlogCommentApp methodsFor: 'printing' stamp: 'np 1/24/2008 18:44'!
viewAdd
	"A comment does not have subdocument"
	self redirectToView: #main! !

!BlogCommentApp methodsFor: 'printing' stamp: 'np 4/5/2008 20:06'!
viewApprove
	self observee setApprovedBy: self session user.
	self observee updateUrl.
	self redirectTo: self observee post blog view: #commentsWaitingApproval.
			! !

!BlogCommentApp methodsFor: 'printing' stamp: 'np 5/11/2008 01:49'!
viewEdit
	| e |
	self canBeUpdated ifFalse: [^WebPage new addText: 'update not allowed!!'].
	self setLock "and if already locked:" ifFalse: [^self redirectToView: #wait].
	self ensureRSSInHeader.
	e := WebElement new.
	e table width: self pageContentWidth.
	e add: self lockElement. "just to refresh document lock periodically"
	e cell colspan: 2; addText: self observee title header: 3.
	e newRow.
	e cell addText: 'Name'; addBreak.
	e cell colspan: 2; addInputFieldAspect: #name for: self observee createdBy.
	e newRow.
	e cell addText: 'Email'; addBreak.
	e cell colspan: 2; addInputFieldAspect: #email for: self observee createdBy.
	e newRow.
	e cell addText: 'Website'; addBreak.
	e cell colspan: 2; addInputFieldAspect: #website for: self observee createdBy.
	e newRow.
	e cell addText: 'Body'; addBreak.
	e cell colspan: 2;
		add: (WebTextArea new name: 'contents: '; size: 50@10; 
			aspect: #body for: self observee).
	e newRow.
	e cell align: #center; colspan: 2;
		add: (WebButton new text: 'Save'; type: #submit).

	^self pageFrameWith: e title: self title.! !

!BlogCommentApp methodsFor: 'printing' stamp: 'np 8/17/2008 17:43'!
viewMain
	|e f|
	self ensureRSSInHeader.
	self canBeViewed ifFalse: [^WebPage new addText: 'access denied!!'].
	self observee isObsolete ifTrue: [^self redirectToView: #unObsolete].
	e := WebElement new.
	e add: self actionsLineElement.
	e addLinkTo: self observee post text: 'Comment on ', self observee post title header: 1.
	f := WebElement new class: #blogComment.
	f addText: self observee createdTimestampText; addBreak.
	self observee createdBy website isEmpty	ifTrue: [
		f addText: self observee createdByText, ' says:']
	ifFalse: [
		f addLinkTo: self observee createdBy website text: self observee createdByText, ' says:'].
	f addBreak; addText: self observee body.
	e add: f.
	self pageFrameWith: e title: self observee title.
	self add: self wakeupElement. "rich text editor prefech for faster load"! !

!BlogCommentApp methodsFor: 'printing' stamp: 'np 4/1/2008 21:50'!
viewRemove
	| e |
	e := WebElement new.
	e cell addText: 'Do you really want to remove this comment?'.
	e newRow.
	e cell addButtonText: 'Remove'.
	self pageFrameWith: e title: 'Remove comment'! !

WikiPageApp subclass: #BlogPostApp
	instanceVariableNames: 'newComment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scribo-Blog'!

!BlogPostApp methodsFor: 'actions' stamp: 'np 4/5/2008 20:06'!
actionAdd
	self observee parent addPost: self observee.
	self setAccessors.
	self observee setCreatedBy: self user.
	self site urlResolver changeToPreferedURL: self observee.
	self site index indexObject: self observee.
	self redirectToView: #main! !

!BlogPostApp methodsFor: 'actions' stamp: 'np 4/5/2008 20:07'!
actionEdit
	self canBeUpdated ifFalse: [^self].
	self setAccessors.
	self observee newestVersion
		setModifiedBy: self user;
		setCurrentVersion;
		updateUrl.
	self observee currentVersion subdocuments do: [:each |
		each parent: self observee currentVersion].
	self site index indexObject: self observee currentVersion.
	self redirectTo: self observee currentVersion view: #main! !

!BlogPostApp methodsFor: 'actions' stamp: 'np 4/4/2008 23:28'!
actionMain
	"this method is here because of a bug in WebSecurityManager with access rights..."! !

!BlogPostApp methodsFor: 'actions' stamp: 'np 4/5/2008 20:07'!
actionMainAddComment
	self user isGuest ifTrue: [
		self newCommentIsValid ifFalse: [^self redirectToView: #main]].
	self observee addComment: self newComment.
	self user isAdmin ifTrue: [self newComment setApprovedBy: self session user].
	self redirectTo: self observee! !

!BlogPostApp methodsFor: 'printing-elements' stamp: 'np 3/28/2008 22:01'!
actionsLineElement
	| e |
	e := WebElement new. e table width: 1.
	e cell addLinkTo: self observee text: 'Edit' view: #edit; addSpace.
	e cell addLinkTo: self observee text: 'Remove' view: #remove; addSpace.
	e cell addLinkTo: self observee text: 'History' view: #history; addSpace.
	e cell addLinkTo: self observee parent text: 'Posts' view: #posts; addSpace.
	e cell addLinkTo: self observee parent text: 'Comments' view: #comments; addSpace.
	e newCell align: #right.
	e cell addLinkTo: self site admin text: 'Logout' view: #logout; addSpace.
	^e! !

!BlogPostApp methodsFor: 'access rights' stamp: 'np 3/29/2008 06:00'!
canBeObsoleted
	self observee isObsolete ifTrue: [^false].
	self user isAdmin ifFalse: [^false].
	^true! !

!BlogPostApp methodsFor: 'access rights' stamp: 'np 3/22/2008 02:23'!
canBeViewed
	^(super canBeViewed & (self observee isPublished | self user isAdmin))
! !

!BlogPostApp methodsFor: 'printing-elements' stamp: 'np 8/17/2008 17:43'!
commentElementFor: aBlogComment
	|e|
	e := WebElement new class: #blogComment.
	e addLinkTo: aBlogComment text: aBlogComment createdTimestamp; addBreak.
	aBlogComment createdBy website isEmpty
	ifTrue: [
		e addText: aBlogComment createdByText, ' says:']
	ifFalse: [e addLinkTo: aBlogComment createdBy website text: aBlogComment createdByText, ' says:'].
	e addBreak.
	e add: (WebElement new class: #blogCommentContent; addText: aBlogComment body; yourself).
	e addBreak.
	^e! !

!BlogPostApp methodsFor: 'printing' stamp: 'np 4/5/2008 20:12'!
ensureRSSInHeader
	self addRSSLinkInHeaderFor: self observee blog 
		view: #RSSPosts 
		title: self observee blog title.
	self addRSSLinkInHeaderFor: self observee blog
		view: #RSSComments 
		title: self observee blog title, ' (Comments)'.! !

!BlogPostApp methodsFor: 'initialize-release' stamp: 'np 3/27/2008 02:01'!
initialize
	super initialize! !

!BlogPostApp methodsFor: 'printing-elements' stamp: 'np 5/14/2008 01:57'!
mainElement
	| e f |
	e := WebElement new class: #post.
	self canBeUpdated ifTrue: [e add: self actionsLineElement].
	e add: (self postHeaderElementFor: self observee).
	e addText: self observee htmlBody.
	f := WebElement new class: #comments.
	f addPng: #bulletCommentPng; addText: ' Comments:'; addBreak.
	self observee approvedComments do: [:each |
		f add: (self commentElementFor: each)].
	e addBreak; add: f.
	^e! !

!BlogPostApp methodsFor: 'accessing' stamp: 'np 1/26/2008 15:45'!
newComment
	^newComment! !

!BlogPostApp methodsFor: 'accessing' stamp: 'np 1/23/2008 15:25'!
newComment: aBlogComment
	newComment := aBlogComment! !

!BlogPostApp methodsFor: 'printing-elements' stamp: 'np 6/4/2008 20:14'!
newCommentElement
	| e author |
	self observee commentsClosed ifFalse: [
		^WebText text: 'Comments are closed.'].
	e := WebElement new class: #newComment.
	self user isGuest 
		ifFalse: [author := self session user]
		ifTrue: [author := WebUser new].
	e addTextH2: 'Leave a reply'.
	self inError 
		ifTrue: [e newRow. e newCell add: self errorReport]
		ifFalse: [self newComment: ((BlogComment newCreatedBy: author)
			parent: self observee)].
	e newRow.
	self user isGuest 
	ifFalse: [
		e newCell colspan: 3; add: (self smallText: newComment createdByText);
		addLinkTo: self observee blog site admin text: ' (logout)' view: #logout]
	ifTrue: [
		e newCell colspan: 3; addInputFieldAspect: #name for: newComment createdBy.
		e cell add: (self smallText: 'Name (required)'attributes: #bold).
		e newRow.
		e newCell colspan: 3; addInputFieldAspect: #email for: newComment createdBy.
		e cell add: (self smallText: 'Email (required)'attributes: #bold).
		e newRow.
		e newCell colspan: 3; addInputFieldAspect: #website for: newComment createdBy.
		e cell add: (self smallText: 'Website'attributes: #bold)].
	e newRow.
	e newCell colspan: 3;
		add: (WebTextArea new name: 'body'; size: 50@10; 
			aspect: #body for: self newComment).
	e newRow.
	e newCell colspan: 3;
		addButtonText: 'Submit' action: #addComment.
	^e! !

!BlogPostApp methodsFor: 'testing' stamp: 'np 3/27/2008 02:01'!
newCommentIsValid
	self newComment createdByText trimBlanks isEmpty 
		ifTrue: [self error: 'Name is required!!'].
	self newComment createdBy email trimBlanks isEmpty 
		ifTrue: [self error: 'Email is required!!'].
	self newComment createdBy email isValidEMailAddress 
		ifFalse: [self error: 'Invalid email address!!'].
	self newComment body trimBlanks isEmpty 
		ifTrue: [self error: 'Your comment is empty!!'].
	^(self error = nil)! !

!BlogPostApp methodsFor: 'printing-elements' stamp: 'np 4/1/2008 21:53'!
pageFrameWith: anElement title: aString
	^self style blogPageFrameWith: anElement title: aString! !

!BlogPostApp methodsFor: 'printing' stamp: 'np 5/11/2008 01:49'!
viewEdit
	| e menu richTextMode |
	self canBeUpdated ifFalse: [^WebPage new addText: 'update not allowed!!'].
	self setLock "and if already locked:" ifFalse: [^self redirectToView: #wait].
	self ensureRSSInHeader.
	(self view = #add) not & self isObserveeNewVersion not ifTrue: 
		[self makeObserveeNewVersion. self redirectTo: self observee view: #edit].
	self title: 'Edit post: ', self observee title.
	e := WebElement new.  e table width: self pageContentWidth.
	e add: self lockElement. "just to refresh document lock periodically"
	e cell valign: #bottom; addText: 'Title'; addBreak; 
		addInputFieldAspect: #title for: self observee size: 40. e newCell.
	e cell addText: 'Access allowed to (empty = all): '.
	self prepareAccessors.
	menu := (WebMenu aspect: #menuName collection: self allGroupsAndPersons 
		selected: self accessors) size: 4.
	e cell add: menu. e newRow.
	richTextMode := (self session lastRequest queryAt: 'mode') isNil.
	richTextMode 
		ifTrue: [e cell colspan: 2; addText: 'Contents'; addBreak; 
			addRichEditorAspect: #body for: self observee size: 80@30. e newRow]
		ifFalse: [e cell colspan: 2;  addText: 'Contents:'; addBreak; 
			addTextAreaAspect: #body for: self observee size: 80@30. e newRow].
	e cell addText: 'Categories'; addBreak.
	e cell add: (WebInputField new size: 50; aspect: #categories for: self observee).
	e cell addBreak.
	e cell addText: 'Tags'; addBreak.
	e cell add: (WebInputField new size: 50; aspect: #keywords for: self observee).
	e cell addBreak.
	e cell addCheckboxAspect: #published for: self observee; addText: 'Published'.
	e cell addBreak.
	e cell newRow; addButtonText: 'Save'. e cell addBreak; addNbSp; addBreak.
	e cell colspan: 2;  add: self imagesIFrame.
	self pageFrameWith: e title: self title! !

!BlogPostApp methodsFor: 'printing' stamp: 'np 8/17/2008 16:59'!
viewMain
	| e |
	self ensureRSSInHeader.
	self canBeViewed ifFalse: [^WebPage new addText: 'access denied!!'].
	self observee isObsolete ifTrue: [^self redirectToView: #unObsolete].
	e := WebElement new.
	e add: self mainElement.
	e addBreak.
	e add: self newCommentElement.
	self pageFrameWith: e title: self observee title.
	self add: self wakeupElement. "rich text editor prefech for faster load"! !

!BlogPostApp methodsFor: 'printing' stamp: 'np 4/1/2008 21:50'!
viewRemove
	| e |
	e := WebElement new.
	e cell addText: 'Do you really want to remove "', self observee title, '"?'.
	e newRow.
	e cell addButtonText: 'Remove'.
	self pageFrameWith: e title: 'Remove post'! !

!BlogPostApp methodsFor: 'accessing' stamp: 'np 4/23/2008 03:10'!
wiki
	^self observee blog ! !

WikiPageApp subclass: #SitePageApp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scribo-Sites'!

!SitePageApp methodsFor: 'printing-elements' stamp: 'np 8/19/2008 17:09'!
actionsLineElement
	| e |
	e := WebElement new. e table width: self pageContentWidth.
	e cell align: #right; addLinkTo: self observee text: 'Edit' view: #edit; addSpace.
	e cell addLinkTo: self observee text: 'Remove' view: #remove; addSpace.
	e cell addLinkTo: self observee text: 'History' view: #history; addSpace.
	e cell addLinkTo: self observee parent text: 'Pages' view: #contents; addSpace.
	e cell addLinkTo: self site admin text: 'Logout' view: #logout; addSpace.
	^e! !

!SitePageApp methodsFor: 'access rights' stamp: 'np 5/14/2008 02:07'!
canBeEdited
	^self user isAdmin! !

!SitePageApp methodsFor: 'printing-elements' stamp: 'np 3/20/2008 03:59'!
leftElement
	| e page |
	e := WebElement newId: #sitePageLeft. 
	page := self observee parent pageTitled: 'firstPageLeft'. page isNil ifTrue: [^e].
	e addText: page htmlBody withHeadingAnchors.
	^e! !

!SitePageApp methodsFor: 'printing-elements' stamp: 'np 3/15/2008 17:11'!
mainElement
	| e |
	e := WebElement new. 
	e addText: self observee htmlBody withHeadingAnchors.
	^e! !

!SitePageApp methodsFor: 'printing' stamp: 'np 4/1/2008 21:53'!
pageFrameWith: anElement title: aString
	^self style sitePageFrameWith: anElement title: aString! !

!SitePageApp methodsFor: 'printing-elements' stamp: 'np 1/21/2008 10:57'!
pageFrameWith: aWebElement title: aTitleString tabs: aTabsElement
	| element |
	self clear;  title: aTitleString.
	element := (WebElement newId: #container)
		add: self headerElement; 
		add: ((WebElement newId: #siteTabs) 
			add: aTabsElement; 
			yourself); 
		addBreak; 
		add: ((WebElement newId: #sitePage) 
			add: aWebElement; 
			yourself); 
		yourself.
	^self app add: element; yourself! !

!SitePageApp methodsFor: 'printing-elements' stamp: 'np 1/21/2008 15:13'!
pageTitle
	self observee isDefaultPage ifTrue: [^self observee title].
	^self observee content defaultPage title, ': ', self observee title! !

!SitePageApp methodsFor: 'printing-elements' stamp: 'np 8/17/2008 17:39'!
rightElement
	| e page |
	e := WebElement newId: #sitePageRight. 
	page := self observee parent pageTitled: 'firstPageRight'. page isNil ifTrue: [^e].
	e addText: page htmlBody.
	^e! !

!SitePageApp methodsFor: 'printing-elements' stamp: 'np 1/21/2008 10:58'!
tabsElement
	^self style tabsElement! !

!SitePageApp methodsFor: 'printing' stamp: 'janko 7/18/2008 17:08'!
viewFirstPage
	| e |
	self title: self pageTitle.
	e := WebElement new.  e table width: self pageContentWidth.
	e cell colspan: 3; add: self tabsElement.
	e newRow. e cell addNbSp. e newRow.
	e cell id: #sitePageLeft; width: 0.25; valign: #top; add: self leftElement. 
	e newCell  valign: #top.
	self canBeEdited ifTrue: [e cell add: self actionsLineElement. e addBreak].
	e cell add: self mainElement; addBreak; add: self lastChangedElement.
	e newRow.
	self pageFrameWith: e title: self title.
	self add: self wakeupElement. "rich text editor prefech for faster load"! !

!SitePageApp methodsFor: 'printing' stamp: 'janko 7/18/2008 17:08'!
viewMain
	| e |
	self canBeViewed ifFalse: [^WebPage new addText: 'access denied!!'].
	self observee isObsolete ifTrue: [^self redirectToView: #unObsolete].
	self title: self pageTitle.
	(self isFirstPageDifferent and: [self observee isDefaultPage])
		ifTrue: [^self viewFirstPage].
	e := WebElement new.  e table width: self pageContentWidth.
	e cell add: self tabsElement. e newRow. 
	self canBeEdited ifTrue: [e cell add: self actionsLineElement. e addBreak].
	e cell add: self mainElement; addBreak; add: self lastChangedElement. e newRow.
	self pageFrameWith: e title: self title.
	self add: self wakeupElement. "rich text editor prefech for faster load"! !

!WikiPageApp methodsFor: 'accessing' stamp: 'np 1/21/2008 10:47'!
accessors
	"all allowed to access this page"
	accessors isNil ifTrue: [self accessors: OrderedCollection new].
	^accessors! !

!WikiPageApp methodsFor: 'accessing' stamp: 'np 1/21/2008 10:47'!
accessors: aCollection
	accessors := aCollection! !

!WikiPageApp methodsFor: 'actions' stamp: 'np 3/29/2008 05:24'!
actionAdd
	self observee parent addPage: self observee.
	self setAccessors.
	self observee setCreatedBy: self user.
	self site urlResolver changeToPreferedURL: self observee.
	self site index indexObject: self observee.
	self redirectToView: #main! !

!WikiPageApp methodsFor: 'actions' stamp: 'np 3/29/2008 05:42'!
actionEdit
	self canBeUpdated ifFalse: [^self].
	self setAccessors.
	self observee newestVersion
		setModifiedBy: self user;
		setCurrentVersion.
	self site index indexObject: self observee currentVersion.
	self redirectTo: self observee currentVersion view: #main! !

!WikiPageApp methodsFor: 'actions' stamp: 'np 1/29/2008 11:50'!
actionImages
	(self filename isNil or: [self filename isEmpty]) ifTrue: [^nil].
	self observee attachFilename: self filename content: self file.
	self redirectToView: #images! !

!WikiPageApp methodsFor: 'actions' stamp: 'np 5/14/2008 02:10'!
actionRemove
	self canBeObsoleted ifFalse: [^self]. 
	self observee setObsoleteBy: self user. "not really remove it!!"
	self site urlResolver removeObject: self observee.
	self site index removeObject: self observee.
	self redirectTo: self observee parent! !

!WikiPageApp methodsFor: 'actions' stamp: 'np 5/14/2008 02:10'!
actionUnObsolete
	self canBeUnObsoleted ifFalse: [^self]. 
	self observee unObsoleteBy: self user.
	self redirectToView: #main! !

!WikiPageApp methodsFor: 'actions' stamp: ' 19/3/08 18:13'!
actionWaitBack
	self redirectToView: #main! !

!WikiPageApp methodsFor: 'actions' stamp: ' 19/3/08 18:13'!
actionWaitEdit
	self redirectToView: #edit! !

!WikiPageApp methodsFor: 'printing-elements' stamp: 'np 8/17/2008 20:19'!
actionsLineElement
	| e |
	e := WebElement new. e table width: self pageContentWidth.
	e cell addLinkTo: self observee text: 'Edit' view: #edit; addSpace.
	self observee isDefaultPage ifFalse: [
		e cell addLinkTo: self observee text: 'Remove' view: #remove; addSpace].
	e cell addLinkTo: self wiki text: 'Home'; addSpace.
	e cell addLinkTo: self observee text: 'History' view: #history; addSpace.
	e cell addLinkTo: self observee parent text: 'Pages' view: #contents; addSpace.
	e newCell align: #right.
	self observee areAccessRightsSet ifTrue: 
		[e cell addText: '<span style={color:gray}>Access limited</span> '].
	e cell addLinkTo: self site admin text: 'Logout' view: #logout; addSpace.
	^e! !

!WikiPageApp methodsFor: 'printing' stamp: 'janko 3/16/2008 13:35'!
addKeywordsToPageHeader
	self observee keywords isEmpty ifTrue: [^nil].
	self addMetaKeywords: self observee keywords.! !

!WikiPageApp methodsFor: 'accessing' stamp: 'np 1/21/2008 10:47'!
aidaDontCache
	"don't cache images IFRAME in editing"
	^self view = #images! !

!WikiPageApp methodsFor: 'accessing' stamp: 'np 3/21/2008 04:47'!
allGroupsAndPersons
	| all |
	all := self site securityManager allGroups asOrderedCollection.
	all := all reject: [:group | 
		#('AllUsers' 'Registered Users' 'Users waiting activation') includes: group name].
	all := (SortedCollection withAll: all sortBlock: [:a :b  | a name < b name]) asOrderedCollection.
	all addAll: (SortedCollection withAll: (self site securityManager allUsers collect: [:each | each asPerson])
		sortBlock: [:a :b  | a menuName < b menuName]).
	^all! !

!WikiPageApp methodsFor: 'accessing' stamp: 'np 1/21/2008 10:47'!
attachContentType
	^contentType! !

!WikiPageApp methodsFor: 'accessing' stamp: 'np 1/21/2008 10:47'!
attachContentType: aString
	"content type of attachment"
	contentType := aString! !

!WikiPageApp methodsFor: 'access rights' stamp: 'np 1/21/2008 10:46'!
canBeAccessed
	^self observee isAccessAllowedFor: self user! !

!WikiPageApp methodsFor: 'access rights' stamp: 'np 5/14/2008 01:53'!
canBeObsoleted
	self observee isObsolete ifTrue: [^false].
	self observee isDefaultPage ifTrue: [^false].
	^self observee isDeleteAllowedFor: self user! !

!WikiPageApp methodsFor: 'access rights' stamp: 'np 5/14/2008 01:53'!
canBeUnObsoleted
	self observee isObsolete ifFalse: [^false].
	^self observee isDeleteAllowedFor: self user! !

!WikiPageApp methodsFor: 'access rights' stamp: 'np 1/21/2008 10:46'!
canBeUpdated
	^self observee isUpdateAllowedFor: self user! !

!WikiPageApp methodsFor: 'access rights' stamp: 'np 3/29/2008 06:06'!
canBeViewed
	^(self observee isAccessAllowedFor: self user) & 
		(self observee isObsolete not | self user isAdmin)! !

!WikiPageApp methodsFor: 'accessing' stamp: 'np 1/21/2008 10:47'!
file
	^file! !

!WikiPageApp methodsFor: 'accessing' stamp: 'np 1/21/2008 10:47'!
file: aByteArray
	"contents of file to attach"
	file := aByteArray! !

!WikiPageApp methodsFor: 'accessing' stamp: 'np 1/21/2008 10:47'!
filename
	^filename! !

!WikiPageApp methodsFor: 'accessing' stamp: 'np 1/21/2008 10:47'!
filename: aString
	"original name of attached file"
	filename := aString! !

!WikiPageApp methodsFor: 'printing-elements' stamp: 'np 5/7/2008 17:41'!
historyElement
	| e versions |
	versions := self observee allVersions reverse.
	e := WebElement new.
	e addTextH1: 'History of ', self observee title. e addBreak.
	e add: (WebGrid new width: self pageContentWidth;
		columnNames: #('version' 'created' 'by');
		columnAspects: #(versionNumber modifiedTimestampText modifiedByText);
		columnLinkViews: #(main nil nil nil);
		collection: versions;
		rowsOnPage: 50;
		yourself).
	^e! !

!WikiPageApp methodsFor: 'printing-elements' stamp: 'mu 6/24/2008 21:13'!
imagesElement
	| e images |
	e := WebElement new. e table cellPadding: 0; cellSpacing: 1.
	images := self observee imageAttachments.
	images do: [:image || inx link |
		inx := images indexOf: image.
		e cell align: #center; style: 'text-align: center'; valign: #bottom; 
			addImage: image encodedUrl size: 80@60.
		link := WebLink new linkTo: self observee.   "delete icon"
		link add: (WebImage gif: #buttonCloseGif). 
		link view: #imgsDelete; parameter: 'index' value: inx printString.
		e cell addBreak; add: link. e newCell].
	e newRow.
	e cell colspan: 10; add: self uploadElement.
	^e! !

!WikiPageApp methodsFor: 'printing-elements' stamp: 'np 1/21/2008 10:50'!
imagesIFrame
	| link iframe |
	iframe := WebIFrame new.
	iframe size: 750@130; frameBorder: 1; scrolling: #no.
	link := WebLink text: '' linkTo: self observee view: #images.
		iframe src: (link composeURLOn: self session).
	^iframe! !

!WikiPageApp methodsFor: 'access rights' stamp: ' 19/3/08 18:13'!
isLockedBySomeoneElse
	"document is locked and with someone else, not current user "
	^self observee aidaIsLocked and: [(self observee aidaIsLockedOn: self session) not]! !

!WikiPageApp methodsFor: 'versions' stamp: 'np 1/21/2008 10:50'!
isObserveeNewVersion
	^self observee isCurrentVersion not! !

!WikiPageApp methodsFor: 'printing-elements' stamp: ' 19/3/08 18:13'!
lockElement
	"add to edit views to regrant document lock peridoically, until in edit form"
	| e r |
	e := WebElement new.
	r := self lockRegrantElement.
	r updateEverySeconds: 2.
	e add: r.
	^e! !

!WikiPageApp methodsFor: 'printing-elements' stamp: ' 19/3/08 18:13'!
lockRegrantElement
	"this one is called every few seconds just to regrant a lock of that document.
	Use it in editing forms"
	| e |
	e := WebElement new.
	self regrantLock.
	^e! !

!WikiPageApp methodsFor: 'printing-elements' stamp: ' 19/3/08 18:13'!
lockWaitElement
	"notify waiting for document lock to be released with other user"
	| e locked |
	e := WebElement new.
	locked := self setLock.
	locked ifFalse: 
		[e addText: 'Please wait, page is currently locked by user: ', 
			self observee lockedBy nameSurname.
		e addBreak; addBreak; addButtonText: 'Back to the page' action: #back].
	locked ifTrue: 
		[e addText: 'Page is now released and ready to edit'.
		e addBreak; addBreak; addButtonText: 'Edit the page' action: #edit].
	^e! !

!WikiPageApp methodsFor: 'printing-elements' stamp: 'np 5/3/2008 20:25'!
mainElement
	| e |
	e := WebElement new.
	self canBeAccessed 
		ifTrue: [e addText: self observee htmlBody withHeadingAnchors]
		ifFalse: [e addText: '<b style={color:red}>Access not allowed!!</b>'].
	^e! !

!WikiPageApp methodsFor: 'versions' stamp: 'np 1/21/2008 10:50'!
makeObserveeNewVersion
	^self observee:  self observee asNewVersion! !

!WikiPageApp methodsFor: 'printing' stamp: 'np 4/1/2008 21:48'!
pageFrameWith: anElement title: aString
	^self style wikiPageFrameWith: anElement title: aString ! !

!WikiPageApp methodsFor: 'printing-elements' stamp: 'np 1/21/2008 10:50'!
prepareAccessors
	self accessors: self observee allAccessors! !

!WikiPageApp methodsFor: 'access rights' stamp: ' 19/3/08 18:13'!
regrantLock
	"just extent my temporary lock"
	^self setLock! !

!WikiPageApp methodsFor: 'actions' stamp: 'np 1/21/2008 10:48'!
setAccessors
	| old new |
	old := self observee newestVersion allAccessors.
	new := self accessors. new isEmpty ifTrue: [^self observee newestVersion allowAccessToAll]. 
	new do: [:each | (old includes: each) ifFalse: [self observee newestVersion allowAccessTo: each] ].
	old do: [:each | (new includes: each) ifFalse: [self observee newestVersion disallowAccessTo: each] ].! !

!WikiPageApp methodsFor: 'access rights' stamp: ' 19/3/08 18:13'!
setLock
	"try to grant lock to that document. It will return false if already locked by some other.
	Lock will be temporary and must be regranted every observee lockTimeout seconds"
	^self observee aidaLockTemporaryOn: self session! !

!WikiPageApp methodsFor: 'printing-elements' stamp: 'np 5/4/2008 04:46'!
titleElement
	| e p |
	e := WebElement new. 
	p := WebElement newId: #documentTitleScreen.  "screen only"
	p addTextH1: self observee title.
	e add: p.
	^e! !

!WikiPageApp methodsFor: 'printing-elements' stamp: 'np 1/29/2008 11:38'!
uploadElement
	| e text popup |
	e := WebElement new. 
	popup := WebElement newClass: #popup. popup hide.
	text := WebLink text: 'Attach image', '.'  linkTo: 'javascript:nic()' .
	text onClickToggle: popup.
	popup
		addText: 'Image: ';
		add: (WebFileInputField aspect: #file filenameAspect: #filename 
			contentTypeAspect: #attachContentType forObject: self);
		addButtonText: 'Upload'.
	e addGif: #arrowOrangeRightGif; addSpace; add: text.
	e add: popup.
	^e! !

!WikiPageApp methodsFor: 'printing' stamp: 'np 1/21/2008 10:48'!
viewAdd
	self viewEdit! !

!WikiPageApp methodsFor: 'printing' stamp: 'np 1/21/2008 10:48'!
viewConvert
	"temporary!!"
	self observee convertFromFullToLinksOnlyWikiFormat.
	self redirectToView: #main! !

!WikiPageApp methodsFor: 'printing' stamp: 'np 5/11/2008 01:45'!
viewEdit
	| e menu richTextMode |
	self canBeUpdated ifFalse: [^WebPage new addText: 'update not allowed!!'].
	self setLock "and if already locked:" ifFalse: [^self redirectToView: #Wait].
	(self view = #add) not & self isObserveeNewVersion not ifTrue: 
		[self makeObserveeNewVersion. self redirectTo: self observee view: #edit].
	self title: self observee title.
	e := WebElement new.  e table width: self pageContentWidth.
	e add: self lockElement. "just to refresh document lock periodically"
	e cell valign: #bottom; addText: 'Title'; addBreak; 
		addInputFieldAspect: #title for: self observee size: 40. e newCell.
	e cell addText: 'Access allowed to (empty = all): '.
	self prepareAccessors.
	menu := (WebMenu aspect: #menuName collection: self allGroupsAndPersons 
		selected: self accessors) size: 4.
	e cell add: menu. e newRow.
	richTextMode := (self session lastRequest queryAt: 'mode') isNil.
	richTextMode 
		ifTrue: [e cell colspan: 2; addText: 'Contents'; addBreak; 
			addRichEditorAspect: #body for: self observee size: 80@30. e newRow]
		ifFalse: [e cell colspan: 2;  addText: 'Contents:'; addBreak; 
			addTextAreaAspect: #body for: self observee size: 80@30. e newRow].
	e cell addButtonText: 'Save'. e cell addBreak; addNbSp; addBreak.
	e cell colspan: 2;  add: self imagesIFrame.
	self pageFrameWith: e title: self title! !

!WikiPageApp methodsFor: 'printing' stamp: 'np 5/3/2008 20:26'!
viewHistory
	| e |
	self title: 'History of: ', self observee title.
	e := WebElement new.
	e add: self actionsLineElement.
	e add: self historyElement.
	self pageFrameWith: e title: self title! !

!WikiPageApp methodsFor: 'printing' stamp: 'np 1/21/2008 10:49'!
viewImages
	"in iframe inside viwEdit"
	self add: self imagesElement.! !

!WikiPageApp methodsFor: 'printing' stamp: 'np 5/14/2008 01:59'!
viewImgsDelete
	| inx |
	self canBeUpdated ifFalse: [^self].
	(self session lastRequest includesQuery: 'index') 
		ifTrue: [inx := (self session lastRequest queryAt: 'index') asInteger]	
		ifFalse: [^self].
	self observee deleteImageIndex: inx.
	self redirectToView: #images! !

!WikiPageApp methodsFor: 'printing' stamp: 'janko 7/18/2008 17:07'!
viewMain
	| e |
	self canBeViewed ifFalse: [^WebPage new addText: 'access denied!!'].
	self observee isObsolete ifTrue: [^self redirectToView: #unObsolete].
	self title: self observee title.
	e := WebElement new.
	e add: self actionsLineElement.
	e add: self titleElement.
	e add: self mainElement; addBreak.
	self pageFrameWith: e title: self title.
	self add: self wakeupElement. "rich text editor prefech for faster load"! !

!WikiPageApp methodsFor: 'printing' stamp: 'np 5/14/2008 02:14'!
viewRemove
	| e |
	e := WebElement new.
	self canBeObsoleted ifFalse: [^WebPage new addText: 'You can''t remove the first page!!'].
	e cell addText: 'Do you really want to remove "', self observee title, '"?'.
	e newRow.
	e cell addButtonText: 'Remove'.
	self pageFrameWith: e title: 'Remove post'! !

!WikiPageApp methodsFor: 'printing' stamp: 'np 5/14/2008 02:14'!
viewUnObsolete
	| e |
	self canBeUnObsoleted ifFalse: [^WebPage new addText: 'You can''t recover the first page!!']. 
	e := WebElement new.
	e cell addText: 'This page has been removed.'.
	e newRow.
	e cell addButtonText: 'Recover'.
	self pageFrameWith: e title: 'Page removed'! !

!WikiPageApp methodsFor: 'printing' stamp: 'np 4/1/2008 21:49'!
viewWait
	"wait until lock of this document will be released by someone else"
	| e l |
	e := WebElement new.  
	l := self lockWaitElement. 
	l updateEverySeconds: 2.
	e add: l.
	self pageFrameWith: e title: self title! !

!WikiPageApp methodsFor: 'printing-elements' stamp: 'janko 7/31/2008 18:27'!
wakeupElement
	"this hidden element prefetches rich text editor so that opens faster when needed"
	^self canBeUpdated
		ifTrue: [WebRichEditorWakeup new]
		ifFalse: [WebElement new]! !

!WikiPageApp methodsFor: 'accessing' stamp: 'np 1/21/2008 10:48'!
wiki
	^self observee parent! !

!Person methodsFor: '*Scribo-blog' stamp: 'np 1/26/2008 15:32'!
website
	^self asWebUser notNil 
		ifTrue: [self asWebUser website]
		ifFalse: [super website].! !

!Person methodsFor: '*Scribo-blog' stamp: 'np 1/26/2008 15:30'!
website: aString 
	self asWebUser notNil 
		ifTrue: [self asWebUser website: aString]
		ifFalse: [super website: aString].! !

!WideString methodsFor: '*Scribo-Core' stamp: 'mu 4/9/2008 20:18'!
replaceSpecialCharacters
	"Do nothing"
	
	^self! !

!WebUser methodsFor: '*Scribo-Blog' stamp: 'np 3/12/2008 14:19'!
website
	^self otherValuesAt: #website ifAbsent: [^'']! !

!WebUser methodsFor: '*Scribo-Blog' stamp: 'np 1/26/2008 13:28'!
website: aWebsite
	self otherValuesAt: #website put: aWebsite! !

!Party methodsFor: '*Scribo-Blog' stamp: 'np 1/26/2008 15:31'!
website
	| website |
	website := self otherValuesAt: #website ifAbsent: ''.
	^website ! !

!Party methodsFor: '*Scribo-Blog' stamp: 'np 1/26/2008 15:32'!
website: aString
	self otherValuesAt: #website put: aString! !

WebComponent subclass: #BlogPostBatcher
	instanceVariableNames: 'page view parameters posts batchsize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scribo-Blog'!

!BlogPostBatcher methodsFor: 'accessing' stamp: 'np 2/4/2008 19:13'!
addParameter: aParameter value: aValue
	self parameters at: aParameter put: aValue! !

!BlogPostBatcher methodsFor: 'accessing' stamp: 'np 2/4/2008 19:41'!
batchsize
	batchsize isNil ifTrue: [batchsize := 2].
	^batchsize! !

!BlogPostBatcher methodsFor: 'accessing' stamp: 'np 2/4/2008 17:49'!
batchsize: anInteger
	batchsize := anInteger! !

!BlogPostBatcher methodsFor: 'printing' stamp: 'np 4/23/2008 03:11'!
build
	| selectedPosts e |
	e := WebElement new class: 'batcher'.
	selectedPosts := self posts 
		copyFrom: ((self page * self batchsize - (self batchsize - 1)) max: 1) 
		to: ((self page * self batchsize) min: self posts size).
	selectedPosts do: [:each | self add: (self app postElementFor: each)].
	e add: self nextElement.
	e add: self previousElement.
	self add: e.! !

!BlogPostBatcher methodsFor: 'private' stamp: 'np 2/4/2008 19:37'!
nextElement
	| e |
	e := WebLink new.
	self page > 1 ifTrue: [
		e linkTo: self app observee; 
			text: '< Next entries ';
			view: self view;
			parameter: 'page' value: ((self page - 1) asString).
			self parameters associationsDo: [:each |
				e parameter: each key value: each value]].
	^e! !

!BlogPostBatcher methodsFor: 'accessing' stamp: 'np 2/4/2008 18:05'!
page
	page isNil ifTrue: [page := 1].
	^page! !

!BlogPostBatcher methodsFor: 'accessing' stamp: 'np 2/4/2008 17:33'!
page: anInteger
	page := anInteger! !

!BlogPostBatcher methodsFor: 'accessing' stamp: 'np 2/4/2008 18:15'!
parameters
	parameters isNil ifTrue: [parameters := Dictionary new].
	^parameters! !

!BlogPostBatcher methodsFor: 'accessing' stamp: 'np 2/4/2008 18:16'!
posts
	posts isNil ifTrue: [posts := OrderedCollection new].
	^posts! !

!BlogPostBatcher methodsFor: 'accessing' stamp: 'np 2/4/2008 17:37'!
posts: aCollection
	posts := aCollection! !

!BlogPostBatcher methodsFor: 'private' stamp: 'np 2/4/2008 19:42'!
previousElement
	| e l |
	e := WebElement new.
	l := WebLink new.
	(self page * self batchsize < self posts size) ifTrue: [
		self page > 1 ifTrue: [e addText: ' | '].
		l linkTo: self app observee;
			text: ' Previous entries > ';
			view: self view;
			parameter: 'page' value: ((self page + 1) asString).
			self parameters associationsDo: [:each |
				l parameter: each key value: each value]. 
		e add: l].
	^e! !

!BlogPostBatcher methodsFor: 'accessing' stamp: 'np 2/4/2008 18:16'!
view
	view isNil ifTrue: [view := #main].
	^view! !

!BlogPostBatcher methodsFor: 'accessing' stamp: 'np 2/4/2008 17:34'!
view: aSymbol
	view := aSymbol! !

WebComponent subclass: #DailyTextComponent
	instanceVariableNames: 'currentDate dailyText'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scribo-Components'!

!DailyTextComponent class methodsFor: 'instance creation' stamp: 'np 1/20/2008 16:00'!
newOn: aDailyText
	^super new 
		dailyText: aDailyText;
		method: #ajaxUpdate:;
		initialize! !

!DailyTextComponent methodsFor: 'printing' stamp: 'np 1/20/2008 15:58'!
ajaxUpdate: aString
	aString = 'next' ifTrue: [self currentDate: self currentDate + 1].
	aString = 'prev' ifTrue: [self currentDate: self currentDate - 1].
	self build! !

!DailyTextComponent methodsFor: 'accessing' stamp: 'np 1/20/2008 15:57'!
author
	| author |
	author := self canBeEdited
		ifTrue: [self dailyText authorOnDate: self currentDate] "always on currentDate"
		ifFalse: [self dailyText todayAuthor]. "author of last entered text, not nessesary on currentDate"
	author isNil ifTrue: [author := self dailyText lastAuthor].
	^author! !

!DailyTextComponent methodsFor: 'accessing' stamp: 'np 1/20/2008 15:58'!
author: aDailyTextAuthor
	^self dailyText author: aDailyTextAuthor onDate: self currentDate! !

!DailyTextComponent methodsFor: 'accessing' stamp: 'np 1/20/2008 15:58'!
authorImage
	"url of author image"
	^self author notNil ifTrue: [self author image] ifFalse: [''].! !

!DailyTextComponent methodsFor: 'accessing' stamp: 'np 1/20/2008 15:58'!
authorName
	^self author notNil ifTrue: [self author name] ifFalse: [''].! !

!DailyTextComponent methodsFor: 'printing-elements' stamp: 'np 1/20/2008 15:59'!
bodyElement
	| e |
	e := WebElement new.
	self canBeEdited
		ifTrue:  [e add: ((WebInPlaceEditableText aspect: #text for: self size: 20@30)
			triggerElement: ((WebImage png: #buttonCommentPng) title: 'Vnesi/uredi besedilo');
			wikiFormated) ]
		ifFalse: [e addText: self text asWikiHtml].
	^e! !

!DailyTextComponent methodsFor: 'printing' stamp: 'np 1/20/2008 15:59'!
build
	self initElements; initTable.
	self setDiv.
	self table width: 1. "100%"
	self cell style: 'text-align: center'; add: self dateElement. self newRow.
	self cell style: 'text-align: center'; align: #center; add: self imageElement. self newRow.
	self cell add: self bodyElement.
	self form registerFormElementsIn: self.! !

!DailyTextComponent methodsFor: 'access-rights' stamp: 'np 1/20/2008 15:57'!
canBeEdited
	^self app user isAdmin! !

!DailyTextComponent methodsFor: 'accessing' stamp: 'np 1/20/2008 15:58'!
currentDate
	currentDate isNil ifTrue: [^Date today].
	^currentDate! !

!DailyTextComponent methodsFor: 'accessing' stamp: 'np 1/20/2008 15:58'!
currentDate: aDateOrNil
	"put to nil to go back to today's date"
	currentDate := aDateOrNil! !

!DailyTextComponent methodsFor: 'accessing' stamp: 'np 1/20/2008 15:58'!
dailyText
	"here texts by date are stored (kind of observee) "
	^dailyText! !

!DailyTextComponent methodsFor: 'private' stamp: 'np 1/20/2008 16:00'!
dailyText: aDailyText
	dailyText := aDailyText! !

!DailyTextComponent methodsFor: 'printing-elements' stamp: 'np 1/20/2008 15:59'!
dateElement
	| e text |
	e := WebElement new.
	self canBeEdited ifTrue: 
		[(e addLinkTo: 'javascript:nic()'  gif:  #arrowPreviousBigGif title: '') 
			onClickUpdate: self with: 'prev' ].
	text := (SpDate nameOfSloDay: self currentDate weekdayIndex), ', ', 
		self currentDate shorterPrintSloString.
	e addText: text.
	self canBeEdited ifTrue: 
		[(e addLinkTo: 'javascript:nic()'  gif:  #arrowNextBigGif title: '') onClickUpdate: self with: 'next' ].
	^e! !

!DailyTextComponent methodsFor: 'printing-elements' stamp: 'np 1/20/2008 15:59'!
imageElement
	| e menu |
	e := WebElement new.
	self authorImage notEmpty ifTrue: [e addImage: self authorImage]. "url"
	e addBreak.
	self canBeEdited
		ifTrue: [e addText: 'Avtor: '.
			menu := WebMenu aspect: #name collection: self dailyText authors 
				selectedToAspect: #author of: self.
			menu onChangePostAndUpdate: self.
			e add: menu]
		ifFalse: [	e addText: self authorName; addBreak].
	^e! !

!DailyTextComponent methodsFor: 'initialize-release' stamp: 'np 1/20/2008 15:57'!
initialize
	self build! !

!DailyTextComponent methodsFor: 'accessing' stamp: 'np 1/20/2008 15:58'!
text
	| text |
	text := self canBeEdited
		ifTrue: [self dailyText textOnDate: self currentDate] "always on currentDate"
		ifFalse: [self dailyText todayText]. "last entered text, not nessesary on currentDate"
	^text notNil ifTrue: [text] ifFalse: [''].! !

!DailyTextComponent methodsFor: 'accessing' stamp: 'np 1/20/2008 15:58'!
text: aString
	^self dailyText text: aString onDate: self currentDate! !

!WebSecurityManager methodsFor: '*Scribo' stamp: 'np 8/21/2008 18:46'!
initDefaultAccessRights
	"to allow login, registering new user and access to Scribo plugins"
	| views updates |
	views := #(login logout forgoten registration passwordSent waitingConfirmation activation 
		wakeupScriptaculous wakeupRichEditor) 
			collect: [:each | WebAdminApp viewRightSymbolFor: each].

	self setAccessRights: views for: self allUsersGroup on: WebAdminApp name.
	updates := #(login registration passwordSent) 
		collect: [:each | WebAdminApp updateRightSymbolFor: each].
	self setAccessRights: updates for: self allUsersGroup on: WebAdminApp name.
	
	
	"Scribo plugins"
	views := #(main contents) collect: [:each | WikiApp viewRightSymbolFor: each].
	self setAccessRights: views for: self allUsersGroup on: WikiApp name.
	self setAccessRights: views for: self allUsersGroup on: SiteContentApp name.
	views := #(main archive category posts rSSComments rSSPosts) collect: [:each |
		BlogApp viewRightSymbolFor: each].
	self setAccessRights: views for: self allUsersGroup on: BlogApp name.
	views := #(main) collect: [:each | WikiPageApp viewRightSymbolFor: each].
	self setAccessRights: views for: self allUsersGroup on: WikiPageApp name.
	self setAccessRights: views for: self allUsersGroup on: SitePageApp name.self setAccessRights: views for: self allUsersGroup on: BlogPostApp name.
	self setAccessRights: views for: self allUsersGroup on: BlogCommentApp name.
	

"WebSecurityManager allInstances do: [:each | each initDefaultAccessRights]"
! !
